/* eds-backend.c generated by valac 0.56.18, the Vala compiler
 * generated from eds-backend.vala, do not modify */

/*
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 *       Marco Barisione <marco.barisione@collabora.co.uk>
 *       Raul Gutierrez Segales <raul.gutierrez.segales@collabora.co.uk>
 */

#include <gio/gio.h>
#include <libedataserver/libedataserver.h>
#include "eds.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "folks/folks.h"
#include "folks/folks-eds.h"
#include "folks-internal.h"
#include <glib/gstdio.h>

#define FOLKS_BACKENDS_EDS_BACKEND__use_address_books "FOLKS_BACKEND_EDS_USE_ADDRESS_BOOKS"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_BACKENDS_EDS_BACKEND_0_PROPERTY,
	FOLKS_BACKENDS_EDS_BACKEND_NAME_PROPERTY,
	FOLKS_BACKENDS_EDS_BACKEND_PERSONA_STORES_PROPERTY,
	FOLKS_BACKENDS_EDS_BACKEND_IS_PREPARED_PROPERTY,
	FOLKS_BACKENDS_EDS_BACKEND_IS_QUIESCENT_PROPERTY,
	FOLKS_BACKENDS_EDS_BACKEND_NUM_PROPERTIES
};
static GParamSpec* folks_backends_eds_backend_properties[FOLKS_BACKENDS_EDS_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _folks_internal_profile_block_free0(var) ((var == NULL) ? NULL : (var = (folks_internal_profile_block_free (var), NULL)))
typedef struct _FolksBackendsEdsBackendPrepareData FolksBackendsEdsBackendPrepareData;
typedef struct _FolksBackendsEdsBackendUnprepareData FolksBackendsEdsBackendUnprepareData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FolksBackendsEdsBackendPrivate {
	gboolean _is_prepared;
	gboolean _prepare_pending;
	gboolean _is_quiescent;
	GeeHashMap* _persona_stores;
	GeeMap* _persona_stores_ro;
	ESourceRegistry* _ab_sources;
	GeeSet* _storeids;
};

struct _FolksBackendsEdsBackendPrepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsEdsBackend* self;
	FolksInternalProfileBlock* profiling;
	FolksInternalProfileBlock* _tmp0_;
	gboolean _tmp1_;
	ESourceRegistry* _tmp2_;
	ESourceRegistry* _tmp3_;
	ESourceRegistry* _tmp4_;
	ESourceRegistry* _tmp5_;
	ESourceRegistry* _tmp6_;
	GError* _inner_error1_;
	FolksInternalProfileBlock* _tmp7_;
	GError* _inner_error0_;
};

struct _FolksBackendsEdsBackendUnprepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsEdsBackend* self;
	gboolean _tmp0_;
	GeeMapIterator* iter;
	GeeHashMap* _tmp1_;
	GeeMapIterator* _tmp2_;
	GeeMapIterator* _tmp3_;
	GeeMapIterator* _tmp4_;
	gpointer _tmp5_;
	FolksPersonaStore* _tmp6_;
	GeeMapIterator* _tmp7_;
	ESourceRegistry* _tmp8_;
	guint _tmp9_;
	ESourceRegistry* _tmp10_;
	guint _tmp11_;
	GError* _inner_error0_;
};

static gint FolksBackendsEdsBackend_private_offset;
static gpointer folks_backends_eds_backend_parent_class = NULL;

static void folks_backends_eds_backend_real_disable_persona_store (FolksBackend* base,
                                                            FolksPersonaStore* store);
static void _folks_backends_eds_backend_remove_address_book (FolksBackendsEdsBackend* self,
                                                      FolksPersonaStore* store,
                                                      gboolean notify,
                                                      GeeMapIterator* iter);
static void folks_backends_eds_backend_real_enable_persona_store (FolksBackend* base,
                                                           FolksPersonaStore* store);
static void _folks_backends_eds_backend_add_persona_store (FolksBackendsEdsBackend* self,
                                                    FolksPersonaStore* store,
                                                    gboolean notify);
static void _folks_backends_eds_backend_store_removed_cb (FolksBackendsEdsBackend* self,
                                                   FolksPersonaStore* store);
static void __folks_backends_eds_backend_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                                gpointer self);
static void folks_backends_eds_backend_real_set_persona_stores (FolksBackend* base,
                                                         GeeSet* storeids);
static void _folks_backends_eds_backend_ab_source_list_changed_cb (FolksBackendsEdsBackend* self);
static void folks_backends_eds_backend_real_prepare_data_free (gpointer _data);
static void folks_backends_eds_backend_real_prepare (FolksBackend* base,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static gboolean folks_backends_eds_backend_real_prepare_co (FolksBackendsEdsBackendPrepareData* _data_);
static void _folks_backends_eds_backend_create_avatars_cache_dir (FolksBackendsEdsBackend* self);
static void folks_backends_eds_backend_prepare_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void __folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_added (ESourceRegistry* _sender,
                                                                                            ESource* source,
                                                                                            gpointer self);
static void __folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_enabled (ESourceRegistry* _sender,
                                                                                              ESource* source,
                                                                                              gpointer self);
static void folks_backends_eds_backend_real_unprepare_data_free (gpointer _data);
static void folks_backends_eds_backend_real_unprepare (FolksBackend* base,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static gboolean folks_backends_eds_backend_real_unprepare_co (FolksBackendsEdsBackendUnprepareData* _data_);
static gchar** _folks_backends_eds_backend_get_addressbooks_from_env (FolksBackendsEdsBackend* self,
                                                               gint* result_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _folks_backends_eds_backend_add_address_book (FolksBackendsEdsBackend* self,
                                                   ESource* s);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GObject * folks_backends_eds_backend_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void folks_backends_eds_backend_finalize (GObject * obj);
static GType folks_backends_eds_backend_get_type_once (void);
static void _vala_folks_backends_eds_backend_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
folks_backends_eds_backend_get_instance_private (FolksBackendsEdsBackend* self)
{
	return G_STRUCT_MEMBER_P (self, FolksBackendsEdsBackend_private_offset);
}

/**
   * {@inheritDoc}
   */
static void
folks_backends_eds_backend_real_disable_persona_store (FolksBackend* base,
                                                       FolksPersonaStore* store)
{
	FolksBackendsEdsBackend * self;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 68 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 68 "../backends/eds/eds-backend.vala"
	g_return_if_fail (store != NULL);
#line 70 "../backends/eds/eds-backend.vala"
	_tmp0_ = self->priv->_persona_stores;
#line 70 "../backends/eds/eds-backend.vala"
	_tmp1_ = folks_persona_store_get_id (store);
#line 70 "../backends/eds/eds-backend.vala"
	_tmp2_ = _tmp1_;
#line 70 "../backends/eds/eds-backend.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
#line 72 "../backends/eds/eds-backend.vala"
		_folks_backends_eds_backend_remove_address_book (self, store, TRUE, NULL);
#line 218 "eds-backend.c"
	}
}

/**
   * {@inheritDoc}
   */
static void
folks_backends_eds_backend_real_enable_persona_store (FolksBackend* base,
                                                      FolksPersonaStore* store)
{
	FolksBackendsEdsBackend * self;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 79 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 79 "../backends/eds/eds-backend.vala"
	g_return_if_fail (store != NULL);
#line 81 "../backends/eds/eds-backend.vala"
	_tmp0_ = self->priv->_persona_stores;
#line 81 "../backends/eds/eds-backend.vala"
	_tmp1_ = folks_persona_store_get_id (store);
#line 81 "../backends/eds/eds-backend.vala"
	_tmp2_ = _tmp1_;
#line 81 "../backends/eds/eds-backend.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_) == FALSE) {
#line 83 "../backends/eds/eds-backend.vala"
		_folks_backends_eds_backend_add_persona_store (self, store, TRUE);
#line 247 "eds-backend.c"
	}
}

static void
__folks_backends_eds_backend_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                           gpointer self)
{
#line 89 "../backends/eds/eds-backend.vala"
	_folks_backends_eds_backend_store_removed_cb ((FolksBackendsEdsBackend*) self, _sender);
#line 257 "eds-backend.c"
}

static void
_folks_backends_eds_backend_add_persona_store (FolksBackendsEdsBackend* self,
                                               FolksPersonaStore* store,
                                               gboolean notify)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 87 "../backends/eds/eds-backend.vala"
	g_return_if_fail (self != NULL);
#line 87 "../backends/eds/eds-backend.vala"
	g_return_if_fail (store != NULL);
#line 89 "../backends/eds/eds-backend.vala"
	g_signal_connect_object (store, "removed", (GCallback) __folks_backends_eds_backend_store_removed_cb_folks_persona_store_removed, self, 0);
#line 91 "../backends/eds/eds-backend.vala"
	_tmp0_ = self->priv->_persona_stores;
#line 91 "../backends/eds/eds-backend.vala"
	_tmp1_ = folks_persona_store_get_id (store);
#line 91 "../backends/eds/eds-backend.vala"
	_tmp2_ = _tmp1_;
#line 91 "../backends/eds/eds-backend.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp2_, store);
#line 93 "../backends/eds/eds-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) self, "persona-store-added", store);
#line 94 "../backends/eds/eds-backend.vala"
	if (notify) {
#line 96 "../backends/eds/eds-backend.vala"
		g_object_notify ((GObject*) self, "persona-stores");
#line 288 "eds-backend.c"
	}
}

/**
   * {@inheritDoc}
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 105 "../backends/eds/eds-backend.vala"
	return self ? g_object_ref (self) : NULL;
#line 300 "eds-backend.c"
}

static void
folks_backends_eds_backend_real_set_persona_stores (FolksBackend* base,
                                                    GeeSet* storeids)
{
	FolksBackendsEdsBackend * self;
	GeeSet* _tmp0_;
	gboolean stores_changed = FALSE;
	GeeMapIterator* iter = NULL;
	GeeHashMap* _tmp16_;
	GeeMapIterator* _tmp17_;
#line 103 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 105 "../backends/eds/eds-backend.vala"
	_tmp0_ = _g_object_ref0 (storeids);
#line 105 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_storeids);
#line 105 "../backends/eds/eds-backend.vala"
	self->priv->_storeids = _tmp0_;
#line 108 "../backends/eds/eds-backend.vala"
	if (storeids == NULL) {
#line 110 "../backends/eds/eds-backend.vala"
		_folks_backends_eds_backend_ab_source_list_changed_cb (self);
#line 111 "../backends/eds/eds-backend.vala"
		return;
#line 327 "eds-backend.c"
	}
#line 114 "../backends/eds/eds-backend.vala"
	stores_changed = FALSE;
#line 331 "eds-backend.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 116 "../backends/eds/eds-backend.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) storeids);
#line 116 "../backends/eds/eds-backend.vala"
		_id_it = _tmp1_;
#line 116 "../backends/eds/eds-backend.vala"
		while (TRUE) {
#line 341 "eds-backend.c"
			GeeIterator* _tmp2_;
			gchar* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeHashMap* _tmp5_;
			const gchar* _tmp6_;
#line 116 "../backends/eds/eds-backend.vala"
			_tmp2_ = _id_it;
#line 116 "../backends/eds/eds-backend.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 116 "../backends/eds/eds-backend.vala"
				break;
#line 354 "eds-backend.c"
			}
#line 116 "../backends/eds/eds-backend.vala"
			_tmp3_ = _id_it;
#line 116 "../backends/eds/eds-backend.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 116 "../backends/eds/eds-backend.vala"
			id = (gchar*) _tmp4_;
#line 118 "../backends/eds/eds-backend.vala"
			_tmp5_ = self->priv->_persona_stores;
#line 118 "../backends/eds/eds-backend.vala"
			_tmp6_ = id;
#line 118 "../backends/eds/eds-backend.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_) == FALSE) {
#line 368 "eds-backend.c"
				ESource* s = NULL;
				ESourceRegistry* _tmp7_;
				const gchar* _tmp8_;
				ESource* _tmp9_;
				ESource* _tmp10_;
				EdsfPersonaStore* store = NULL;
				ESourceRegistry* _tmp12_;
				ESource* _tmp13_;
				EdsfPersonaStore* _tmp14_;
				EdsfPersonaStore* _tmp15_;
#line 120 "../backends/eds/eds-backend.vala"
				_tmp7_ = self->priv->_ab_sources;
#line 120 "../backends/eds/eds-backend.vala"
				_tmp8_ = id;
#line 120 "../backends/eds/eds-backend.vala"
				_tmp9_ = e_source_registry_ref_source (_tmp7_, _tmp8_);
#line 120 "../backends/eds/eds-backend.vala"
				s = _tmp9_;
#line 122 "../backends/eds/eds-backend.vala"
				_tmp10_ = s;
#line 122 "../backends/eds/eds-backend.vala"
				if (_tmp10_ == NULL) {
#line 391 "eds-backend.c"
					const gchar* _tmp11_;
#line 124 "../backends/eds/eds-backend.vala"
					_tmp11_ = id;
#line 124 "../backends/eds/eds-backend.vala"
					g_warning ("eds-backend.vala:124: Unable to reference EDS source with ID %s", _tmp11_);
#line 125 "../backends/eds/eds-backend.vala"
					_g_object_unref0 (s);
#line 125 "../backends/eds/eds-backend.vala"
					_g_free0 (id);
#line 125 "../backends/eds/eds-backend.vala"
					continue;
#line 403 "eds-backend.c"
				}
#line 128 "../backends/eds/eds-backend.vala"
				_tmp12_ = self->priv->_ab_sources;
#line 128 "../backends/eds/eds-backend.vala"
				_tmp13_ = s;
#line 128 "../backends/eds/eds-backend.vala"
				_tmp14_ = edsf_persona_store_new_with_source_registry (_tmp12_, _tmp13_);
#line 128 "../backends/eds/eds-backend.vala"
				store = _tmp14_;
#line 130 "../backends/eds/eds-backend.vala"
				_tmp15_ = store;
#line 130 "../backends/eds/eds-backend.vala"
				_folks_backends_eds_backend_add_persona_store (self, (FolksPersonaStore*) _tmp15_, FALSE);
#line 132 "../backends/eds/eds-backend.vala"
				stores_changed = TRUE;
#line 118 "../backends/eds/eds-backend.vala"
				_g_object_unref0 (store);
#line 118 "../backends/eds/eds-backend.vala"
				_g_object_unref0 (s);
#line 423 "eds-backend.c"
			}
#line 116 "../backends/eds/eds-backend.vala"
			_g_free0 (id);
#line 427 "eds-backend.c"
		}
#line 116 "../backends/eds/eds-backend.vala"
		_g_object_unref0 (_id_it);
#line 431 "eds-backend.c"
	}
#line 136 "../backends/eds/eds-backend.vala"
	_tmp16_ = self->priv->_persona_stores;
#line 136 "../backends/eds/eds-backend.vala"
	_tmp17_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp16_);
#line 136 "../backends/eds/eds-backend.vala"
	iter = _tmp17_;
#line 138 "../backends/eds/eds-backend.vala"
	while (TRUE) {
#line 441 "eds-backend.c"
		GeeMapIterator* _tmp18_;
		FolksPersonaStore* store = NULL;
		GeeMapIterator* _tmp19_;
		gpointer _tmp20_;
		FolksPersonaStore* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 138 "../backends/eds/eds-backend.vala"
		_tmp18_ = iter;
#line 138 "../backends/eds/eds-backend.vala"
		if (!gee_map_iterator_next (_tmp18_)) {
#line 138 "../backends/eds/eds-backend.vala"
			break;
#line 455 "eds-backend.c"
		}
#line 140 "../backends/eds/eds-backend.vala"
		_tmp19_ = iter;
#line 140 "../backends/eds/eds-backend.vala"
		_tmp20_ = gee_map_iterator_get_value (_tmp19_);
#line 140 "../backends/eds/eds-backend.vala"
		store = (FolksPersonaStore*) _tmp20_;
#line 142 "../backends/eds/eds-backend.vala"
		_tmp21_ = store;
#line 142 "../backends/eds/eds-backend.vala"
		_tmp22_ = folks_persona_store_get_id (_tmp21_);
#line 142 "../backends/eds/eds-backend.vala"
		_tmp23_ = _tmp22_;
#line 142 "../backends/eds/eds-backend.vala"
		if (!gee_collection_contains ((GeeCollection*) storeids, _tmp23_)) {
#line 471 "eds-backend.c"
			FolksPersonaStore* _tmp24_;
			GeeMapIterator* _tmp25_;
#line 144 "../backends/eds/eds-backend.vala"
			_tmp24_ = store;
#line 144 "../backends/eds/eds-backend.vala"
			_tmp25_ = iter;
#line 144 "../backends/eds/eds-backend.vala"
			_folks_backends_eds_backend_remove_address_book (self, _tmp24_, FALSE, _tmp25_);
#line 145 "../backends/eds/eds-backend.vala"
			stores_changed = TRUE;
#line 482 "eds-backend.c"
		}
#line 138 "../backends/eds/eds-backend.vala"
		_g_object_unref0 (store);
#line 486 "eds-backend.c"
	}
#line 149 "../backends/eds/eds-backend.vala"
	if (stores_changed) {
#line 151 "../backends/eds/eds-backend.vala"
		g_object_notify ((GObject*) self, "persona-stores");
#line 492 "eds-backend.c"
	}
#line 103 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (iter);
#line 496 "eds-backend.c"
}

/**
   * {@inheritDoc}
   */
FolksBackendsEdsBackend*
folks_backends_eds_backend_construct (GType object_type)
{
	FolksBackendsEdsBackend * self = NULL;
#line 160 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) g_object_new (object_type, NULL);
#line 158 "../backends/eds/eds-backend.vala"
	return self;
#line 510 "eds-backend.c"
}

FolksBackendsEdsBackend*
folks_backends_eds_backend_new (void)
{
#line 158 "../backends/eds/eds-backend.vala"
	return folks_backends_eds_backend_construct (FOLKS_BACKENDS_EDS_TYPE_BACKEND);
#line 518 "eds-backend.c"
}

static void
folks_backends_eds_backend_real_prepare_data_free (gpointer _data)
{
	FolksBackendsEdsBackendPrepareData* _data_;
	_data_ = _data;
#line 40 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (_data_->self);
#line 40 "../backends/eds/eds-backend.vala"
	g_slice_free (FolksBackendsEdsBackendPrepareData, _data_);
#line 530 "eds-backend.c"
}

static void
folks_backends_eds_backend_real_prepare (FolksBackend* base,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	FolksBackendsEdsBackend * self;
	FolksBackendsEdsBackendPrepareData* _data_;
	FolksBackendsEdsBackend* _tmp0_;
#line 40 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 40 "../backends/eds/eds-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsEdsBackendPrepareData);
#line 40 "../backends/eds/eds-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 40 "../backends/eds/eds-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_eds_backend_real_prepare_data_free);
#line 40 "../backends/eds/eds-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 40 "../backends/eds/eds-backend.vala"
	_data_->self = _tmp0_;
#line 40 "../backends/eds/eds-backend.vala"
	folks_backends_eds_backend_real_prepare_co (_data_);
#line 555 "eds-backend.c"
}

static void
folks_backends_eds_backend_prepare_finish (FolksBackend* base,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	FolksBackendsEdsBackendPrepareData* _data_;
#line 40 "../backends/eds/eds-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 40 "../backends/eds/eds-backend.vala"
	if (NULL == _data_) {
#line 40 "../backends/eds/eds-backend.vala"
		return;
#line 570 "eds-backend.c"
	}
}

/**
   * {@inheritDoc}
   */
static void
folks_backends_eds_backend_prepare_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	FolksBackendsEdsBackendPrepareData* _data_;
#line 213 "../backends/eds/eds-backend.vala"
	_data_ = _user_data_;
#line 213 "../backends/eds/eds-backend.vala"
	_data_->_source_object_ = source_object;
#line 213 "../backends/eds/eds-backend.vala"
	_data_->_res_ = _res_;
#line 213 "../backends/eds/eds-backend.vala"
	folks_backends_eds_backend_real_prepare_co (_data_);
#line 591 "eds-backend.c"
}

static void
__folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_added (ESourceRegistry* _sender,
                                                                                       ESource* source,
                                                                                       gpointer self)
{
#line 216 "../backends/eds/eds-backend.vala"
	_folks_backends_eds_backend_ab_source_list_changed_cb ((FolksBackendsEdsBackend*) self);
#line 601 "eds-backend.c"
}

static void
__folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_enabled (ESourceRegistry* _sender,
                                                                                         ESource* source,
                                                                                         gpointer self)
{
#line 218 "../backends/eds/eds-backend.vala"
	_folks_backends_eds_backend_ab_source_list_changed_cb ((FolksBackendsEdsBackend*) self);
#line 611 "eds-backend.c"
}

static gboolean
folks_backends_eds_backend_real_prepare_co (FolksBackendsEdsBackendPrepareData* _data_)
{
#line 197 "../backends/eds/eds-backend.vala"
	switch (_data_->_state_) {
#line 197 "../backends/eds/eds-backend.vala"
		case 0:
#line 621 "eds-backend.c"
		goto _state_0;
#line 197 "../backends/eds/eds-backend.vala"
		case 1:
#line 625 "eds-backend.c"
		goto _state_1;
		default:
#line 197 "../backends/eds/eds-backend.vala"
		g_assert_not_reached ();
#line 630 "eds-backend.c"
	}
	_state_0:
#line 199 "../backends/eds/eds-backend.vala"
	_data_->_tmp0_ = folks_internal_profiling_start ("preparing Eds.Backend", NULL);
#line 199 "../backends/eds/eds-backend.vala"
	_data_->profiling = _data_->_tmp0_;
#line 201 "../backends/eds/eds-backend.vala"
	if (_data_->self->priv->_is_prepared) {
#line 201 "../backends/eds/eds-backend.vala"
		_data_->_tmp1_ = TRUE;
#line 641 "eds-backend.c"
	} else {
#line 201 "../backends/eds/eds-backend.vala"
		_data_->_tmp1_ = _data_->self->priv->_prepare_pending;
#line 645 "eds-backend.c"
	}
#line 201 "../backends/eds/eds-backend.vala"
	if (_data_->_tmp1_) {
#line 203 "../backends/eds/eds-backend.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 203 "../backends/eds/eds-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 203 "../backends/eds/eds-backend.vala"
		if (_data_->_state_ != 0) {
#line 203 "../backends/eds/eds-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 203 "../backends/eds/eds-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 659 "eds-backend.c"
			}
		}
#line 203 "../backends/eds/eds-backend.vala"
		g_object_unref (_data_->_async_result);
#line 203 "../backends/eds/eds-backend.vala"
		return FALSE;
#line 666 "eds-backend.c"
	}
	{
#line 208 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 209 "../backends/eds/eds-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 211 "../backends/eds/eds-backend.vala"
		_folks_backends_eds_backend_create_avatars_cache_dir (_data_->self);
#line 213 "../backends/eds/eds-backend.vala"
		_data_->_state_ = 1;
#line 213 "../backends/eds/eds-backend.vala"
		e_source_registry_new (NULL, folks_backends_eds_backend_prepare_ready, _data_);
#line 213 "../backends/eds/eds-backend.vala"
		return FALSE;
#line 681 "eds-backend.c"
		_state_1:
#line 213 "../backends/eds/eds-backend.vala"
		_data_->_tmp3_ = e_source_registry_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 213 "../backends/eds/eds-backend.vala"
		_data_->_tmp2_ = _data_->_tmp3_;
#line 213 "../backends/eds/eds-backend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 689 "eds-backend.c"
			goto __finally0;
		}
#line 213 "../backends/eds/eds-backend.vala"
		_data_->_tmp4_ = _data_->_tmp2_;
#line 213 "../backends/eds/eds-backend.vala"
		_data_->_tmp2_ = NULL;
#line 213 "../backends/eds/eds-backend.vala"
		_g_object_unref0 (_data_->self->priv->_ab_sources);
#line 213 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_ab_sources = _data_->_tmp4_;
#line 216 "../backends/eds/eds-backend.vala"
		_data_->_tmp5_ = _data_->self->priv->_ab_sources;
#line 216 "../backends/eds/eds-backend.vala"
		g_signal_connect_object (_data_->_tmp5_, "source-added", (GCallback) __folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_added, _data_->self, 0);
#line 218 "../backends/eds/eds-backend.vala"
		_data_->_tmp6_ = _data_->self->priv->_ab_sources;
#line 218 "../backends/eds/eds-backend.vala"
		g_signal_connect_object (_data_->_tmp6_, "source-enabled", (GCallback) __folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_enabled, _data_->self, 0);
#line 220 "../backends/eds/eds-backend.vala"
		_folks_backends_eds_backend_ab_source_list_changed_cb (_data_->self);
#line 222 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_is_prepared = TRUE;
#line 223 "../backends/eds/eds-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 225 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_is_quiescent = TRUE;
#line 226 "../backends/eds/eds-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 206 "../backends/eds/eds-backend.vala"
		_g_object_unref0 (_data_->_tmp2_);
#line 720 "eds-backend.c"
	}
	__finally0:
	{
#line 230 "../backends/eds/eds-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 231 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 728 "eds-backend.c"
	}
#line 206 "../backends/eds/eds-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 206 "../backends/eds/eds-backend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 206 "../backends/eds/eds-backend.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 206 "../backends/eds/eds-backend.vala"
		g_object_unref (_data_->_async_result);
#line 206 "../backends/eds/eds-backend.vala"
		return FALSE;
#line 740 "eds-backend.c"
	}
#line 234 "../backends/eds/eds-backend.vala"
	_data_->_tmp7_ = _data_->profiling;
#line 234 "../backends/eds/eds-backend.vala"
	_data_->profiling = NULL;
#line 234 "../backends/eds/eds-backend.vala"
	folks_internal_profiling_end (_data_->_tmp7_);
#line 197 "../backends/eds/eds-backend.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 197 "../backends/eds/eds-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 197 "../backends/eds/eds-backend.vala"
	if (_data_->_state_ != 0) {
#line 197 "../backends/eds/eds-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 197 "../backends/eds/eds-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 758 "eds-backend.c"
		}
	}
#line 197 "../backends/eds/eds-backend.vala"
	g_object_unref (_data_->_async_result);
#line 197 "../backends/eds/eds-backend.vala"
	return FALSE;
#line 765 "eds-backend.c"
}

static void
folks_backends_eds_backend_real_unprepare_data_free (gpointer _data)
{
	FolksBackendsEdsBackendUnprepareData* _data_;
	_data_ = _data;
#line 40 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (_data_->self);
#line 40 "../backends/eds/eds-backend.vala"
	g_slice_free (FolksBackendsEdsBackendUnprepareData, _data_);
#line 777 "eds-backend.c"
}

static void
folks_backends_eds_backend_real_unprepare (FolksBackend* base,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	FolksBackendsEdsBackend * self;
	FolksBackendsEdsBackendUnprepareData* _data_;
	FolksBackendsEdsBackend* _tmp0_;
#line 40 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 40 "../backends/eds/eds-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsEdsBackendUnprepareData);
#line 40 "../backends/eds/eds-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 40 "../backends/eds/eds-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_eds_backend_real_unprepare_data_free);
#line 40 "../backends/eds/eds-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 40 "../backends/eds/eds-backend.vala"
	_data_->self = _tmp0_;
#line 40 "../backends/eds/eds-backend.vala"
	folks_backends_eds_backend_real_unprepare_co (_data_);
#line 802 "eds-backend.c"
}

static void
folks_backends_eds_backend_unprepare_finish (FolksBackend* base,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	FolksBackendsEdsBackendUnprepareData* _data_;
#line 40 "../backends/eds/eds-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 40 "../backends/eds/eds-backend.vala"
	if (NULL == _data_) {
#line 40 "../backends/eds/eds-backend.vala"
		return;
#line 817 "eds-backend.c"
	}
}

/**
   * {@inheritDoc}
   */
static gboolean
folks_backends_eds_backend_real_unprepare_co (FolksBackendsEdsBackendUnprepareData* _data_)
{
#line 240 "../backends/eds/eds-backend.vala"
	switch (_data_->_state_) {
#line 240 "../backends/eds/eds-backend.vala"
		case 0:
#line 831 "eds-backend.c"
		goto _state_0;
		default:
#line 240 "../backends/eds/eds-backend.vala"
		g_assert_not_reached ();
#line 836 "eds-backend.c"
	}
	_state_0:
#line 242 "../backends/eds/eds-backend.vala"
	if (!_data_->self->priv->_is_prepared) {
#line 242 "../backends/eds/eds-backend.vala"
		_data_->_tmp0_ = TRUE;
#line 843 "eds-backend.c"
	} else {
#line 242 "../backends/eds/eds-backend.vala"
		_data_->_tmp0_ = _data_->self->priv->_prepare_pending;
#line 847 "eds-backend.c"
	}
#line 242 "../backends/eds/eds-backend.vala"
	if (_data_->_tmp0_) {
#line 244 "../backends/eds/eds-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 244 "../backends/eds/eds-backend.vala"
		if (_data_->_state_ != 0) {
#line 244 "../backends/eds/eds-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 244 "../backends/eds/eds-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 859 "eds-backend.c"
			}
		}
#line 244 "../backends/eds/eds-backend.vala"
		g_object_unref (_data_->_async_result);
#line 244 "../backends/eds/eds-backend.vala"
		return FALSE;
#line 866 "eds-backend.c"
	}
	{
#line 249 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 250 "../backends/eds/eds-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 252 "../backends/eds/eds-backend.vala"
		_data_->_tmp1_ = _data_->self->priv->_persona_stores;
#line 252 "../backends/eds/eds-backend.vala"
		_data_->_tmp2_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _data_->_tmp1_);
#line 252 "../backends/eds/eds-backend.vala"
		_data_->iter = _data_->_tmp2_;
#line 254 "../backends/eds/eds-backend.vala"
		while (TRUE) {
#line 254 "../backends/eds/eds-backend.vala"
			_data_->_tmp3_ = _data_->iter;
#line 254 "../backends/eds/eds-backend.vala"
			if (!gee_map_iterator_next (_data_->_tmp3_)) {
#line 254 "../backends/eds/eds-backend.vala"
				break;
#line 887 "eds-backend.c"
			}
#line 255 "../backends/eds/eds-backend.vala"
			_data_->_tmp4_ = _data_->iter;
#line 255 "../backends/eds/eds-backend.vala"
			_data_->_tmp5_ = gee_map_iterator_get_value (_data_->_tmp4_);
#line 255 "../backends/eds/eds-backend.vala"
			_data_->_tmp6_ = (FolksPersonaStore*) _data_->_tmp5_;
#line 255 "../backends/eds/eds-backend.vala"
			_data_->_tmp7_ = _data_->iter;
#line 255 "../backends/eds/eds-backend.vala"
			_folks_backends_eds_backend_remove_address_book (_data_->self, _data_->_tmp6_, TRUE, _data_->_tmp7_);
#line 255 "../backends/eds/eds-backend.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 901 "eds-backend.c"
		}
#line 257 "../backends/eds/eds-backend.vala"
		_data_->_tmp8_ = _data_->self->priv->_ab_sources;
#line 257 "../backends/eds/eds-backend.vala"
		g_signal_parse_name ("source-added", e_source_registry_get_type (), &_data_->_tmp9_, NULL, FALSE);
#line 257 "../backends/eds/eds-backend.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp9_, 0, NULL, (GCallback) __folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_added, _data_->self);
#line 258 "../backends/eds/eds-backend.vala"
		_data_->_tmp10_ = _data_->self->priv->_ab_sources;
#line 258 "../backends/eds/eds-backend.vala"
		g_signal_parse_name ("source-enabled", e_source_registry_get_type (), &_data_->_tmp11_, NULL, FALSE);
#line 258 "../backends/eds/eds-backend.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp11_, 0, NULL, (GCallback) __folks_backends_eds_backend_ab_source_list_changed_cb_e_source_registry_source_enabled, _data_->self);
#line 259 "../backends/eds/eds-backend.vala"
		_g_object_unref0 (_data_->self->priv->_ab_sources);
#line 259 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_ab_sources = NULL;
#line 261 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_is_quiescent = FALSE;
#line 262 "../backends/eds/eds-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 264 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_is_prepared = FALSE;
#line 265 "../backends/eds/eds-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 247 "../backends/eds/eds-backend.vala"
		_g_object_unref0 (_data_->iter);
#line 929 "eds-backend.c"
	}
	__finally0:
	{
#line 269 "../backends/eds/eds-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 270 "../backends/eds/eds-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 937 "eds-backend.c"
	}
#line 247 "../backends/eds/eds-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 247 "../backends/eds/eds-backend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 247 "../backends/eds/eds-backend.vala"
		g_object_unref (_data_->_async_result);
#line 247 "../backends/eds/eds-backend.vala"
		return FALSE;
#line 947 "eds-backend.c"
	}
#line 240 "../backends/eds/eds-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 240 "../backends/eds/eds-backend.vala"
	if (_data_->_state_ != 0) {
#line 240 "../backends/eds/eds-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 240 "../backends/eds/eds-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 957 "eds-backend.c"
		}
	}
#line 240 "../backends/eds/eds-backend.vala"
	g_object_unref (_data_->_async_result);
#line 240 "../backends/eds/eds-backend.vala"
	return FALSE;
#line 964 "eds-backend.c"
}

static void
_folks_backends_eds_backend_create_avatars_cache_dir (FolksBackendsEdsBackend* self)
{
	gchar* avatars_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 274 "../backends/eds/eds-backend.vala"
	g_return_if_fail (self != NULL);
#line 276 "../backends/eds/eds-backend.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 276 "../backends/eds/eds-backend.vala"
	_tmp1_ = g_build_filename (_tmp0_, "folks", "avatars", NULL);
#line 276 "../backends/eds/eds-backend.vala"
	avatars_dir = _tmp1_;
#line 278 "../backends/eds/eds-backend.vala"
	g_mkdir_with_parents (avatars_dir, 0700);
#line 274 "../backends/eds/eds-backend.vala"
	_g_free0 (avatars_dir);
#line 985 "eds-backend.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 304 "../backends/eds/eds-backend.vala"
	for (i = 0; i < stack_length; i++) {
#line 304 "../backends/eds/eds-backend.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 304 "../backends/eds/eds-backend.vala"
			return TRUE;
#line 1000 "eds-backend.c"
		}
	}
#line 304 "../backends/eds/eds-backend.vala"
	return FALSE;
#line 1005 "eds-backend.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 285 "../backends/eds/eds-backend.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1013 "eds-backend.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 285 "../backends/eds/eds-backend.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1021 "eds-backend.c"
}

static void
_folks_backends_eds_backend_ab_source_list_changed_cb (FolksBackendsEdsBackend* self)
{
	gchar** use_addressbooks = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint use_addressbooks_length1;
	gint _use_addressbooks_size_;
	GList* books = NULL;
	ESourceRegistry* _tmp2_;
	GList* _tmp3_;
	GeeLinkedList* added_sources = NULL;
	GeeLinkedList* _tmp4_;
	GList* _tmp5_;
#line 285 "../backends/eds/eds-backend.vala"
	g_return_if_fail (self != NULL);
#line 287 "../backends/eds/eds-backend.vala"
	_tmp1_ = _folks_backends_eds_backend_get_addressbooks_from_env (self, &_tmp0_);
#line 287 "../backends/eds/eds-backend.vala"
	use_addressbooks = _tmp1_;
#line 287 "../backends/eds/eds-backend.vala"
	use_addressbooks_length1 = _tmp0_;
#line 287 "../backends/eds/eds-backend.vala"
	_use_addressbooks_size_ = use_addressbooks_length1;
#line 288 "../backends/eds/eds-backend.vala"
	_tmp2_ = self->priv->_ab_sources;
#line 288 "../backends/eds/eds-backend.vala"
	_tmp3_ = e_source_registry_list_enabled (_tmp2_, E_SOURCE_EXTENSION_ADDRESS_BOOK);
#line 288 "../backends/eds/eds-backend.vala"
	books = _tmp3_;
#line 291 "../backends/eds/eds-backend.vala"
	g_debug ("eds-backend.vala:291: Address book source list changed.");
#line 296 "../backends/eds/eds-backend.vala"
	_tmp4_ = gee_linked_list_new (e_source_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 296 "../backends/eds/eds-backend.vala"
	added_sources = _tmp4_;
#line 298 "../backends/eds/eds-backend.vala"
	_tmp5_ = books;
#line 1062 "eds-backend.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 298 "../backends/eds/eds-backend.vala"
		s_collection = _tmp5_;
#line 298 "../backends/eds/eds-backend.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 1070 "eds-backend.c"
			ESource* _tmp6_;
			ESource* s = NULL;
#line 298 "../backends/eds/eds-backend.vala"
			_tmp6_ = _g_object_ref0 ((ESource*) s_it->data);
#line 298 "../backends/eds/eds-backend.vala"
			s = _tmp6_;
#line 1077 "eds-backend.c"
			{
				gchar* uid = NULL;
				ESource* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_ = FALSE;
				gchar** _tmp11_;
				gint _tmp11__length1;
				gboolean _tmp14_ = FALSE;
				GeeSet* _tmp15_;
				GeeHashMap* _tmp18_;
				const gchar* _tmp19_;
#line 302 "../backends/eds/eds-backend.vala"
				_tmp7_ = s;
#line 302 "../backends/eds/eds-backend.vala"
				_tmp8_ = e_source_get_uid (_tmp7_);
#line 302 "../backends/eds/eds-backend.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 302 "../backends/eds/eds-backend.vala"
				uid = _tmp9_;
#line 303 "../backends/eds/eds-backend.vala"
				_tmp11_ = use_addressbooks;
#line 303 "../backends/eds/eds-backend.vala"
				_tmp11__length1 = use_addressbooks_length1;
#line 303 "../backends/eds/eds-backend.vala"
				if (_tmp11__length1 > 0) {
#line 1104 "eds-backend.c"
					const gchar* _tmp12_;
					gchar** _tmp13_;
					gint _tmp13__length1;
#line 304 "../backends/eds/eds-backend.vala"
					_tmp12_ = uid;
#line 304 "../backends/eds/eds-backend.vala"
					_tmp13_ = use_addressbooks;
#line 304 "../backends/eds/eds-backend.vala"
					_tmp13__length1 = use_addressbooks_length1;
#line 304 "../backends/eds/eds-backend.vala"
					_tmp10_ = !_vala_string_array_contains (_tmp13_, _tmp13__length1, _tmp12_);
#line 1116 "eds-backend.c"
				} else {
#line 303 "../backends/eds/eds-backend.vala"
					_tmp10_ = FALSE;
#line 1120 "eds-backend.c"
				}
#line 303 "../backends/eds/eds-backend.vala"
				if (_tmp10_) {
#line 306 "../backends/eds/eds-backend.vala"
					_g_free0 (uid);
#line 306 "../backends/eds/eds-backend.vala"
					_g_object_unref0 (s);
#line 306 "../backends/eds/eds-backend.vala"
					continue;
#line 1130 "eds-backend.c"
				}
#line 309 "../backends/eds/eds-backend.vala"
				_tmp15_ = self->priv->_storeids;
#line 309 "../backends/eds/eds-backend.vala"
				if (_tmp15_ != NULL) {
#line 1136 "eds-backend.c"
					GeeSet* _tmp16_;
					const gchar* _tmp17_;
#line 310 "../backends/eds/eds-backend.vala"
					_tmp16_ = self->priv->_storeids;
#line 310 "../backends/eds/eds-backend.vala"
					_tmp17_ = uid;
#line 310 "../backends/eds/eds-backend.vala"
					_tmp14_ = !gee_collection_contains ((GeeCollection*) _tmp16_, _tmp17_);
#line 1145 "eds-backend.c"
				} else {
#line 309 "../backends/eds/eds-backend.vala"
					_tmp14_ = FALSE;
#line 1149 "eds-backend.c"
				}
#line 309 "../backends/eds/eds-backend.vala"
				if (_tmp14_) {
#line 312 "../backends/eds/eds-backend.vala"
					_g_free0 (uid);
#line 312 "../backends/eds/eds-backend.vala"
					_g_object_unref0 (s);
#line 312 "../backends/eds/eds-backend.vala"
					continue;
#line 1159 "eds-backend.c"
				}
#line 315 "../backends/eds/eds-backend.vala"
				_tmp18_ = self->priv->_persona_stores;
#line 315 "../backends/eds/eds-backend.vala"
				_tmp19_ = uid;
#line 315 "../backends/eds/eds-backend.vala"
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp18_, _tmp19_)) {
#line 1167 "eds-backend.c"
					GeeLinkedList* _tmp20_;
					ESource* _tmp21_;
#line 317 "../backends/eds/eds-backend.vala"
					_tmp20_ = added_sources;
#line 317 "../backends/eds/eds-backend.vala"
					_tmp21_ = s;
#line 317 "../backends/eds/eds-backend.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 1176 "eds-backend.c"
				}
#line 298 "../backends/eds/eds-backend.vala"
				_g_free0 (uid);
#line 298 "../backends/eds/eds-backend.vala"
				_g_object_unref0 (s);
#line 1182 "eds-backend.c"
			}
		}
	}
	{
		GeeLinkedList* _s_list = NULL;
		GeeLinkedList* _tmp22_;
		gint _s_size = 0;
		GeeLinkedList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _s_index = 0;
#line 323 "../backends/eds/eds-backend.vala"
		_tmp22_ = added_sources;
#line 323 "../backends/eds/eds-backend.vala"
		_s_list = _tmp22_;
#line 323 "../backends/eds/eds-backend.vala"
		_tmp23_ = _s_list;
#line 323 "../backends/eds/eds-backend.vala"
		_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 323 "../backends/eds/eds-backend.vala"
		_tmp25_ = _tmp24_;
#line 323 "../backends/eds/eds-backend.vala"
		_s_size = _tmp25_;
#line 323 "../backends/eds/eds-backend.vala"
		_s_index = -1;
#line 323 "../backends/eds/eds-backend.vala"
		while (TRUE) {
#line 1210 "eds-backend.c"
			gint _tmp26_;
			gint _tmp27_;
			ESource* s = NULL;
			GeeLinkedList* _tmp28_;
			gpointer _tmp29_;
			ESource* _tmp30_;
#line 323 "../backends/eds/eds-backend.vala"
			_s_index = _s_index + 1;
#line 323 "../backends/eds/eds-backend.vala"
			_tmp26_ = _s_index;
#line 323 "../backends/eds/eds-backend.vala"
			_tmp27_ = _s_size;
#line 323 "../backends/eds/eds-backend.vala"
			if (!(_tmp26_ < _tmp27_)) {
#line 323 "../backends/eds/eds-backend.vala"
				break;
#line 1227 "eds-backend.c"
			}
#line 323 "../backends/eds/eds-backend.vala"
			_tmp28_ = _s_list;
#line 323 "../backends/eds/eds-backend.vala"
			_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, _s_index);
#line 323 "../backends/eds/eds-backend.vala"
			s = (ESource*) _tmp29_;
#line 325 "../backends/eds/eds-backend.vala"
			_tmp30_ = s;
#line 325 "../backends/eds/eds-backend.vala"
			_folks_backends_eds_backend_add_address_book (self, _tmp30_);
#line 323 "../backends/eds/eds-backend.vala"
			_g_object_unref0 (s);
#line 1241 "eds-backend.c"
		}
	}
#line 285 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (added_sources);
#line 285 "../backends/eds/eds-backend.vala"
	(books == NULL) ? NULL : (books = (_g_list_free__g_object_unref0_ (books), NULL));
#line 285 "../backends/eds/eds-backend.vala"
	use_addressbooks = (_vala_array_free (use_addressbooks, use_addressbooks_length1, (GDestroyNotify) g_free), NULL);
#line 1250 "eds-backend.c"
}

/**
   * Add a new addressbook connected to a Persona Store.
   */
static void
_folks_backends_eds_backend_add_address_book (FolksBackendsEdsBackend* self,
                                              ESource* s)
{
	gchar* uid = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	EdsfPersonaStore* store = NULL;
	ESourceRegistry* _tmp5_;
	EdsfPersonaStore* _tmp6_;
	EdsfPersonaStore* _tmp7_;
#line 332 "../backends/eds/eds-backend.vala"
	g_return_if_fail (self != NULL);
#line 332 "../backends/eds/eds-backend.vala"
	g_return_if_fail (s != NULL);
#line 334 "../backends/eds/eds-backend.vala"
	_tmp0_ = e_source_get_uid (s);
#line 334 "../backends/eds/eds-backend.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 334 "../backends/eds/eds-backend.vala"
	uid = _tmp1_;
#line 335 "../backends/eds/eds-backend.vala"
	_tmp2_ = self->priv->_persona_stores;
#line 335 "../backends/eds/eds-backend.vala"
	_tmp3_ = uid;
#line 335 "../backends/eds/eds-backend.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, _tmp3_)) {
#line 336 "../backends/eds/eds-backend.vala"
		_g_free0 (uid);
#line 336 "../backends/eds/eds-backend.vala"
		return;
#line 1290 "eds-backend.c"
	}
#line 338 "../backends/eds/eds-backend.vala"
	_tmp4_ = uid;
#line 338 "../backends/eds/eds-backend.vala"
	g_debug ("eds-backend.vala:338: Adding address book '%s'.", _tmp4_);
#line 340 "../backends/eds/eds-backend.vala"
	_tmp5_ = self->priv->_ab_sources;
#line 340 "../backends/eds/eds-backend.vala"
	_tmp6_ = edsf_persona_store_new_with_source_registry (_tmp5_, s);
#line 340 "../backends/eds/eds-backend.vala"
	store = _tmp6_;
#line 343 "../backends/eds/eds-backend.vala"
	_tmp7_ = store;
#line 343 "../backends/eds/eds-backend.vala"
	folks_backend_enable_persona_store ((FolksBackend*) self, (FolksPersonaStore*) _tmp7_);
#line 332 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (store);
#line 332 "../backends/eds/eds-backend.vala"
	_g_free0 (uid);
#line 1310 "eds-backend.c"
}

static void
_folks_backends_eds_backend_remove_address_book (FolksBackendsEdsBackend* self,
                                                 FolksPersonaStore* store,
                                                 gboolean notify,
                                                 GeeMapIterator* iter)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	guint _tmp7_;
#line 346 "../backends/eds/eds-backend.vala"
	g_return_if_fail (self != NULL);
#line 346 "../backends/eds/eds-backend.vala"
	g_return_if_fail (store != NULL);
#line 350 "../backends/eds/eds-backend.vala"
	_tmp0_ = folks_persona_store_get_id (store);
#line 350 "../backends/eds/eds-backend.vala"
	_tmp1_ = _tmp0_;
#line 350 "../backends/eds/eds-backend.vala"
	g_debug ("eds-backend.vala:350: Removing address book '%s'.", _tmp1_);
#line 352 "../backends/eds/eds-backend.vala"
	if (iter != NULL) {
#line 1334 "eds-backend.c"
		gpointer _tmp2_;
		FolksPersonaStore* _tmp3_;
#line 354 "../backends/eds/eds-backend.vala"
		_tmp2_ = gee_map_iterator_get_value (iter);
#line 354 "../backends/eds/eds-backend.vala"
		_tmp3_ = (FolksPersonaStore*) _tmp2_;
#line 354 "../backends/eds/eds-backend.vala"
		_vala_assert (store == _tmp3_, "store == iter.get_value ()");
#line 354 "../backends/eds/eds-backend.vala"
		_g_object_unref0 (_tmp3_);
#line 355 "../backends/eds/eds-backend.vala"
		gee_map_iterator_unset (iter);
#line 1347 "eds-backend.c"
	} else {
		GeeHashMap* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 359 "../backends/eds/eds-backend.vala"
		_tmp4_ = self->priv->_persona_stores;
#line 359 "../backends/eds/eds-backend.vala"
		_tmp5_ = folks_persona_store_get_id (store);
#line 359 "../backends/eds/eds-backend.vala"
		_tmp6_ = _tmp5_;
#line 359 "../backends/eds/eds-backend.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, _tmp6_, NULL);
#line 1360 "eds-backend.c"
	}
#line 362 "../backends/eds/eds-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) self, "persona-store-removed", store);
#line 364 "../backends/eds/eds-backend.vala"
	if (notify) {
#line 366 "../backends/eds/eds-backend.vala"
		g_object_notify ((GObject*) self, "persona-stores");
#line 1368 "eds-backend.c"
	}
#line 369 "../backends/eds/eds-backend.vala"
	g_signal_parse_name ("removed", FOLKS_TYPE_PERSONA_STORE, &_tmp7_, NULL, FALSE);
#line 369 "../backends/eds/eds-backend.vala"
	g_signal_handlers_disconnect_matched (store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) __folks_backends_eds_backend_store_removed_cb_folks_persona_store_removed, self);
#line 1374 "eds-backend.c"
}

static void
_folks_backends_eds_backend_store_removed_cb (FolksBackendsEdsBackend* self,
                                              FolksPersonaStore* store)
{
#line 372 "../backends/eds/eds-backend.vala"
	g_return_if_fail (self != NULL);
#line 372 "../backends/eds/eds-backend.vala"
	g_return_if_fail (store != NULL);
#line 374 "../backends/eds/eds-backend.vala"
	_folks_backends_eds_backend_remove_address_book (self, store, TRUE, NULL);
#line 1387 "eds-backend.c"
}

static gchar**
_folks_backends_eds_backend_get_addressbooks_from_env (FolksBackendsEdsBackend* self,
                                                       gint* result_length1)
{
	gchar** addressbooks = NULL;
	gchar** _tmp0_;
	gint addressbooks_length1;
	gint _addressbooks_size_;
	gchar* ab_list = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** result;
#line 377 "../backends/eds/eds-backend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 379 "../backends/eds/eds-backend.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 379 "../backends/eds/eds-backend.vala"
	addressbooks = _tmp0_;
#line 379 "../backends/eds/eds-backend.vala"
	addressbooks_length1 = 0;
#line 379 "../backends/eds/eds-backend.vala"
	_addressbooks_size_ = addressbooks_length1;
#line 380 "../backends/eds/eds-backend.vala"
	_tmp1_ = g_getenv (FOLKS_BACKENDS_EDS_BACKEND__use_address_books);
#line 380 "../backends/eds/eds-backend.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 380 "../backends/eds/eds-backend.vala"
	ab_list = _tmp2_;
#line 382 "../backends/eds/eds-backend.vala"
	_tmp4_ = ab_list;
#line 382 "../backends/eds/eds-backend.vala"
	if (_tmp4_ != NULL) {
#line 1426 "eds-backend.c"
		const gchar* _tmp5_;
#line 382 "../backends/eds/eds-backend.vala"
		_tmp5_ = ab_list;
#line 382 "../backends/eds/eds-backend.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") != 0;
#line 1432 "eds-backend.c"
	} else {
#line 382 "../backends/eds/eds-backend.vala"
		_tmp3_ = FALSE;
#line 1436 "eds-backend.c"
	}
#line 382 "../backends/eds/eds-backend.vala"
	if (_tmp3_) {
#line 1440 "eds-backend.c"
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
#line 384 "../backends/eds/eds-backend.vala"
		_tmp6_ = ab_list;
#line 384 "../backends/eds/eds-backend.vala"
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ":", 0);
#line 384 "../backends/eds/eds-backend.vala"
		addressbooks = (_vala_array_free (addressbooks, addressbooks_length1, (GDestroyNotify) g_free), NULL);
#line 384 "../backends/eds/eds-backend.vala"
		addressbooks = _tmp8_;
#line 384 "../backends/eds/eds-backend.vala"
		addressbooks_length1 = _vala_array_length (_tmp7_);
#line 384 "../backends/eds/eds-backend.vala"
		_addressbooks_size_ = addressbooks_length1;
#line 1456 "eds-backend.c"
	}
#line 387 "../backends/eds/eds-backend.vala"
	_tmp9_ = addressbooks;
#line 387 "../backends/eds/eds-backend.vala"
	_tmp9__length1 = addressbooks_length1;
#line 387 "../backends/eds/eds-backend.vala"
	if (result_length1) {
#line 387 "../backends/eds/eds-backend.vala"
		*result_length1 = _tmp9__length1;
#line 1466 "eds-backend.c"
	}
#line 387 "../backends/eds/eds-backend.vala"
	result = _tmp9_;
#line 387 "../backends/eds/eds-backend.vala"
	_g_free0 (ab_list);
#line 387 "../backends/eds/eds-backend.vala"
	return result;
#line 1474 "eds-backend.c"
}

static const gchar*
folks_backends_eds_backend_real_get_name (FolksBackend* base)
{
	const gchar* result;
	FolksBackendsEdsBackend* self;
#line 55 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 55 "../backends/eds/eds-backend.vala"
	result = BACKEND_NAME;
#line 55 "../backends/eds/eds-backend.vala"
	return result;
#line 1488 "eds-backend.c"
}

static GeeMap*
folks_backends_eds_backend_real_get_persona_stores (FolksBackend* base)
{
	GeeMap* result;
	FolksBackendsEdsBackend* self;
	GeeMap* _tmp0_;
#line 62 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 62 "../backends/eds/eds-backend.vala"
	_tmp0_ = self->priv->_persona_stores_ro;
#line 62 "../backends/eds/eds-backend.vala"
	result = _tmp0_;
#line 62 "../backends/eds/eds-backend.vala"
	return result;
#line 1505 "eds-backend.c"
}

static gboolean
folks_backends_eds_backend_real_get_is_prepared (FolksBackend* base)
{
	gboolean result;
	FolksBackendsEdsBackend* self;
#line 179 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 179 "../backends/eds/eds-backend.vala"
	result = self->priv->_is_prepared;
#line 179 "../backends/eds/eds-backend.vala"
	return result;
#line 1519 "eds-backend.c"
}

static gboolean
folks_backends_eds_backend_real_get_is_quiescent (FolksBackend* base)
{
	gboolean result;
	FolksBackendsEdsBackend* self;
#line 191 "../backends/eds/eds-backend.vala"
	self = (FolksBackendsEdsBackend*) base;
#line 191 "../backends/eds/eds-backend.vala"
	result = self->priv->_is_quiescent;
#line 191 "../backends/eds/eds-backend.vala"
	return result;
#line 1533 "eds-backend.c"
}

static GObject *
folks_backends_eds_backend_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksBackendsEdsBackend * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
#line 163 "../backends/eds/eds-backend.vala"
	parent_class = G_OBJECT_CLASS (folks_backends_eds_backend_parent_class);
#line 163 "../backends/eds/eds-backend.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 163 "../backends/eds/eds-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_EDS_TYPE_BACKEND, FolksBackendsEdsBackend);
#line 165 "../backends/eds/eds-backend.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_TYPE_PERSONA_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 165 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores);
#line 165 "../backends/eds/eds-backend.vala"
	self->priv->_persona_stores = _tmp0_;
#line 166 "../backends/eds/eds-backend.vala"
	_tmp1_ = self->priv->_persona_stores;
#line 166 "../backends/eds/eds-backend.vala"
	_tmp2_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp1_);
#line 166 "../backends/eds/eds-backend.vala"
	_tmp3_ = _tmp2_;
#line 166 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores_ro);
#line 166 "../backends/eds/eds-backend.vala"
	self->priv->_persona_stores_ro = _tmp3_;
#line 167 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_storeids);
#line 167 "../backends/eds/eds-backend.vala"
	self->priv->_storeids = NULL;
#line 163 "../backends/eds/eds-backend.vala"
	return obj;
#line 1576 "eds-backend.c"
}

static void
folks_backends_eds_backend_class_init (FolksBackendsEdsBackendClass * klass,
                                       gpointer klass_data)
{
#line 40 "../backends/eds/eds-backend.vala"
	folks_backends_eds_backend_parent_class = g_type_class_peek_parent (klass);
#line 40 "../backends/eds/eds-backend.vala"
	g_type_class_adjust_private_offset (klass, &FolksBackendsEdsBackend_private_offset);
#line 40 "../backends/eds/eds-backend.vala"
	((FolksBackendClass *) klass)->disable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_backends_eds_backend_real_disable_persona_store;
#line 40 "../backends/eds/eds-backend.vala"
	((FolksBackendClass *) klass)->enable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_backends_eds_backend_real_enable_persona_store;
#line 40 "../backends/eds/eds-backend.vala"
	((FolksBackendClass *) klass)->set_persona_stores = (void (*) (FolksBackend*, GeeSet*)) folks_backends_eds_backend_real_set_persona_stores;
#line 40 "../backends/eds/eds-backend.vala"
	((FolksBackendClass *) klass)->prepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_backends_eds_backend_real_prepare;
#line 40 "../backends/eds/eds-backend.vala"
	((FolksBackendClass *) klass)->prepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_backends_eds_backend_prepare_finish;
#line 40 "../backends/eds/eds-backend.vala"
	((FolksBackendClass *) klass)->unprepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_backends_eds_backend_real_unprepare;
#line 40 "../backends/eds/eds-backend.vala"
	((FolksBackendClass *) klass)->unprepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_backends_eds_backend_unprepare_finish;
#line 40 "../backends/eds/eds-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_name = (const gchar* (*) (FolksBackend*)) folks_backends_eds_backend_real_get_name;
#line 40 "../backends/eds/eds-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_persona_stores = (GeeMap* (*) (FolksBackend*)) folks_backends_eds_backend_real_get_persona_stores;
#line 40 "../backends/eds/eds-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_prepared = (gboolean (*) (FolksBackend*)) folks_backends_eds_backend_real_get_is_prepared;
#line 40 "../backends/eds/eds-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_quiescent = (gboolean (*) (FolksBackend*)) folks_backends_eds_backend_real_get_is_quiescent;
#line 40 "../backends/eds/eds-backend.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_backends_eds_backend_get_property;
#line 40 "../backends/eds/eds-backend.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_backends_eds_backend_constructor;
#line 40 "../backends/eds/eds-backend.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_backends_eds_backend_finalize;
#line 1615 "eds-backend.c"
	/**
	   * {@inheritDoc}
	   */
#line 40 "../backends/eds/eds-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_EDS_BACKEND_NAME_PROPERTY, folks_backends_eds_backend_properties[FOLKS_BACKENDS_EDS_BACKEND_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1621 "eds-backend.c"
	/**
	   * {@inheritDoc}
	   */
#line 40 "../backends/eds/eds-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_EDS_BACKEND_PERSONA_STORES_PROPERTY, folks_backends_eds_backend_properties[FOLKS_BACKENDS_EDS_BACKEND_PERSONA_STORES_PROPERTY] = g_param_spec_object ("persona-stores", "persona-stores", "persona-stores", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1627 "eds-backend.c"
	/**
	   * Whether this Backend has been prepared.
	   *
	   * See {@link Folks.Backend.is_prepared}.
	   *
	   * @since 0.6.0
	   */
#line 40 "../backends/eds/eds-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_EDS_BACKEND_IS_PREPARED_PROPERTY, folks_backends_eds_backend_properties[FOLKS_BACKENDS_EDS_BACKEND_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1637 "eds-backend.c"
	/**
	   * Whether this Backend has reached a quiescent state.
	   *
	   * See {@link Folks.Backend.is_quiescent}.
	   *
	   * @since 0.6.2
	   */
#line 40 "../backends/eds/eds-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_EDS_BACKEND_IS_QUIESCENT_PROPERTY, folks_backends_eds_backend_properties[FOLKS_BACKENDS_EDS_BACKEND_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1647 "eds-backend.c"
}

static void
folks_backends_eds_backend_instance_init (FolksBackendsEdsBackend * self,
                                          gpointer klass)
{
#line 40 "../backends/eds/eds-backend.vala"
	self->priv = folks_backends_eds_backend_get_instance_private (self);
#line 44 "../backends/eds/eds-backend.vala"
	self->priv->_is_prepared = FALSE;
#line 45 "../backends/eds/eds-backend.vala"
	self->priv->_prepare_pending = FALSE;
#line 46 "../backends/eds/eds-backend.vala"
	self->priv->_is_quiescent = FALSE;
#line 1662 "eds-backend.c"
}

static void
folks_backends_eds_backend_finalize (GObject * obj)
{
	FolksBackendsEdsBackend * self;
#line 40 "../backends/eds/eds-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_EDS_TYPE_BACKEND, FolksBackendsEdsBackend);
#line 47 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores);
#line 48 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores_ro);
#line 49 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_ab_sources);
#line 50 "../backends/eds/eds-backend.vala"
	_g_object_unref0 (self->priv->_storeids);
#line 40 "../backends/eds/eds-backend.vala"
	G_OBJECT_CLASS (folks_backends_eds_backend_parent_class)->finalize (obj);
#line 1681 "eds-backend.c"
}

/**
 * A backend which connects to EDS and creates a {@link PersonaStore}
 * for each service.
 */
static GType
folks_backends_eds_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksBackendsEdsBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_backends_eds_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksBackendsEdsBackend), 0, (GInstanceInitFunc) folks_backends_eds_backend_instance_init, NULL };
	GType folks_backends_eds_backend_type_id;
	folks_backends_eds_backend_type_id = g_type_register_static (FOLKS_TYPE_BACKEND, "FolksBackendsEdsBackend", &g_define_type_info, 0);
	FolksBackendsEdsBackend_private_offset = g_type_add_instance_private (folks_backends_eds_backend_type_id, sizeof (FolksBackendsEdsBackendPrivate));
	return folks_backends_eds_backend_type_id;
}

GType
folks_backends_eds_backend_get_type (void)
{
	static volatile gsize folks_backends_eds_backend_type_id__once = 0;
	if (g_once_init_enter (&folks_backends_eds_backend_type_id__once)) {
		GType folks_backends_eds_backend_type_id;
		folks_backends_eds_backend_type_id = folks_backends_eds_backend_get_type_once ();
		g_once_init_leave (&folks_backends_eds_backend_type_id__once, folks_backends_eds_backend_type_id);
	}
	return folks_backends_eds_backend_type_id__once;
}

static void
_vala_folks_backends_eds_backend_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	FolksBackendsEdsBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_BACKENDS_EDS_TYPE_BACKEND, FolksBackendsEdsBackend);
#line 40 "../backends/eds/eds-backend.vala"
	switch (property_id) {
#line 40 "../backends/eds/eds-backend.vala"
		case FOLKS_BACKENDS_EDS_BACKEND_NAME_PROPERTY:
#line 40 "../backends/eds/eds-backend.vala"
		g_value_set_string (value, folks_backend_get_name ((FolksBackend*) self));
#line 40 "../backends/eds/eds-backend.vala"
		break;
#line 40 "../backends/eds/eds-backend.vala"
		case FOLKS_BACKENDS_EDS_BACKEND_PERSONA_STORES_PROPERTY:
#line 40 "../backends/eds/eds-backend.vala"
		g_value_set_object (value, folks_backend_get_persona_stores ((FolksBackend*) self));
#line 40 "../backends/eds/eds-backend.vala"
		break;
#line 40 "../backends/eds/eds-backend.vala"
		case FOLKS_BACKENDS_EDS_BACKEND_IS_PREPARED_PROPERTY:
#line 40 "../backends/eds/eds-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_prepared ((FolksBackend*) self));
#line 40 "../backends/eds/eds-backend.vala"
		break;
#line 40 "../backends/eds/eds-backend.vala"
		case FOLKS_BACKENDS_EDS_BACKEND_IS_QUIESCENT_PROPERTY:
#line 40 "../backends/eds/eds-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_quiescent ((FolksBackend*) self));
#line 40 "../backends/eds/eds-backend.vala"
		break;
#line 1744 "eds-backend.c"
		default:
#line 40 "../backends/eds/eds-backend.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 40 "../backends/eds/eds-backend.vala"
		break;
#line 1750 "eds-backend.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

