/* extended-info.c generated by valac 0.56.18, the Vala compiler
 * generated from extended-info.vala, do not modify */

/*
 * Copyright (C) 2013, 2015 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Rodrigo Moya <rodrigo@gnome.org>
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 */

#include "folks/folks.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_EXTENDED_FIELD_DETAILS_0_PROPERTY,
	FOLKS_EXTENDED_FIELD_DETAILS_NUM_PROPERTIES
};
static GParamSpec* folks_extended_field_details_properties[FOLKS_EXTENDED_FIELD_DETAILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _FolksExtendedInfoChangeExtendedFieldData FolksExtendedInfoChangeExtendedFieldData;
typedef struct _FolksExtendedInfoRemoveExtendedFieldData FolksExtendedInfoRemoveExtendedFieldData;

struct _FolksExtendedInfoChangeExtendedFieldData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksExtendedInfo* self;
	gchar* name;
	FolksExtendedFieldDetails* value;
	GError* _tmp0_;
	GError* _inner_error0_;
};

struct _FolksExtendedInfoRemoveExtendedFieldData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksExtendedInfo* self;
	gchar* name;
	GError* _tmp0_;
	GError* _inner_error0_;
};

static gpointer folks_extended_field_details_parent_class = NULL;

static gboolean folks_extended_field_details_real_equal (FolksAbstractFieldDetails* base,
                                                  FolksAbstractFieldDetails* that);
static guint folks_extended_field_details_real_hash (FolksAbstractFieldDetails* base);
static GType folks_extended_field_details_get_type_once (void);
static void folks_extended_info_real_change_extended_field_data_free (gpointer _data);
static void folks_extended_info_real_change_extended_field (FolksExtendedInfo* self,
                                                     const gchar* name,
                                                     FolksExtendedFieldDetails* value,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean folks_extended_info_real_change_extended_field_co (FolksExtendedInfoChangeExtendedFieldData* _data_);
static void folks_extended_info_real_remove_extended_field_data_free (gpointer _data);
static void folks_extended_info_real_remove_extended_field (FolksExtendedInfo* self,
                                                     const gchar* name,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean folks_extended_info_real_remove_extended_field_co (FolksExtendedInfoRemoveExtendedFieldData* _data_);
static GType folks_extended_info_get_type_once (void);

/**
   * Create a new ExtendedFieldDetails.
   *
   * @param value the value of the field, which may be the empty string
   * @param parameters initial parameters. See
   * {@link AbstractFieldDetails.parameters}. A ``null`` value is equivalent to
   * an empty map of parameters.
   *
   * @return a new ExtendedFieldDetails
   *
   * @since 0.11.0
   */
FolksExtendedFieldDetails*
folks_extended_field_details_construct (GType object_type,
                                        const gchar* value,
                                        GeeMultiMap* parameters)
{
	FolksExtendedFieldDetails * self = NULL;
#line 51 "../folks/extended-info.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 51 "../folks/extended-info.vala"
	self = (FolksExtendedFieldDetails*) folks_abstract_field_details_construct (object_type, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free);
#line 54 "../folks/extended-info.vala"
	folks_abstract_field_details_set_value ((FolksAbstractFieldDetails*) self, value);
#line 55 "../folks/extended-info.vala"
	if (parameters != NULL) {
#line 56 "../folks/extended-info.vala"
		folks_abstract_field_details_set_parameters ((FolksAbstractFieldDetails*) self, G_TYPE_CHECK_INSTANCE_CAST (parameters, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 126 "extended-info.c"
	}
#line 51 "../folks/extended-info.vala"
	return self;
#line 130 "extended-info.c"
}

FolksExtendedFieldDetails*
folks_extended_field_details_new (const gchar* value,
                                  GeeMultiMap* parameters)
{
#line 51 "../folks/extended-info.vala"
	return folks_extended_field_details_construct (FOLKS_TYPE_EXTENDED_FIELD_DETAILS, value, parameters);
#line 139 "extended-info.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.11.0
   */
static gboolean
folks_extended_field_details_real_equal (FolksAbstractFieldDetails* base,
                                         FolksAbstractFieldDetails* that)
{
	FolksExtendedFieldDetails * self;
	gboolean result;
#line 64 "../folks/extended-info.vala"
	self = (FolksExtendedFieldDetails*) base;
#line 64 "../folks/extended-info.vala"
	g_return_val_if_fail (that != NULL, FALSE);
#line 66 "../folks/extended-info.vala"
	result = FOLKS_ABSTRACT_FIELD_DETAILS_CLASS (folks_extended_field_details_parent_class)->equal (G_TYPE_CHECK_INSTANCE_CAST (self, FOLKS_TYPE_ABSTRACT_FIELD_DETAILS, FolksAbstractFieldDetails), that);
#line 66 "../folks/extended-info.vala"
	return result;
#line 161 "extended-info.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.11.0
   */
static guint
folks_extended_field_details_real_hash (FolksAbstractFieldDetails* base)
{
	FolksExtendedFieldDetails * self;
	guint result;
#line 74 "../folks/extended-info.vala"
	self = (FolksExtendedFieldDetails*) base;
#line 76 "../folks/extended-info.vala"
	result = FOLKS_ABSTRACT_FIELD_DETAILS_CLASS (folks_extended_field_details_parent_class)->hash (G_TYPE_CHECK_INSTANCE_CAST (self, FOLKS_TYPE_ABSTRACT_FIELD_DETAILS, FolksAbstractFieldDetails));
#line 76 "../folks/extended-info.vala"
	return result;
#line 180 "extended-info.c"
}

static void
folks_extended_field_details_class_init (FolksExtendedFieldDetailsClass * klass,
                                         gpointer klass_data)
{
#line 37 "../folks/extended-info.vala"
	folks_extended_field_details_parent_class = g_type_class_peek_parent (klass);
#line 37 "../folks/extended-info.vala"
	((FolksAbstractFieldDetailsClass *) klass)->equal = (gboolean (*) (FolksAbstractFieldDetails*, FolksAbstractFieldDetails*)) folks_extended_field_details_real_equal;
#line 37 "../folks/extended-info.vala"
	((FolksAbstractFieldDetailsClass *) klass)->hash = (guint (*) (FolksAbstractFieldDetails*)) folks_extended_field_details_real_hash;
#line 193 "extended-info.c"
}

static void
folks_extended_field_details_instance_init (FolksExtendedFieldDetails * self,
                                            gpointer klass)
{
}

/**
 * Object representing an arbitrary field that can have some parameters
 * associated with it. This is intended to be as general-purpose as, for
 * example, a vCard property. See the documentation for
 * {@link Folks.ExtendedInfo} for information on when using this object is
 * appropriate.
 *
 * See {@link Folks.AbstractFieldDetails} for details on common parameter names
 * and values.
 *
 * @since 0.11.0
 */
static GType
folks_extended_field_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksExtendedFieldDetailsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_extended_field_details_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksExtendedFieldDetails), 0, (GInstanceInitFunc) folks_extended_field_details_instance_init, NULL };
	GType folks_extended_field_details_type_id;
	folks_extended_field_details_type_id = g_type_register_static (FOLKS_TYPE_ABSTRACT_FIELD_DETAILS, "FolksExtendedFieldDetails", &g_define_type_info, 0);
	return folks_extended_field_details_type_id;
}

GType
folks_extended_field_details_get_type (void)
{
	static volatile gsize folks_extended_field_details_type_id__once = 0;
	if (g_once_init_enter (&folks_extended_field_details_type_id__once)) {
		GType folks_extended_field_details_type_id;
		folks_extended_field_details_type_id = folks_extended_field_details_get_type_once ();
		g_once_init_leave (&folks_extended_field_details_type_id__once, folks_extended_field_details_type_id);
	}
	return folks_extended_field_details_type_id__once;
}

/**
   * Retrieve the value for an arbitrary field.
   *
   * @return The value of the extended field, which may be empty, or `null` if
   *   the field is not set
   *
   * @since 0.11.0
   */
FolksExtendedFieldDetails*
folks_extended_info_get_extended_field (FolksExtendedInfo* self,
                                        const gchar* name)
{
	FolksExtendedInfoIface* _iface_;
#line 117 "../folks/extended-info.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../folks/extended-info.vala"
	_iface_ = FOLKS_EXTENDED_INFO_GET_INTERFACE (self);
#line 117 "../folks/extended-info.vala"
	if (_iface_->get_extended_field) {
#line 117 "../folks/extended-info.vala"
		return _iface_->get_extended_field (self, name);
#line 256 "extended-info.c"
	}
#line 117 "../folks/extended-info.vala"
	return NULL;
#line 260 "extended-info.c"
}

static void
folks_extended_info_real_change_extended_field_data_free (gpointer _data)
{
	FolksExtendedInfoChangeExtendedFieldData* _data_;
	_data_ = _data;
#line 107 "../folks/extended-info.vala"
	_g_free0 (_data_->name);
#line 107 "../folks/extended-info.vala"
	_g_object_unref0 (_data_->value);
#line 107 "../folks/extended-info.vala"
	_g_object_unref0 (_data_->self);
#line 107 "../folks/extended-info.vala"
	g_slice_free (FolksExtendedInfoChangeExtendedFieldData, _data_);
#line 276 "extended-info.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 107 "../folks/extended-info.vala"
	return self ? g_object_ref (self) : NULL;
#line 284 "extended-info.c"
}

static void
folks_extended_info_real_change_extended_field (FolksExtendedInfo* self,
                                                const gchar* name,
                                                FolksExtendedFieldDetails* value,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	FolksExtendedInfoChangeExtendedFieldData* _data_;
	FolksExtendedInfo* _tmp0_;
	gchar* _tmp1_;
	FolksExtendedFieldDetails* _tmp2_;
#line 107 "../folks/extended-info.vala"
	g_return_if_fail (name != NULL);
#line 107 "../folks/extended-info.vala"
	g_return_if_fail (value != NULL);
#line 107 "../folks/extended-info.vala"
	_data_ = g_slice_new0 (FolksExtendedInfoChangeExtendedFieldData);
#line 107 "../folks/extended-info.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 107 "../folks/extended-info.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_extended_info_real_change_extended_field_data_free);
#line 107 "../folks/extended-info.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 107 "../folks/extended-info.vala"
	_data_->self = _tmp0_;
#line 107 "../folks/extended-info.vala"
	_tmp1_ = g_strdup (name);
#line 107 "../folks/extended-info.vala"
	_g_free0 (_data_->name);
#line 107 "../folks/extended-info.vala"
	_data_->name = _tmp1_;
#line 107 "../folks/extended-info.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 107 "../folks/extended-info.vala"
	_g_object_unref0 (_data_->value);
#line 107 "../folks/extended-info.vala"
	_data_->value = _tmp2_;
#line 107 "../folks/extended-info.vala"
	folks_extended_info_real_change_extended_field_co (_data_);
#line 326 "extended-info.c"
}

static void
folks_extended_info_real_change_extended_field_finish (FolksExtendedInfo* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	FolksExtendedInfoChangeExtendedFieldData* _data_;
#line 107 "../folks/extended-info.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 107 "../folks/extended-info.vala"
	if (NULL == _data_) {
#line 107 "../folks/extended-info.vala"
		return;
#line 341 "extended-info.c"
	}
}

/**
   * Change the value of an arbitrary field.
   *
   * @param name name of the arbitrary field to change value
   * @param value new value for the arbitrary field
   * @throws PropertyError if setting the value failed
   *
   * @since 0.11.0
   */
static gboolean
folks_extended_info_real_change_extended_field_co (FolksExtendedInfoChangeExtendedFieldData* _data_)
{
#line 128 "../folks/extended-info.vala"
	switch (_data_->_state_) {
#line 128 "../folks/extended-info.vala"
		case 0:
#line 361 "extended-info.c"
		goto _state_0;
		default:
#line 128 "../folks/extended-info.vala"
		g_assert_not_reached ();
#line 366 "extended-info.c"
	}
	_state_0:
#line 132 "../folks/extended-info.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Extended fields are not writeable on this contact."));
#line 132 "../folks/extended-info.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 132 "../folks/extended-info.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 132 "../folks/extended-info.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 132 "../folks/extended-info.vala"
		g_object_unref (_data_->_async_result);
#line 132 "../folks/extended-info.vala"
		return FALSE;
#line 381 "extended-info.c"
	} else {
#line 132 "../folks/extended-info.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 132 "../folks/extended-info.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 132 "../folks/extended-info.vala"
		g_object_unref (_data_->_async_result);
#line 132 "../folks/extended-info.vala"
		return FALSE;
#line 391 "extended-info.c"
	}
#line 128 "../folks/extended-info.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 128 "../folks/extended-info.vala"
	if (_data_->_state_ != 0) {
#line 128 "../folks/extended-info.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 128 "../folks/extended-info.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 401 "extended-info.c"
		}
	}
#line 128 "../folks/extended-info.vala"
	g_object_unref (_data_->_async_result);
#line 128 "../folks/extended-info.vala"
	return FALSE;
#line 408 "extended-info.c"
}

void
folks_extended_info_change_extended_field (FolksExtendedInfo* self,
                                           const gchar* name,
                                           FolksExtendedFieldDetails* value,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	FolksExtendedInfoIface* _iface_;
#line 107 "../folks/extended-info.vala"
	_iface_ = FOLKS_EXTENDED_INFO_GET_INTERFACE (self);
#line 107 "../folks/extended-info.vala"
	if (_iface_->change_extended_field) {
#line 107 "../folks/extended-info.vala"
		_iface_->change_extended_field (self, name, value, _callback_, _user_data_);
#line 425 "extended-info.c"
	}
}

void
folks_extended_info_change_extended_field_finish (FolksExtendedInfo* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	FolksExtendedInfoIface* _iface_;
#line 107 "../folks/extended-info.vala"
	_iface_ = FOLKS_EXTENDED_INFO_GET_INTERFACE (self);
#line 107 "../folks/extended-info.vala"
	if (_iface_->change_extended_field_finish) {
#line 107 "../folks/extended-info.vala"
		_iface_->change_extended_field_finish (self, _res_, error);
#line 441 "extended-info.c"
	}
}

static void
folks_extended_info_real_remove_extended_field_data_free (gpointer _data)
{
	FolksExtendedInfoRemoveExtendedFieldData* _data_;
	_data_ = _data;
#line 107 "../folks/extended-info.vala"
	_g_free0 (_data_->name);
#line 107 "../folks/extended-info.vala"
	_g_object_unref0 (_data_->self);
#line 107 "../folks/extended-info.vala"
	g_slice_free (FolksExtendedInfoRemoveExtendedFieldData, _data_);
#line 456 "extended-info.c"
}

static void
folks_extended_info_real_remove_extended_field (FolksExtendedInfo* self,
                                                const gchar* name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	FolksExtendedInfoRemoveExtendedFieldData* _data_;
	FolksExtendedInfo* _tmp0_;
	gchar* _tmp1_;
#line 107 "../folks/extended-info.vala"
	g_return_if_fail (name != NULL);
#line 107 "../folks/extended-info.vala"
	_data_ = g_slice_new0 (FolksExtendedInfoRemoveExtendedFieldData);
#line 107 "../folks/extended-info.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 107 "../folks/extended-info.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_extended_info_real_remove_extended_field_data_free);
#line 107 "../folks/extended-info.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 107 "../folks/extended-info.vala"
	_data_->self = _tmp0_;
#line 107 "../folks/extended-info.vala"
	_tmp1_ = g_strdup (name);
#line 107 "../folks/extended-info.vala"
	_g_free0 (_data_->name);
#line 107 "../folks/extended-info.vala"
	_data_->name = _tmp1_;
#line 107 "../folks/extended-info.vala"
	folks_extended_info_real_remove_extended_field_co (_data_);
#line 488 "extended-info.c"
}

static void
folks_extended_info_real_remove_extended_field_finish (FolksExtendedInfo* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	FolksExtendedInfoRemoveExtendedFieldData* _data_;
#line 107 "../folks/extended-info.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 107 "../folks/extended-info.vala"
	if (NULL == _data_) {
#line 107 "../folks/extended-info.vala"
		return;
#line 503 "extended-info.c"
	}
}

/**
   * Remove an arbitrary field.
   *
   * @param name name of the arbitrary field to remove
   * @throws PropertyError if removing the property failed
   *
   * @since 0.11.0
   */
static gboolean
folks_extended_info_real_remove_extended_field_co (FolksExtendedInfoRemoveExtendedFieldData* _data_)
{
#line 144 "../folks/extended-info.vala"
	switch (_data_->_state_) {
#line 144 "../folks/extended-info.vala"
		case 0:
#line 522 "extended-info.c"
		goto _state_0;
		default:
#line 144 "../folks/extended-info.vala"
		g_assert_not_reached ();
#line 527 "extended-info.c"
	}
	_state_0:
#line 148 "../folks/extended-info.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Extended fields are not writeable on this contact."));
#line 148 "../folks/extended-info.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 148 "../folks/extended-info.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 148 "../folks/extended-info.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 148 "../folks/extended-info.vala"
		g_object_unref (_data_->_async_result);
#line 148 "../folks/extended-info.vala"
		return FALSE;
#line 542 "extended-info.c"
	} else {
#line 148 "../folks/extended-info.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 148 "../folks/extended-info.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 148 "../folks/extended-info.vala"
		g_object_unref (_data_->_async_result);
#line 148 "../folks/extended-info.vala"
		return FALSE;
#line 552 "extended-info.c"
	}
#line 144 "../folks/extended-info.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 144 "../folks/extended-info.vala"
	if (_data_->_state_ != 0) {
#line 144 "../folks/extended-info.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 144 "../folks/extended-info.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 562 "extended-info.c"
		}
	}
#line 144 "../folks/extended-info.vala"
	g_object_unref (_data_->_async_result);
#line 144 "../folks/extended-info.vala"
	return FALSE;
#line 569 "extended-info.c"
}

void
folks_extended_info_remove_extended_field (FolksExtendedInfo* self,
                                           const gchar* name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	FolksExtendedInfoIface* _iface_;
#line 107 "../folks/extended-info.vala"
	_iface_ = FOLKS_EXTENDED_INFO_GET_INTERFACE (self);
#line 107 "../folks/extended-info.vala"
	if (_iface_->remove_extended_field) {
#line 107 "../folks/extended-info.vala"
		_iface_->remove_extended_field (self, name, _callback_, _user_data_);
#line 585 "extended-info.c"
	}
}

void
folks_extended_info_remove_extended_field_finish (FolksExtendedInfo* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	FolksExtendedInfoIface* _iface_;
#line 107 "../folks/extended-info.vala"
	_iface_ = FOLKS_EXTENDED_INFO_GET_INTERFACE (self);
#line 107 "../folks/extended-info.vala"
	if (_iface_->remove_extended_field_finish) {
#line 107 "../folks/extended-info.vala"
		_iface_->remove_extended_field_finish (self, _res_, error);
#line 601 "extended-info.c"
	}
}

static void
folks_extended_info_default_init (FolksExtendedInfoIface * iface,
                                  gpointer iface_data)
{
#line 107 "../folks/extended-info.vala"
	iface->change_extended_field = folks_extended_info_real_change_extended_field;
#line 107 "../folks/extended-info.vala"
	iface->change_extended_field_finish = folks_extended_info_real_change_extended_field_finish;
#line 107 "../folks/extended-info.vala"
	iface->remove_extended_field = folks_extended_info_real_remove_extended_field;
#line 107 "../folks/extended-info.vala"
	iface->remove_extended_field_finish = folks_extended_info_real_remove_extended_field_finish;
#line 617 "extended-info.c"
}

/**
 * Arbitrary field interface.
 *
 * This interface allows clients to store arbitrary fields for contacts in
 * backends that support it.
 *
 * This interface should be used for application-specific data, in which case
 * the application should use the vCard approach to prefixing non-standard
 * property names: `X-[APPLICATION NAME]-*’. Note that this is a global
 * namespace, shared between all consumers of the backend’s data, so please
 * namespace application-specific data with the application’s name.
 *
 * This interface should not be used for more general-purpose data which could
 * be better represented with a type-safe interface implemented in libfolks.
 * It must not be used for data which is already represented with a type-safe
 * interface in libfolks.
 *
 * A good example of data which could be stored on this interface is an e-mail
 * application’s setting of whether a content prefers to receive HTML or
 * plaintext e-mail.
 *
 * A good example of data which should not be stored on this interface is a
 * contact’s anniversary. That should be added in a separate interface in
 * libfolks.
 *
 * @since 0.11.0
 */
static GType
folks_extended_info_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksExtendedInfoIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_extended_info_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType folks_extended_info_type_id;
	folks_extended_info_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksExtendedInfo", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (folks_extended_info_type_id, G_TYPE_OBJECT);
	return folks_extended_info_type_id;
}

GType
folks_extended_info_get_type (void)
{
	static volatile gsize folks_extended_info_type_id__once = 0;
	if (g_once_init_enter (&folks_extended_info_type_id__once)) {
		GType folks_extended_info_type_id;
		folks_extended_info_type_id = folks_extended_info_get_type_once ();
		g_once_init_leave (&folks_extended_info_type_id__once, folks_extended_info_type_id);
	}
	return folks_extended_info_type_id__once;
}

