/* gender-details.c generated by valac 0.56.18, the Vala compiler
 * generated from gender-details.vala, do not modify */

/*
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2011 Philip Withnall
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Marco Barisione <marco.barisione@collabora.co.uk>
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 *       Philip Withnall <philip@tecnocode.co.uk>
 */

#include "folks/folks.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _FolksGenderDetailsChangeGenderData FolksGenderDetailsChangeGenderData;

struct _FolksGenderDetailsChangeGenderData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksGenderDetails* self;
	FolksGender gender;
	GError* _tmp0_;
	GError* _inner_error0_;
};

static void folks_gender_details_real_change_gender_data_free (gpointer _data);
static void folks_gender_details_real_change_gender (FolksGenderDetails* self,
                                              FolksGender gender,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static gboolean folks_gender_details_real_change_gender_co (FolksGenderDetailsChangeGenderData* _data_);
static GType folks_gender_details_get_type_once (void);

/**
 * The gender of a contact
 *
 * @since 0.3.5
 */
static GType
folks_gender_get_type_once (void)
{
	static const GEnumValue values[] = {{FOLKS_GENDER_UNSPECIFIED, "FOLKS_GENDER_UNSPECIFIED", "unspecified"}, {FOLKS_GENDER_MALE, "FOLKS_GENDER_MALE", "male"}, {FOLKS_GENDER_FEMALE, "FOLKS_GENDER_FEMALE", "female"}, {0, NULL, NULL}};
	GType folks_gender_type_id;
	folks_gender_type_id = g_enum_register_static ("FolksGender", values);
	return folks_gender_type_id;
}

GType
folks_gender_get_type (void)
{
	static volatile gsize folks_gender_type_id__once = 0;
	if (g_once_init_enter (&folks_gender_type_id__once)) {
		GType folks_gender_type_id;
		folks_gender_type_id = folks_gender_get_type_once ();
		g_once_init_leave (&folks_gender_type_id__once, folks_gender_type_id);
	}
	return folks_gender_type_id__once;
}

static void
folks_gender_details_real_change_gender_data_free (gpointer _data)
{
	FolksGenderDetailsChangeGenderData* _data_;
	_data_ = _data;
#line 54 "../folks/gender-details.vala"
	_g_object_unref0 (_data_->self);
#line 54 "../folks/gender-details.vala"
	g_slice_free (FolksGenderDetailsChangeGenderData, _data_);
#line 99 "gender-details.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../folks/gender-details.vala"
	return self ? g_object_ref (self) : NULL;
#line 107 "gender-details.c"
}

static void
folks_gender_details_real_change_gender (FolksGenderDetails* self,
                                         FolksGender gender,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	FolksGenderDetailsChangeGenderData* _data_;
	FolksGenderDetails* _tmp0_;
#line 54 "../folks/gender-details.vala"
	_data_ = g_slice_new0 (FolksGenderDetailsChangeGenderData);
#line 54 "../folks/gender-details.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 54 "../folks/gender-details.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_gender_details_real_change_gender_data_free);
#line 54 "../folks/gender-details.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 54 "../folks/gender-details.vala"
	_data_->self = _tmp0_;
#line 54 "../folks/gender-details.vala"
	_data_->gender = gender;
#line 54 "../folks/gender-details.vala"
	folks_gender_details_real_change_gender_co (_data_);
#line 132 "gender-details.c"
}

static void
folks_gender_details_real_change_gender_finish (FolksGenderDetails* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	FolksGenderDetailsChangeGenderData* _data_;
#line 54 "../folks/gender-details.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 54 "../folks/gender-details.vala"
	if (NULL == _data_) {
#line 54 "../folks/gender-details.vala"
		return;
#line 147 "gender-details.c"
	}
}

/**
   * Change the contact's gender.
   *
   * It's preferred to call this rather than setting
   * {@link GenderDetails.gender} directly, as this method gives error
   * notification and will only return once the gender has been written to the
   * relevant backing store (or the operation's failed).
   *
   * @param gender the contact's gender
   * @throws PropertyError if setting the gender failed
   * @since 0.6.2
   */
static gboolean
folks_gender_details_real_change_gender_co (FolksGenderDetailsChangeGenderData* _data_)
{
#line 75 "../folks/gender-details.vala"
	switch (_data_->_state_) {
#line 75 "../folks/gender-details.vala"
		case 0:
#line 170 "gender-details.c"
		goto _state_0;
		default:
#line 75 "../folks/gender-details.vala"
		g_assert_not_reached ();
#line 175 "gender-details.c"
	}
	_state_0:
#line 78 "../folks/gender-details.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Gender is not writeable on this contact."));
#line 78 "../folks/gender-details.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 78 "../folks/gender-details.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 78 "../folks/gender-details.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 78 "../folks/gender-details.vala"
		g_object_unref (_data_->_async_result);
#line 78 "../folks/gender-details.vala"
		return FALSE;
#line 190 "gender-details.c"
	} else {
#line 78 "../folks/gender-details.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 78 "../folks/gender-details.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 78 "../folks/gender-details.vala"
		g_object_unref (_data_->_async_result);
#line 78 "../folks/gender-details.vala"
		return FALSE;
#line 200 "gender-details.c"
	}
#line 75 "../folks/gender-details.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 75 "../folks/gender-details.vala"
	if (_data_->_state_ != 0) {
#line 75 "../folks/gender-details.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 75 "../folks/gender-details.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 210 "gender-details.c"
		}
	}
#line 75 "../folks/gender-details.vala"
	g_object_unref (_data_->_async_result);
#line 75 "../folks/gender-details.vala"
	return FALSE;
#line 217 "gender-details.c"
}

void
folks_gender_details_change_gender (FolksGenderDetails* self,
                                    FolksGender gender,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FolksGenderDetailsIface* _iface_;
#line 54 "../folks/gender-details.vala"
	_iface_ = FOLKS_GENDER_DETAILS_GET_INTERFACE (self);
#line 54 "../folks/gender-details.vala"
	if (_iface_->change_gender) {
#line 54 "../folks/gender-details.vala"
		_iface_->change_gender (self, gender, _callback_, _user_data_);
#line 233 "gender-details.c"
	}
}

void
folks_gender_details_change_gender_finish (FolksGenderDetails* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	FolksGenderDetailsIface* _iface_;
#line 54 "../folks/gender-details.vala"
	_iface_ = FOLKS_GENDER_DETAILS_GET_INTERFACE (self);
#line 54 "../folks/gender-details.vala"
	if (_iface_->change_gender_finish) {
#line 54 "../folks/gender-details.vala"
		_iface_->change_gender_finish (self, _res_, error);
#line 249 "gender-details.c"
	}
}

FolksGender
folks_gender_details_get_gender (FolksGenderDetails* self)
{
	FolksGenderDetailsIface* _iface_;
#line 61 "../folks/gender-details.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 61 "../folks/gender-details.vala"
	_iface_ = FOLKS_GENDER_DETAILS_GET_INTERFACE (self);
#line 61 "../folks/gender-details.vala"
	if (_iface_->get_gender) {
#line 61 "../folks/gender-details.vala"
		return _iface_->get_gender (self);
#line 265 "gender-details.c"
	}
#line 61 "../folks/gender-details.vala"
	return 0;
#line 269 "gender-details.c"
}

void
folks_gender_details_set_gender (FolksGenderDetails* self,
                                 FolksGender value)
{
	FolksGenderDetailsIface* _iface_;
#line 61 "../folks/gender-details.vala"
	g_return_if_fail (self != NULL);
#line 61 "../folks/gender-details.vala"
	_iface_ = FOLKS_GENDER_DETAILS_GET_INTERFACE (self);
#line 61 "../folks/gender-details.vala"
	if (_iface_->set_gender) {
#line 61 "../folks/gender-details.vala"
		_iface_->set_gender (self, value);
#line 285 "gender-details.c"
	}
}

static void
folks_gender_details_default_init (FolksGenderDetailsIface * iface,
                                   gpointer iface_data)
{
	/**
	   * The gender of the contact.
	   *
	   * @since 0.3.5
	   */
#line 54 "../folks/gender-details.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("gender", "gender", "gender", FOLKS_TYPE_GENDER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 54 "../folks/gender-details.vala"
	iface->change_gender = folks_gender_details_real_change_gender;
#line 54 "../folks/gender-details.vala"
	iface->change_gender_finish = folks_gender_details_real_change_gender_finish;
#line 304 "gender-details.c"
}

/**
 * Gender of a contact.
 *
 * This allows representation of the gender of a contact.
 *
 * @since 0.3.5
 */
static GType
folks_gender_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksGenderDetailsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_gender_details_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType folks_gender_details_type_id;
	folks_gender_details_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksGenderDetails", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (folks_gender_details_type_id, G_TYPE_OBJECT);
	return folks_gender_details_type_id;
}

GType
folks_gender_details_get_type (void)
{
	static volatile gsize folks_gender_details_type_id__once = 0;
	if (g_once_init_enter (&folks_gender_details_type_id__once)) {
		GType folks_gender_details_type_id;
		folks_gender_details_type_id = folks_gender_details_get_type_once ();
		g_once_init_leave (&folks_gender_details_type_id__once, folks_gender_details_type_id);
	}
	return folks_gender_details_type_id__once;
}

