/* name-details.c generated by valac 0.56.18, the Vala compiler
 * generated from name-details.vala, do not modify */

/*
 * Copyright (C) 2011, 2013 Collabora Ltd.
 * Copyright (C) 2011, 2013 Philip Withnall
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Marco Barisione <marco.barisione@collabora.co.uk>
 *       Raul Gutierrez Segales <raul.gutierrez.segales@collabora.co.uk>
 *       Philip Withnall <philip@tecnocode.co.uk>
 */

#include "folks/folks.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_STRUCTURED_NAME_0_PROPERTY,
	FOLKS_STRUCTURED_NAME_FAMILY_NAME_PROPERTY,
	FOLKS_STRUCTURED_NAME_GIVEN_NAME_PROPERTY,
	FOLKS_STRUCTURED_NAME_ADDITIONAL_NAMES_PROPERTY,
	FOLKS_STRUCTURED_NAME_PREFIXES_PROPERTY,
	FOLKS_STRUCTURED_NAME_SUFFIXES_PROPERTY,
	FOLKS_STRUCTURED_NAME_NUM_PROPERTIES
};
static GParamSpec* folks_structured_name_properties[FOLKS_STRUCTURED_NAME_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _FolksNameDetailsChangeStructuredNameData FolksNameDetailsChangeStructuredNameData;
typedef struct _FolksNameDetailsChangeFullNameData FolksNameDetailsChangeFullNameData;
typedef struct _FolksNameDetailsChangeNicknameData FolksNameDetailsChangeNicknameData;

struct _FolksStructuredNamePrivate {
	gchar* _family_name;
	gchar* _given_name;
	gchar* _additional_names;
	gchar* _prefixes;
	gchar* _suffixes;
};

struct _FolksNameDetailsChangeStructuredNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksNameDetails* self;
	FolksStructuredName* name;
	GError* _tmp0_;
	GError* _inner_error0_;
};

struct _FolksNameDetailsChangeFullNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksNameDetails* self;
	gchar* full_name;
	GError* _tmp0_;
	GError* _inner_error0_;
};

struct _FolksNameDetailsChangeNicknameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksNameDetails* self;
	gchar* nickname;
	GError* _tmp0_;
	GError* _inner_error0_;
};

static gint FolksStructuredName_private_offset;
static gpointer folks_structured_name_parent_class = NULL;

static gchar* _folks_structured_name_extract_initials (FolksStructuredName* self,
                                                const gchar* names);
static void folks_structured_name_finalize (GObject * obj);
static GType folks_structured_name_get_type_once (void);
static void _vala_folks_structured_name_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_folks_structured_name_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void folks_name_details_real_change_structured_name_data_free (gpointer _data);
static void folks_name_details_real_change_structured_name (FolksNameDetails* self,
                                                     FolksStructuredName* name,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean folks_name_details_real_change_structured_name_co (FolksNameDetailsChangeStructuredNameData* _data_);
static void folks_name_details_real_change_full_name_data_free (gpointer _data);
static void folks_name_details_real_change_full_name (FolksNameDetails* self,
                                               const gchar* full_name,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static gboolean folks_name_details_real_change_full_name_co (FolksNameDetailsChangeFullNameData* _data_);
static void folks_name_details_real_change_nickname_data_free (gpointer _data);
static void folks_name_details_real_change_nickname (FolksNameDetails* self,
                                              const gchar* nickname,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static gboolean folks_name_details_real_change_nickname_co (FolksNameDetailsChangeNicknameData* _data_);
static GType folks_name_details_get_type_once (void);

static inline gpointer
folks_structured_name_get_instance_private (FolksStructuredName* self)
{
	return G_STRUCT_MEMBER_P (self, FolksStructuredName_private_offset);
}

/**
   * Create a StructuredName.
   *
   * You can pass ``null`` if a component is not set.
   *
   * @param family_name the family (last) name
   * @param given_name the given (first) name
   * @param additional_names additional names
   * @param prefixes prefixes of the name
   * @param suffixes suffixes of the name
   * @return a new StructuredName
   *
   * @since 0.3.5
   */
FolksStructuredName*
folks_structured_name_construct (GType object_type,
                                 const gchar* family_name,
                                 const gchar* given_name,
                                 const gchar* additional_names,
                                 const gchar* prefixes,
                                 const gchar* suffixes)
{
	FolksStructuredName * self = NULL;
#line 127 "../folks/name-details.vala"
	self = (FolksStructuredName*) g_object_new (object_type, "family-name", family_name, "given-name", given_name, "additional-names", additional_names, "prefixes", prefixes, "suffixes", suffixes, NULL);
#line 124 "../folks/name-details.vala"
	return self;
#line 171 "name-details.c"
}

FolksStructuredName*
folks_structured_name_new (const gchar* family_name,
                           const gchar* given_name,
                           const gchar* additional_names,
                           const gchar* prefixes,
                           const gchar* suffixes)
{
#line 124 "../folks/name-details.vala"
	return folks_structured_name_construct (FOLKS_TYPE_STRUCTURED_NAME, family_name, given_name, additional_names, prefixes, suffixes);
#line 183 "name-details.c"
}

/**
   * Create a StructuredName.
   *
   * Shorthand for the common case of just having the family and given
   * name of a contact. It's equivalent to calling
   * {@link StructuredName.StructuredName} and passing ``null`` for all
   * the other components.
   *
   * @param family_name the family (last) name
   * @param given_name the given (first) name
   * @return a new StructuredName
   *
   * @since 0.3.5
   */
FolksStructuredName*
folks_structured_name_construct_simple (GType object_type,
                                        const gchar* family_name,
                                        const gchar* given_name)
{
	FolksStructuredName * self = NULL;
#line 150 "../folks/name-details.vala"
	self = (FolksStructuredName*) g_object_new (object_type, "family-name", family_name, "given-name", given_name, NULL);
#line 148 "../folks/name-details.vala"
	return self;
#line 210 "name-details.c"
}

FolksStructuredName*
folks_structured_name_new_simple (const gchar* family_name,
                                  const gchar* given_name)
{
#line 148 "../folks/name-details.vala"
	return folks_structured_name_construct_simple (FOLKS_TYPE_STRUCTURED_NAME, family_name, given_name);
#line 219 "name-details.c"
}

/**
   * Whether none of the components is set.
   *
   * @return ``true`` if all the components are the empty string, ``false``
   * otherwise.
   *
   * @since 0.3.5
   */
gboolean
folks_structured_name_is_empty (FolksStructuredName* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean result;
#line 162 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "../folks/name-details.vala"
	_tmp4_ = self->priv->_family_name;
#line 164 "../folks/name-details.vala"
	if (g_strcmp0 (_tmp4_, "") == 0) {
#line 245 "name-details.c"
		const gchar* _tmp5_;
#line 165 "../folks/name-details.vala"
		_tmp5_ = self->priv->_given_name;
#line 165 "../folks/name-details.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
#line 251 "name-details.c"
	} else {
#line 164 "../folks/name-details.vala"
		_tmp3_ = FALSE;
#line 255 "name-details.c"
	}
#line 164 "../folks/name-details.vala"
	if (_tmp3_) {
#line 259 "name-details.c"
		const gchar* _tmp6_;
#line 166 "../folks/name-details.vala"
		_tmp6_ = self->priv->_additional_names;
#line 166 "../folks/name-details.vala"
		_tmp2_ = g_strcmp0 (_tmp6_, "") == 0;
#line 265 "name-details.c"
	} else {
#line 164 "../folks/name-details.vala"
		_tmp2_ = FALSE;
#line 269 "name-details.c"
	}
#line 164 "../folks/name-details.vala"
	if (_tmp2_) {
#line 273 "name-details.c"
		const gchar* _tmp7_;
#line 167 "../folks/name-details.vala"
		_tmp7_ = self->priv->_prefixes;
#line 167 "../folks/name-details.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, "") == 0;
#line 279 "name-details.c"
	} else {
#line 164 "../folks/name-details.vala"
		_tmp1_ = FALSE;
#line 283 "name-details.c"
	}
#line 164 "../folks/name-details.vala"
	if (_tmp1_) {
#line 287 "name-details.c"
		const gchar* _tmp8_;
#line 168 "../folks/name-details.vala"
		_tmp8_ = self->priv->_suffixes;
#line 168 "../folks/name-details.vala"
		_tmp0_ = g_strcmp0 (_tmp8_, "") == 0;
#line 293 "name-details.c"
	} else {
#line 164 "../folks/name-details.vala"
		_tmp0_ = FALSE;
#line 297 "name-details.c"
	}
#line 164 "../folks/name-details.vala"
	result = _tmp0_;
#line 164 "../folks/name-details.vala"
	return result;
#line 303 "name-details.c"
}

/**
   * Whether two StructuredNames are the same.
   *
   * @param other the other structured name to compare with
   * @return ``true`` if all the components are the same, ``false``
   * otherwise.
   *
   * @since 0.5.0
   */
gboolean
folks_structured_name_equal (FolksStructuredName* self,
                             FolksStructuredName* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 180 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 180 "../folks/name-details.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 182 "../folks/name-details.vala"
	_tmp4_ = self->priv->_family_name;
#line 182 "../folks/name-details.vala"
	_tmp5_ = folks_structured_name_get_family_name (other);
#line 182 "../folks/name-details.vala"
	_tmp6_ = _tmp5_;
#line 182 "../folks/name-details.vala"
	if (g_strcmp0 (_tmp4_, _tmp6_) == 0) {
#line 339 "name-details.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 183 "../folks/name-details.vala"
		_tmp7_ = self->priv->_given_name;
#line 183 "../folks/name-details.vala"
		_tmp8_ = folks_structured_name_get_given_name (other);
#line 183 "../folks/name-details.vala"
		_tmp9_ = _tmp8_;
#line 183 "../folks/name-details.vala"
		_tmp3_ = g_strcmp0 (_tmp7_, _tmp9_) == 0;
#line 351 "name-details.c"
	} else {
#line 182 "../folks/name-details.vala"
		_tmp3_ = FALSE;
#line 355 "name-details.c"
	}
#line 182 "../folks/name-details.vala"
	if (_tmp3_) {
#line 359 "name-details.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 184 "../folks/name-details.vala"
		_tmp10_ = self->priv->_additional_names;
#line 184 "../folks/name-details.vala"
		_tmp11_ = folks_structured_name_get_additional_names (other);
#line 184 "../folks/name-details.vala"
		_tmp12_ = _tmp11_;
#line 184 "../folks/name-details.vala"
		_tmp2_ = g_strcmp0 (_tmp10_, _tmp12_) == 0;
#line 371 "name-details.c"
	} else {
#line 182 "../folks/name-details.vala"
		_tmp2_ = FALSE;
#line 375 "name-details.c"
	}
#line 182 "../folks/name-details.vala"
	if (_tmp2_) {
#line 379 "name-details.c"
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 185 "../folks/name-details.vala"
		_tmp13_ = self->priv->_prefixes;
#line 185 "../folks/name-details.vala"
		_tmp14_ = folks_structured_name_get_prefixes (other);
#line 185 "../folks/name-details.vala"
		_tmp15_ = _tmp14_;
#line 185 "../folks/name-details.vala"
		_tmp1_ = g_strcmp0 (_tmp13_, _tmp15_) == 0;
#line 391 "name-details.c"
	} else {
#line 182 "../folks/name-details.vala"
		_tmp1_ = FALSE;
#line 395 "name-details.c"
	}
#line 182 "../folks/name-details.vala"
	if (_tmp1_) {
#line 399 "name-details.c"
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
#line 186 "../folks/name-details.vala"
		_tmp16_ = self->priv->_suffixes;
#line 186 "../folks/name-details.vala"
		_tmp17_ = folks_structured_name_get_suffixes (other);
#line 186 "../folks/name-details.vala"
		_tmp18_ = _tmp17_;
#line 186 "../folks/name-details.vala"
		_tmp0_ = g_strcmp0 (_tmp16_, _tmp18_) == 0;
#line 411 "name-details.c"
	} else {
#line 182 "../folks/name-details.vala"
		_tmp0_ = FALSE;
#line 415 "name-details.c"
	}
#line 182 "../folks/name-details.vala"
	result = _tmp0_;
#line 182 "../folks/name-details.vala"
	return result;
#line 421 "name-details.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 437 "name-details.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 449 "name-details.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 453 "name-details.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 461 "name-details.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 465 "name-details.c"
	}
}

static gchar*
_folks_structured_name_extract_initials (FolksStructuredName* self,
                                         const gchar* names)
{
	GString* output = NULL;
	GString* _tmp0_;
	gboolean at_start_of_word = FALSE;
	gint index = 0;
	gunichar c = 0U;
	GString* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 189 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "../folks/name-details.vala"
	g_return_val_if_fail (names != NULL, NULL);
#line 197 "../folks/name-details.vala"
	_tmp0_ = g_string_new ("");
#line 197 "../folks/name-details.vala"
	output = _tmp0_;
#line 198 "../folks/name-details.vala"
	at_start_of_word = TRUE;
#line 199 "../folks/name-details.vala"
	index = 0;
#line 202 "../folks/name-details.vala"
	while (TRUE) {
#line 496 "name-details.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 202 "../folks/name-details.vala"
		_tmp2_ = string_get_next_char (names, &index, &_tmp1_);
#line 202 "../folks/name-details.vala"
		c = _tmp1_;
#line 202 "../folks/name-details.vala"
		if (!(_tmp2_ == TRUE)) {
#line 202 "../folks/name-details.vala"
			break;
#line 508 "name-details.c"
		}
#line 206 "../folks/name-details.vala"
		if (g_unichar_isspace (c)) {
#line 206 "../folks/name-details.vala"
			_tmp3_ = TRUE;
#line 514 "name-details.c"
		} else {
#line 206 "../folks/name-details.vala"
			_tmp3_ = c == ((gunichar) '-');
#line 518 "name-details.c"
		}
#line 206 "../folks/name-details.vala"
		if (_tmp3_) {
#line 208 "../folks/name-details.vala"
			at_start_of_word = TRUE;
#line 524 "name-details.c"
		} else {
#line 210 "../folks/name-details.vala"
			if (at_start_of_word) {
#line 528 "name-details.c"
				GString* _tmp4_;
#line 212 "../folks/name-details.vala"
				_tmp4_ = output;
#line 212 "../folks/name-details.vala"
				g_string_append_unichar (_tmp4_, c);
#line 213 "../folks/name-details.vala"
				at_start_of_word = FALSE;
#line 536 "name-details.c"
			}
		}
	}
#line 217 "../folks/name-details.vala"
	_tmp5_ = output;
#line 217 "../folks/name-details.vala"
	_tmp6_ = _tmp5_->str;
#line 217 "../folks/name-details.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 217 "../folks/name-details.vala"
	result = _tmp7_;
#line 217 "../folks/name-details.vala"
	_g_string_free0 (output);
#line 217 "../folks/name-details.vala"
	return result;
#line 552 "name-details.c"
}

/**
   * Formatted version of the structured name.
   *
   * @return name formatted according to the current locale
   * @since 0.4.0
   */
gchar*
folks_structured_name_to_string (FolksStructuredName* self)
{
	gchar* name_fmt = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 226 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 268 "../folks/name-details.vala"
	_tmp0_ = g_strdup (_ ("%g%t%m%t%f"));
#line 268 "../folks/name-details.vala"
	name_fmt = _tmp0_;
#line 270 "../folks/name-details.vala"
	_tmp1_ = folks_structured_name_to_string_with_format (self, name_fmt);
#line 270 "../folks/name-details.vala"
	result = _tmp1_;
#line 270 "../folks/name-details.vala"
	_g_free0 (name_fmt);
#line 270 "../folks/name-details.vala"
	return result;
#line 582 "name-details.c"
}

/**
   * Formatted version of the structured name.
   *
   * This allows a custom format string to be specified, using the placeholders
   * described on [[http://lh.2xlibre.net/values/name_fmt/]]. This ``name_fmt``
   * must almost always be translated to the current locale. (Ideally it would
   * be translated to the locale of the persona whose name is being formatted,
   * but such locale information isn’t available.)
   *
   * @param name_fmt format string for the name
   * @return name formatted according to the given format
   * @since 0.9.7
   */
gchar*
folks_structured_name_to_string_with_format (FolksStructuredName* self,
                                             const gchar* name_fmt)
{
	GString* output = NULL;
	GString* _tmp0_;
	gboolean in_field_descriptor = FALSE;
	gboolean field_descriptor_romanised = FALSE;
	gboolean field_descriptor_empty = FALSE;
	gint index = 0;
	gunichar c = 0U;
	GString* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* result;
#line 286 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 286 "../folks/name-details.vala"
	g_return_val_if_fail (name_fmt != NULL, NULL);
#line 288 "../folks/name-details.vala"
	_tmp0_ = g_string_new ("");
#line 288 "../folks/name-details.vala"
	output = _tmp0_;
#line 289 "../folks/name-details.vala"
	in_field_descriptor = FALSE;
#line 290 "../folks/name-details.vala"
	field_descriptor_romanised = FALSE;
#line 291 "../folks/name-details.vala"
	field_descriptor_empty = TRUE;
#line 292 "../folks/name-details.vala"
	index = 0;
#line 295 "../folks/name-details.vala"
	while (TRUE) {
#line 631 "name-details.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 295 "../folks/name-details.vala"
		_tmp2_ = string_get_next_char (name_fmt, &index, &_tmp1_);
#line 295 "../folks/name-details.vala"
		c = _tmp1_;
#line 295 "../folks/name-details.vala"
		if (!(_tmp2_ == TRUE)) {
#line 295 "../folks/name-details.vala"
			break;
#line 642 "name-details.c"
		}
#line 298 "../folks/name-details.vala"
		if (c == ((gunichar) '%')) {
#line 300 "../folks/name-details.vala"
			in_field_descriptor = !in_field_descriptor;
#line 304 "../folks/name-details.vala"
			if (in_field_descriptor) {
#line 306 "../folks/name-details.vala"
				field_descriptor_romanised = FALSE;
#line 307 "../folks/name-details.vala"
				continue;
#line 654 "name-details.c"
			}
		}
#line 311 "../folks/name-details.vala"
		if (in_field_descriptor) {
#line 659 "name-details.c"
			gchar* val = NULL;
			gchar* _tmp3_;
			GString* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
#line 314 "../folks/name-details.vala"
			if (c == ((gunichar) 'R')) {
#line 317 "../folks/name-details.vala"
				field_descriptor_romanised = TRUE;
#line 318 "../folks/name-details.vala"
				continue;
#line 671 "name-details.c"
			}
#line 321 "../folks/name-details.vala"
			_tmp3_ = g_strdup ("");
#line 321 "../folks/name-details.vala"
			val = _tmp3_;
#line 324 "../folks/name-details.vala"
			if (c == ((gunichar) 'f')) {
#line 679 "name-details.c"
				const gchar* _tmp4_;
				gchar* _tmp5_;
#line 326 "../folks/name-details.vala"
				_tmp4_ = self->priv->_family_name;
#line 326 "../folks/name-details.vala"
				_tmp5_ = g_strdup (_tmp4_);
#line 326 "../folks/name-details.vala"
				_g_free0 (val);
#line 326 "../folks/name-details.vala"
				val = _tmp5_;
#line 690 "name-details.c"
			} else {
#line 328 "../folks/name-details.vala"
				if (c == ((gunichar) 'F')) {
#line 694 "name-details.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 330 "../folks/name-details.vala"
					_tmp6_ = self->priv->_family_name;
#line 330 "../folks/name-details.vala"
					_tmp7_ = g_utf8_strup (_tmp6_, (gssize) -1);
#line 330 "../folks/name-details.vala"
					_g_free0 (val);
#line 330 "../folks/name-details.vala"
					val = _tmp7_;
#line 705 "name-details.c"
				} else {
#line 332 "../folks/name-details.vala"
					if (c == ((gunichar) 'g')) {
#line 709 "name-details.c"
						const gchar* _tmp8_;
						gchar* _tmp9_;
#line 334 "../folks/name-details.vala"
						_tmp8_ = self->priv->_given_name;
#line 334 "../folks/name-details.vala"
						_tmp9_ = g_strdup (_tmp8_);
#line 334 "../folks/name-details.vala"
						_g_free0 (val);
#line 334 "../folks/name-details.vala"
						val = _tmp9_;
#line 720 "name-details.c"
					} else {
#line 336 "../folks/name-details.vala"
						if (c == ((gunichar) 'G')) {
#line 724 "name-details.c"
							const gchar* _tmp10_;
							gchar* _tmp11_;
#line 338 "../folks/name-details.vala"
							_tmp10_ = self->priv->_given_name;
#line 338 "../folks/name-details.vala"
							_tmp11_ = _folks_structured_name_extract_initials (self, _tmp10_);
#line 338 "../folks/name-details.vala"
							_g_free0 (val);
#line 338 "../folks/name-details.vala"
							val = _tmp11_;
#line 735 "name-details.c"
						} else {
#line 340 "../folks/name-details.vala"
							if (c == ((gunichar) 'm')) {
#line 739 "name-details.c"
								const gchar* _tmp12_;
								gchar* _tmp13_;
#line 342 "../folks/name-details.vala"
								_tmp12_ = self->priv->_additional_names;
#line 342 "../folks/name-details.vala"
								_tmp13_ = g_strdup (_tmp12_);
#line 342 "../folks/name-details.vala"
								_g_free0 (val);
#line 342 "../folks/name-details.vala"
								val = _tmp13_;
#line 750 "name-details.c"
							} else {
#line 344 "../folks/name-details.vala"
								if (c == ((gunichar) 'M')) {
#line 754 "name-details.c"
									const gchar* _tmp14_;
									gchar* _tmp15_;
#line 346 "../folks/name-details.vala"
									_tmp14_ = self->priv->_additional_names;
#line 346 "../folks/name-details.vala"
									_tmp15_ = _folks_structured_name_extract_initials (self, _tmp14_);
#line 346 "../folks/name-details.vala"
									_g_free0 (val);
#line 346 "../folks/name-details.vala"
									val = _tmp15_;
#line 765 "name-details.c"
								} else {
									gboolean _tmp16_ = FALSE;
									gboolean _tmp17_ = FALSE;
#line 348 "../folks/name-details.vala"
									if (c == ((gunichar) 's')) {
#line 348 "../folks/name-details.vala"
										_tmp17_ = TRUE;
#line 773 "name-details.c"
									} else {
#line 348 "../folks/name-details.vala"
										_tmp17_ = c == ((gunichar) 'S');
#line 777 "name-details.c"
									}
#line 348 "../folks/name-details.vala"
									if (_tmp17_) {
#line 348 "../folks/name-details.vala"
										_tmp16_ = TRUE;
#line 783 "name-details.c"
									} else {
#line 348 "../folks/name-details.vala"
										_tmp16_ = c == ((gunichar) 'd');
#line 787 "name-details.c"
									}
#line 348 "../folks/name-details.vala"
									if (_tmp16_) {
#line 791 "name-details.c"
										const gchar* _tmp18_;
										gchar* _tmp19_;
#line 351 "../folks/name-details.vala"
										_tmp18_ = self->priv->_prefixes;
#line 351 "../folks/name-details.vala"
										_tmp19_ = g_strdup (_tmp18_);
#line 351 "../folks/name-details.vala"
										_g_free0 (val);
#line 351 "../folks/name-details.vala"
										val = _tmp19_;
#line 802 "name-details.c"
									} else {
#line 353 "../folks/name-details.vala"
										if (c == ((gunichar) 't')) {
#line 806 "name-details.c"
											const gchar* _tmp20_ = NULL;
											gchar* _tmp21_;
#line 355 "../folks/name-details.vala"
											if (field_descriptor_empty == FALSE) {
#line 355 "../folks/name-details.vala"
												_tmp20_ = " ";
#line 813 "name-details.c"
											} else {
#line 355 "../folks/name-details.vala"
												_tmp20_ = "";
#line 817 "name-details.c"
											}
#line 355 "../folks/name-details.vala"
											_tmp21_ = g_strdup (_tmp20_);
#line 355 "../folks/name-details.vala"
											_g_free0 (val);
#line 355 "../folks/name-details.vala"
											val = _tmp21_;
#line 825 "name-details.c"
										} else {
											gboolean _tmp22_ = FALSE;
											gboolean _tmp23_ = FALSE;
#line 357 "../folks/name-details.vala"
											if (c == ((gunichar) 'l')) {
#line 357 "../folks/name-details.vala"
												_tmp23_ = TRUE;
#line 833 "name-details.c"
											} else {
#line 357 "../folks/name-details.vala"
												_tmp23_ = c == ((gunichar) 'o');
#line 837 "name-details.c"
											}
#line 357 "../folks/name-details.vala"
											if (_tmp23_) {
#line 357 "../folks/name-details.vala"
												_tmp22_ = TRUE;
#line 843 "name-details.c"
											} else {
#line 357 "../folks/name-details.vala"
												_tmp22_ = c == ((gunichar) 'p');
#line 847 "name-details.c"
											}
#line 357 "../folks/name-details.vala"
											if (_tmp22_) {
#line 851 "name-details.c"
												gchar* _tmp24_;
#line 360 "../folks/name-details.vala"
												_tmp24_ = g_strdup ("");
#line 360 "../folks/name-details.vala"
												_g_free0 (val);
#line 360 "../folks/name-details.vala"
												val = _tmp24_;
#line 859 "name-details.c"
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 364 "../folks/name-details.vala"
			_tmp25_ = output;
#line 364 "../folks/name-details.vala"
			_tmp26_ = val;
#line 364 "../folks/name-details.vala"
			g_string_append (_tmp25_, _tmp26_);
#line 365 "../folks/name-details.vala"
			in_field_descriptor = FALSE;
#line 366 "../folks/name-details.vala"
			_tmp27_ = val;
#line 366 "../folks/name-details.vala"
			field_descriptor_empty = g_strcmp0 (_tmp27_, "") == 0;
#line 311 "../folks/name-details.vala"
			_g_free0 (val);
#line 883 "name-details.c"
		} else {
			GString* _tmp28_;
#line 371 "../folks/name-details.vala"
			_tmp28_ = output;
#line 371 "../folks/name-details.vala"
			g_string_append_unichar (_tmp28_, c);
#line 890 "name-details.c"
		}
	}
#line 375 "../folks/name-details.vala"
	_tmp29_ = output;
#line 375 "../folks/name-details.vala"
	_tmp30_ = _tmp29_->str;
#line 375 "../folks/name-details.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 375 "../folks/name-details.vala"
	result = _tmp31_;
#line 375 "../folks/name-details.vala"
	_g_string_free0 (output);
#line 375 "../folks/name-details.vala"
	return result;
#line 905 "name-details.c"
}

const gchar*
folks_structured_name_get_family_name (FolksStructuredName* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../folks/name-details.vala"
	_tmp0_ = self->priv->_family_name;
#line 48 "../folks/name-details.vala"
	result = _tmp0_;
#line 48 "../folks/name-details.vala"
	return result;
#line 921 "name-details.c"
}

void
folks_structured_name_set_family_name (FolksStructuredName* self,
                                       const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 49 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 49 "../folks/name-details.vala"
	if (value != NULL) {
#line 49 "../folks/name-details.vala"
		_tmp0_ = value;
#line 936 "name-details.c"
	} else {
#line 49 "../folks/name-details.vala"
		_tmp0_ = "";
#line 940 "name-details.c"
	}
#line 49 "../folks/name-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 49 "../folks/name-details.vala"
	_g_free0 (self->priv->_family_name);
#line 49 "../folks/name-details.vala"
	self->priv->_family_name = _tmp1_;
#line 49 "../folks/name-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_FAMILY_NAME_PROPERTY]);
#line 950 "name-details.c"
}

const gchar*
folks_structured_name_get_given_name (FolksStructuredName* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 62 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../folks/name-details.vala"
	_tmp0_ = self->priv->_given_name;
#line 62 "../folks/name-details.vala"
	result = _tmp0_;
#line 62 "../folks/name-details.vala"
	return result;
#line 966 "name-details.c"
}

void
folks_structured_name_set_given_name (FolksStructuredName* self,
                                      const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 63 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 63 "../folks/name-details.vala"
	if (value != NULL) {
#line 63 "../folks/name-details.vala"
		_tmp0_ = value;
#line 981 "name-details.c"
	} else {
#line 63 "../folks/name-details.vala"
		_tmp0_ = "";
#line 985 "name-details.c"
	}
#line 63 "../folks/name-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 63 "../folks/name-details.vala"
	_g_free0 (self->priv->_given_name);
#line 63 "../folks/name-details.vala"
	self->priv->_given_name = _tmp1_;
#line 63 "../folks/name-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_GIVEN_NAME_PROPERTY]);
#line 995 "name-details.c"
}

const gchar*
folks_structured_name_get_additional_names (FolksStructuredName* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 77 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../folks/name-details.vala"
	_tmp0_ = self->priv->_additional_names;
#line 77 "../folks/name-details.vala"
	result = _tmp0_;
#line 77 "../folks/name-details.vala"
	return result;
#line 1011 "name-details.c"
}

void
folks_structured_name_set_additional_names (FolksStructuredName* self,
                                            const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 78 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 78 "../folks/name-details.vala"
	if (value != NULL) {
#line 78 "../folks/name-details.vala"
		_tmp0_ = value;
#line 1026 "name-details.c"
	} else {
#line 78 "../folks/name-details.vala"
		_tmp0_ = "";
#line 1030 "name-details.c"
	}
#line 78 "../folks/name-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 78 "../folks/name-details.vala"
	_g_free0 (self->priv->_additional_names);
#line 78 "../folks/name-details.vala"
	self->priv->_additional_names = _tmp1_;
#line 78 "../folks/name-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_ADDITIONAL_NAMES_PROPERTY]);
#line 1040 "name-details.c"
}

const gchar*
folks_structured_name_get_prefixes (FolksStructuredName* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 92 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "../folks/name-details.vala"
	_tmp0_ = self->priv->_prefixes;
#line 92 "../folks/name-details.vala"
	result = _tmp0_;
#line 92 "../folks/name-details.vala"
	return result;
#line 1056 "name-details.c"
}

void
folks_structured_name_set_prefixes (FolksStructuredName* self,
                                    const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 93 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 93 "../folks/name-details.vala"
	if (value != NULL) {
#line 93 "../folks/name-details.vala"
		_tmp0_ = value;
#line 1071 "name-details.c"
	} else {
#line 93 "../folks/name-details.vala"
		_tmp0_ = "";
#line 1075 "name-details.c"
	}
#line 93 "../folks/name-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 93 "../folks/name-details.vala"
	_g_free0 (self->priv->_prefixes);
#line 93 "../folks/name-details.vala"
	self->priv->_prefixes = _tmp1_;
#line 93 "../folks/name-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_PREFIXES_PROPERTY]);
#line 1085 "name-details.c"
}

const gchar*
folks_structured_name_get_suffixes (FolksStructuredName* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 106 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../folks/name-details.vala"
	_tmp0_ = self->priv->_suffixes;
#line 106 "../folks/name-details.vala"
	result = _tmp0_;
#line 106 "../folks/name-details.vala"
	return result;
#line 1101 "name-details.c"
}

void
folks_structured_name_set_suffixes (FolksStructuredName* self,
                                    const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 107 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 107 "../folks/name-details.vala"
	if (value != NULL) {
#line 107 "../folks/name-details.vala"
		_tmp0_ = value;
#line 1116 "name-details.c"
	} else {
#line 107 "../folks/name-details.vala"
		_tmp0_ = "";
#line 1120 "name-details.c"
	}
#line 107 "../folks/name-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 107 "../folks/name-details.vala"
	_g_free0 (self->priv->_suffixes);
#line 107 "../folks/name-details.vala"
	self->priv->_suffixes = _tmp1_;
#line 107 "../folks/name-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_SUFFIXES_PROPERTY]);
#line 1130 "name-details.c"
}

static void
folks_structured_name_class_init (FolksStructuredNameClass * klass,
                                  gpointer klass_data)
{
#line 36 "../folks/name-details.vala"
	folks_structured_name_parent_class = g_type_class_peek_parent (klass);
#line 36 "../folks/name-details.vala"
	g_type_class_adjust_private_offset (klass, &FolksStructuredName_private_offset);
#line 36 "../folks/name-details.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_structured_name_get_property;
#line 36 "../folks/name-details.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folks_structured_name_set_property;
#line 36 "../folks/name-details.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_structured_name_finalize;
#line 1147 "name-details.c"
	/**
	   * The family name.
	   *
	   * The family name (also known as surname or last name) of a contact.
	   *
	   * @since 0.3.5
	   */
#line 36 "../folks/name-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_STRUCTURED_NAME_FAMILY_NAME_PROPERTY, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_FAMILY_NAME_PROPERTY] = g_param_spec_string ("family-name", "family-name", "family-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1157 "name-details.c"
	/**
	   * The given name.
	   *
	   * The family name (also known as first name) of a contact.
	   *
	   * @since 0.3.5
	   */
#line 36 "../folks/name-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_STRUCTURED_NAME_GIVEN_NAME_PROPERTY, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_GIVEN_NAME_PROPERTY] = g_param_spec_string ("given-name", "given-name", "given-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1167 "name-details.c"
	/**
	   * Additional names.
	   *
	   * The additional names of a contact, for instance the contact's
	   * middle name.
	   *
	   * @since 0.3.5
	   */
#line 36 "../folks/name-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_STRUCTURED_NAME_ADDITIONAL_NAMES_PROPERTY, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_ADDITIONAL_NAMES_PROPERTY] = g_param_spec_string ("additional-names", "additional-names", "additional-names", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1178 "name-details.c"
	/**
	   * The prefixes of a name.
	   *
	   * The prefixes used in front of the name (for instance "Mr", "Mrs",
	   * "Doctor" or honorific titles).
	   *
	   * @since 0.3.5
	   */
#line 36 "../folks/name-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_STRUCTURED_NAME_PREFIXES_PROPERTY, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_PREFIXES_PROPERTY] = g_param_spec_string ("prefixes", "prefixes", "prefixes", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1189 "name-details.c"
	/**
	   * The suffixes of a name.
	   *
	   * The suffixes used after a name (for instance "PhD" or "Junior").
	   *
	   * @since 0.3.5
	   */
#line 36 "../folks/name-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_STRUCTURED_NAME_SUFFIXES_PROPERTY, folks_structured_name_properties[FOLKS_STRUCTURED_NAME_SUFFIXES_PROPERTY] = g_param_spec_string ("suffixes", "suffixes", "suffixes", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1199 "name-details.c"
}

static void
folks_structured_name_instance_init (FolksStructuredName * self,
                                     gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 36 "../folks/name-details.vala"
	self->priv = folks_structured_name_get_instance_private (self);
#line 38 "../folks/name-details.vala"
	_tmp0_ = g_strdup ("");
#line 38 "../folks/name-details.vala"
	self->priv->_family_name = _tmp0_;
#line 52 "../folks/name-details.vala"
	_tmp1_ = g_strdup ("");
#line 52 "../folks/name-details.vala"
	self->priv->_given_name = _tmp1_;
#line 66 "../folks/name-details.vala"
	_tmp2_ = g_strdup ("");
#line 66 "../folks/name-details.vala"
	self->priv->_additional_names = _tmp2_;
#line 81 "../folks/name-details.vala"
	_tmp3_ = g_strdup ("");
#line 81 "../folks/name-details.vala"
	self->priv->_prefixes = _tmp3_;
#line 96 "../folks/name-details.vala"
	_tmp4_ = g_strdup ("");
#line 96 "../folks/name-details.vala"
	self->priv->_suffixes = _tmp4_;
#line 1233 "name-details.c"
}

static void
folks_structured_name_finalize (GObject * obj)
{
	FolksStructuredName * self;
#line 36 "../folks/name-details.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_STRUCTURED_NAME, FolksStructuredName);
#line 38 "../folks/name-details.vala"
	_g_free0 (self->priv->_family_name);
#line 52 "../folks/name-details.vala"
	_g_free0 (self->priv->_given_name);
#line 66 "../folks/name-details.vala"
	_g_free0 (self->priv->_additional_names);
#line 81 "../folks/name-details.vala"
	_g_free0 (self->priv->_prefixes);
#line 96 "../folks/name-details.vala"
	_g_free0 (self->priv->_suffixes);
#line 36 "../folks/name-details.vala"
	G_OBJECT_CLASS (folks_structured_name_parent_class)->finalize (obj);
#line 1254 "name-details.c"
}

/**
 * Structured name representation for human names.
 *
 * Represents a full name split in its constituent parts (given name,
 * family name, etc.). This structure corresponds to the "N" field in
 * vCards. The parts of the name are never ``null``: an empty string
 * indicates that a property is not set.
 *
 * @since 0.3.5
 */
static GType
folks_structured_name_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksStructuredNameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_structured_name_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksStructuredName), 0, (GInstanceInitFunc) folks_structured_name_instance_init, NULL };
	GType folks_structured_name_type_id;
	folks_structured_name_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksStructuredName", &g_define_type_info, 0);
	FolksStructuredName_private_offset = g_type_add_instance_private (folks_structured_name_type_id, sizeof (FolksStructuredNamePrivate));
	return folks_structured_name_type_id;
}

GType
folks_structured_name_get_type (void)
{
	static volatile gsize folks_structured_name_type_id__once = 0;
	if (g_once_init_enter (&folks_structured_name_type_id__once)) {
		GType folks_structured_name_type_id;
		folks_structured_name_type_id = folks_structured_name_get_type_once ();
		g_once_init_leave (&folks_structured_name_type_id__once, folks_structured_name_type_id);
	}
	return folks_structured_name_type_id__once;
}

static void
_vala_folks_structured_name_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	FolksStructuredName * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_STRUCTURED_NAME, FolksStructuredName);
#line 36 "../folks/name-details.vala"
	switch (property_id) {
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_FAMILY_NAME_PROPERTY:
#line 36 "../folks/name-details.vala"
		g_value_set_string (value, folks_structured_name_get_family_name (self));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_GIVEN_NAME_PROPERTY:
#line 36 "../folks/name-details.vala"
		g_value_set_string (value, folks_structured_name_get_given_name (self));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_ADDITIONAL_NAMES_PROPERTY:
#line 36 "../folks/name-details.vala"
		g_value_set_string (value, folks_structured_name_get_additional_names (self));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_PREFIXES_PROPERTY:
#line 36 "../folks/name-details.vala"
		g_value_set_string (value, folks_structured_name_get_prefixes (self));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_SUFFIXES_PROPERTY:
#line 36 "../folks/name-details.vala"
		g_value_set_string (value, folks_structured_name_get_suffixes (self));
#line 36 "../folks/name-details.vala"
		break;
#line 1329 "name-details.c"
		default:
#line 36 "../folks/name-details.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../folks/name-details.vala"
		break;
#line 1335 "name-details.c"
	}
}

static void
_vala_folks_structured_name_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	FolksStructuredName * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_STRUCTURED_NAME, FolksStructuredName);
#line 36 "../folks/name-details.vala"
	switch (property_id) {
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_FAMILY_NAME_PROPERTY:
#line 36 "../folks/name-details.vala"
		folks_structured_name_set_family_name (self, g_value_get_string (value));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_GIVEN_NAME_PROPERTY:
#line 36 "../folks/name-details.vala"
		folks_structured_name_set_given_name (self, g_value_get_string (value));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_ADDITIONAL_NAMES_PROPERTY:
#line 36 "../folks/name-details.vala"
		folks_structured_name_set_additional_names (self, g_value_get_string (value));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_PREFIXES_PROPERTY:
#line 36 "../folks/name-details.vala"
		folks_structured_name_set_prefixes (self, g_value_get_string (value));
#line 36 "../folks/name-details.vala"
		break;
#line 36 "../folks/name-details.vala"
		case FOLKS_STRUCTURED_NAME_SUFFIXES_PROPERTY:
#line 36 "../folks/name-details.vala"
		folks_structured_name_set_suffixes (self, g_value_get_string (value));
#line 36 "../folks/name-details.vala"
		break;
#line 1379 "name-details.c"
		default:
#line 36 "../folks/name-details.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../folks/name-details.vala"
		break;
#line 1385 "name-details.c"
	}
}

static void
folks_name_details_real_change_structured_name_data_free (gpointer _data)
{
	FolksNameDetailsChangeStructuredNameData* _data_;
	_data_ = _data;
#line 385 "../folks/name-details.vala"
	_g_object_unref0 (_data_->name);
#line 385 "../folks/name-details.vala"
	_g_object_unref0 (_data_->self);
#line 385 "../folks/name-details.vala"
	g_slice_free (FolksNameDetailsChangeStructuredNameData, _data_);
#line 1400 "name-details.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 385 "../folks/name-details.vala"
	return self ? g_object_ref (self) : NULL;
#line 1408 "name-details.c"
}

static void
folks_name_details_real_change_structured_name (FolksNameDetails* self,
                                                FolksStructuredName* name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	FolksNameDetailsChangeStructuredNameData* _data_;
	FolksNameDetails* _tmp0_;
	FolksStructuredName* _tmp1_;
#line 385 "../folks/name-details.vala"
	_data_ = g_slice_new0 (FolksNameDetailsChangeStructuredNameData);
#line 385 "../folks/name-details.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 385 "../folks/name-details.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_name_details_real_change_structured_name_data_free);
#line 385 "../folks/name-details.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 385 "../folks/name-details.vala"
	_data_->self = _tmp0_;
#line 385 "../folks/name-details.vala"
	_tmp1_ = _g_object_ref0 (name);
#line 385 "../folks/name-details.vala"
	_g_object_unref0 (_data_->name);
#line 385 "../folks/name-details.vala"
	_data_->name = _tmp1_;
#line 385 "../folks/name-details.vala"
	folks_name_details_real_change_structured_name_co (_data_);
#line 1438 "name-details.c"
}

static void
folks_name_details_real_change_structured_name_finish (FolksNameDetails* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	FolksNameDetailsChangeStructuredNameData* _data_;
#line 385 "../folks/name-details.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 385 "../folks/name-details.vala"
	if (NULL == _data_) {
#line 385 "../folks/name-details.vala"
		return;
#line 1453 "name-details.c"
	}
}

/**
   * Change the contact's structured name.
   *
   * It's preferred to call this rather than setting
   * {@link NameDetails.structured_name} directly, as this method gives error
   * notification and will only return once the name has been written to the
   * relevant backing store (or the operation's failed).
   *
   * @param name the structured name (``null`` to unset it)
   * @throws PropertyError if setting the structured name failed
   * @since 0.6.2
   */
static gboolean
folks_name_details_real_change_structured_name_co (FolksNameDetailsChangeStructuredNameData* _data_)
{
#line 412 "../folks/name-details.vala"
	switch (_data_->_state_) {
#line 412 "../folks/name-details.vala"
		case 0:
#line 1476 "name-details.c"
		goto _state_0;
		default:
#line 412 "../folks/name-details.vala"
		g_assert_not_reached ();
#line 1481 "name-details.c"
	}
	_state_0:
#line 416 "../folks/name-details.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Structured name is not writeable on this contact."));
#line 416 "../folks/name-details.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 416 "../folks/name-details.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 416 "../folks/name-details.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 416 "../folks/name-details.vala"
		g_object_unref (_data_->_async_result);
#line 416 "../folks/name-details.vala"
		return FALSE;
#line 1496 "name-details.c"
	} else {
#line 416 "../folks/name-details.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 416 "../folks/name-details.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 416 "../folks/name-details.vala"
		g_object_unref (_data_->_async_result);
#line 416 "../folks/name-details.vala"
		return FALSE;
#line 1506 "name-details.c"
	}
#line 412 "../folks/name-details.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 412 "../folks/name-details.vala"
	if (_data_->_state_ != 0) {
#line 412 "../folks/name-details.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 412 "../folks/name-details.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1516 "name-details.c"
		}
	}
#line 412 "../folks/name-details.vala"
	g_object_unref (_data_->_async_result);
#line 412 "../folks/name-details.vala"
	return FALSE;
#line 1523 "name-details.c"
}

void
folks_name_details_change_structured_name (FolksNameDetails* self,
                                           FolksStructuredName* name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	FolksNameDetailsIface* _iface_;
#line 385 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 385 "../folks/name-details.vala"
	if (_iface_->change_structured_name) {
#line 385 "../folks/name-details.vala"
		_iface_->change_structured_name (self, name, _callback_, _user_data_);
#line 1539 "name-details.c"
	}
}

void
folks_name_details_change_structured_name_finish (FolksNameDetails* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	FolksNameDetailsIface* _iface_;
#line 385 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 385 "../folks/name-details.vala"
	if (_iface_->change_structured_name_finish) {
#line 385 "../folks/name-details.vala"
		_iface_->change_structured_name_finish (self, _res_, error);
#line 1555 "name-details.c"
	}
}

static void
folks_name_details_real_change_full_name_data_free (gpointer _data)
{
	FolksNameDetailsChangeFullNameData* _data_;
	_data_ = _data;
#line 385 "../folks/name-details.vala"
	_g_free0 (_data_->full_name);
#line 385 "../folks/name-details.vala"
	_g_object_unref0 (_data_->self);
#line 385 "../folks/name-details.vala"
	g_slice_free (FolksNameDetailsChangeFullNameData, _data_);
#line 1570 "name-details.c"
}

static void
folks_name_details_real_change_full_name (FolksNameDetails* self,
                                          const gchar* full_name,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	FolksNameDetailsChangeFullNameData* _data_;
	FolksNameDetails* _tmp0_;
	gchar* _tmp1_;
#line 385 "../folks/name-details.vala"
	g_return_if_fail (full_name != NULL);
#line 385 "../folks/name-details.vala"
	_data_ = g_slice_new0 (FolksNameDetailsChangeFullNameData);
#line 385 "../folks/name-details.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 385 "../folks/name-details.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_name_details_real_change_full_name_data_free);
#line 385 "../folks/name-details.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 385 "../folks/name-details.vala"
	_data_->self = _tmp0_;
#line 385 "../folks/name-details.vala"
	_tmp1_ = g_strdup (full_name);
#line 385 "../folks/name-details.vala"
	_g_free0 (_data_->full_name);
#line 385 "../folks/name-details.vala"
	_data_->full_name = _tmp1_;
#line 385 "../folks/name-details.vala"
	folks_name_details_real_change_full_name_co (_data_);
#line 1602 "name-details.c"
}

static void
folks_name_details_real_change_full_name_finish (FolksNameDetails* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	FolksNameDetailsChangeFullNameData* _data_;
#line 385 "../folks/name-details.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 385 "../folks/name-details.vala"
	if (NULL == _data_) {
#line 385 "../folks/name-details.vala"
		return;
#line 1617 "name-details.c"
	}
}

/**
   * Change the contact's full name.
   *
   * It's preferred to call this rather than setting
   * {@link NameDetails.full_name} directly, as this method gives error
   * notification and will only return once the name has been written to the
   * relevant backing store (or the operation's failed).
   *
   * @param full_name the full name (empty string to unset it)
   * @throws PropertyError if setting the full name failed
   * @since 0.6.2
   */
static gboolean
folks_name_details_real_change_full_name_co (FolksNameDetailsChangeFullNameData* _data_)
{
#line 449 "../folks/name-details.vala"
	switch (_data_->_state_) {
#line 449 "../folks/name-details.vala"
		case 0:
#line 1640 "name-details.c"
		goto _state_0;
		default:
#line 449 "../folks/name-details.vala"
		g_assert_not_reached ();
#line 1645 "name-details.c"
	}
	_state_0:
#line 453 "../folks/name-details.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Full name is not writeable on this contact."));
#line 453 "../folks/name-details.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 453 "../folks/name-details.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 453 "../folks/name-details.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 453 "../folks/name-details.vala"
		g_object_unref (_data_->_async_result);
#line 453 "../folks/name-details.vala"
		return FALSE;
#line 1660 "name-details.c"
	} else {
#line 453 "../folks/name-details.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 453 "../folks/name-details.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 453 "../folks/name-details.vala"
		g_object_unref (_data_->_async_result);
#line 453 "../folks/name-details.vala"
		return FALSE;
#line 1670 "name-details.c"
	}
#line 449 "../folks/name-details.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 449 "../folks/name-details.vala"
	if (_data_->_state_ != 0) {
#line 449 "../folks/name-details.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 449 "../folks/name-details.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1680 "name-details.c"
		}
	}
#line 449 "../folks/name-details.vala"
	g_object_unref (_data_->_async_result);
#line 449 "../folks/name-details.vala"
	return FALSE;
#line 1687 "name-details.c"
}

void
folks_name_details_change_full_name (FolksNameDetails* self,
                                     const gchar* full_name,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	FolksNameDetailsIface* _iface_;
#line 385 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 385 "../folks/name-details.vala"
	if (_iface_->change_full_name) {
#line 385 "../folks/name-details.vala"
		_iface_->change_full_name (self, full_name, _callback_, _user_data_);
#line 1703 "name-details.c"
	}
}

void
folks_name_details_change_full_name_finish (FolksNameDetails* self,
                                            GAsyncResult* _res_,
                                            GError** error)
{
	FolksNameDetailsIface* _iface_;
#line 385 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 385 "../folks/name-details.vala"
	if (_iface_->change_full_name_finish) {
#line 385 "../folks/name-details.vala"
		_iface_->change_full_name_finish (self, _res_, error);
#line 1719 "name-details.c"
	}
}

static void
folks_name_details_real_change_nickname_data_free (gpointer _data)
{
	FolksNameDetailsChangeNicknameData* _data_;
	_data_ = _data;
#line 385 "../folks/name-details.vala"
	_g_free0 (_data_->nickname);
#line 385 "../folks/name-details.vala"
	_g_object_unref0 (_data_->self);
#line 385 "../folks/name-details.vala"
	g_slice_free (FolksNameDetailsChangeNicknameData, _data_);
#line 1734 "name-details.c"
}

static void
folks_name_details_real_change_nickname (FolksNameDetails* self,
                                         const gchar* nickname,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	FolksNameDetailsChangeNicknameData* _data_;
	FolksNameDetails* _tmp0_;
	gchar* _tmp1_;
#line 385 "../folks/name-details.vala"
	g_return_if_fail (nickname != NULL);
#line 385 "../folks/name-details.vala"
	_data_ = g_slice_new0 (FolksNameDetailsChangeNicknameData);
#line 385 "../folks/name-details.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 385 "../folks/name-details.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_name_details_real_change_nickname_data_free);
#line 385 "../folks/name-details.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 385 "../folks/name-details.vala"
	_data_->self = _tmp0_;
#line 385 "../folks/name-details.vala"
	_tmp1_ = g_strdup (nickname);
#line 385 "../folks/name-details.vala"
	_g_free0 (_data_->nickname);
#line 385 "../folks/name-details.vala"
	_data_->nickname = _tmp1_;
#line 385 "../folks/name-details.vala"
	folks_name_details_real_change_nickname_co (_data_);
#line 1766 "name-details.c"
}

static void
folks_name_details_real_change_nickname_finish (FolksNameDetails* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	FolksNameDetailsChangeNicknameData* _data_;
#line 385 "../folks/name-details.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 385 "../folks/name-details.vala"
	if (NULL == _data_) {
#line 385 "../folks/name-details.vala"
		return;
#line 1781 "name-details.c"
	}
}

/**
   * Change the contact's nickname.
   *
   * It's preferred to call this rather than setting
   * {@link NameDetails.nickname} directly, as this method gives error
   * notification and will only return once the name has been written to the
   * relevant backing store (or the operation's failed).
   *
   * @param nickname the nickname (empty string to unset it)
   * @throws PropertyError if setting the nickname failed
   * @since 0.6.2
   */
static gboolean
folks_name_details_real_change_nickname_co (FolksNameDetailsChangeNicknameData* _data_)
{
#line 487 "../folks/name-details.vala"
	switch (_data_->_state_) {
#line 487 "../folks/name-details.vala"
		case 0:
#line 1804 "name-details.c"
		goto _state_0;
		default:
#line 487 "../folks/name-details.vala"
		g_assert_not_reached ();
#line 1809 "name-details.c"
	}
	_state_0:
#line 491 "../folks/name-details.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Nickname is not writeable on this contact."));
#line 491 "../folks/name-details.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 491 "../folks/name-details.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 491 "../folks/name-details.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 491 "../folks/name-details.vala"
		g_object_unref (_data_->_async_result);
#line 491 "../folks/name-details.vala"
		return FALSE;
#line 1824 "name-details.c"
	} else {
#line 491 "../folks/name-details.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 491 "../folks/name-details.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 491 "../folks/name-details.vala"
		g_object_unref (_data_->_async_result);
#line 491 "../folks/name-details.vala"
		return FALSE;
#line 1834 "name-details.c"
	}
#line 487 "../folks/name-details.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 487 "../folks/name-details.vala"
	if (_data_->_state_ != 0) {
#line 487 "../folks/name-details.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 487 "../folks/name-details.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1844 "name-details.c"
		}
	}
#line 487 "../folks/name-details.vala"
	g_object_unref (_data_->_async_result);
#line 487 "../folks/name-details.vala"
	return FALSE;
#line 1851 "name-details.c"
}

void
folks_name_details_change_nickname (FolksNameDetails* self,
                                    const gchar* nickname,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FolksNameDetailsIface* _iface_;
#line 385 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 385 "../folks/name-details.vala"
	if (_iface_->change_nickname) {
#line 385 "../folks/name-details.vala"
		_iface_->change_nickname (self, nickname, _callback_, _user_data_);
#line 1867 "name-details.c"
	}
}

void
folks_name_details_change_nickname_finish (FolksNameDetails* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	FolksNameDetailsIface* _iface_;
#line 385 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 385 "../folks/name-details.vala"
	if (_iface_->change_nickname_finish) {
#line 385 "../folks/name-details.vala"
		_iface_->change_nickname_finish (self, _res_, error);
#line 1883 "name-details.c"
	}
}

FolksStructuredName*
folks_name_details_get_structured_name (FolksNameDetails* self)
{
	FolksNameDetailsIface* _iface_;
#line 398 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 398 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 398 "../folks/name-details.vala"
	if (_iface_->get_structured_name) {
#line 398 "../folks/name-details.vala"
		return _iface_->get_structured_name (self);
#line 1899 "name-details.c"
	}
#line 398 "../folks/name-details.vala"
	return NULL;
#line 1903 "name-details.c"
}

void
folks_name_details_set_structured_name (FolksNameDetails* self,
                                        FolksStructuredName* value)
{
	FolksNameDetailsIface* _iface_;
#line 398 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 398 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 398 "../folks/name-details.vala"
	if (_iface_->set_structured_name) {
#line 398 "../folks/name-details.vala"
		_iface_->set_structured_name (self, value);
#line 1919 "name-details.c"
	}
}

const gchar*
folks_name_details_get_full_name (FolksNameDetails* self)
{
	FolksNameDetailsIface* _iface_;
#line 435 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 435 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 435 "../folks/name-details.vala"
	if (_iface_->get_full_name) {
#line 435 "../folks/name-details.vala"
		return _iface_->get_full_name (self);
#line 1935 "name-details.c"
	}
#line 435 "../folks/name-details.vala"
	return NULL;
#line 1939 "name-details.c"
}

void
folks_name_details_set_full_name (FolksNameDetails* self,
                                  const gchar* value)
{
	FolksNameDetailsIface* _iface_;
#line 435 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 435 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 435 "../folks/name-details.vala"
	if (_iface_->set_full_name) {
#line 435 "../folks/name-details.vala"
		_iface_->set_full_name (self, value);
#line 1955 "name-details.c"
	}
}

const gchar*
folks_name_details_get_nickname (FolksNameDetails* self)
{
	FolksNameDetailsIface* _iface_;
#line 473 "../folks/name-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 473 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 473 "../folks/name-details.vala"
	if (_iface_->get_nickname) {
#line 473 "../folks/name-details.vala"
		return _iface_->get_nickname (self);
#line 1971 "name-details.c"
	}
#line 473 "../folks/name-details.vala"
	return NULL;
#line 1975 "name-details.c"
}

void
folks_name_details_set_nickname (FolksNameDetails* self,
                                 const gchar* value)
{
	FolksNameDetailsIface* _iface_;
#line 473 "../folks/name-details.vala"
	g_return_if_fail (self != NULL);
#line 473 "../folks/name-details.vala"
	_iface_ = FOLKS_NAME_DETAILS_GET_INTERFACE (self);
#line 473 "../folks/name-details.vala"
	if (_iface_->set_nickname) {
#line 473 "../folks/name-details.vala"
		_iface_->set_nickname (self, value);
#line 1991 "name-details.c"
	}
}

static void
folks_name_details_default_init (FolksNameDetailsIface * iface,
                                 gpointer iface_data)
{
	/**
	   * The contact name split in its constituent parts.
	   *
	   * Note that most of the time the structured name is not set (i.e.
	   * it's ``null``) or just some of the components are set.
	   * The components are immutable. To get notification of changes of
	   * the structured name, you just have to connect to the ``notify`` signal
	   * of this property.
	   *
	   * @since 0.3.5
	   */
#line 385 "../folks/name-details.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("structured-name", "structured-name", "structured-name", FOLKS_TYPE_STRUCTURED_NAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2012 "name-details.c"
	/**
	   * The full name of the contact.
	   *
	   * The full name is the name of the contact written in the way the contact
	   * prefers. For instance for English names this is usually the given name
	   * followed by the family name, but Chinese names are usually the family
	   * name followed by the given name.
	   * The full name could or could not contain additional names (like a
	   * middle name), prefixes or suffixes.
	   *
	   * The full name must not be ``null``: the empty string represents an unset
	   * full name.
	   *
	   * @since 0.3.5
	   */
#line 385 "../folks/name-details.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("full-name", "full-name", "full-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2030 "name-details.c"
	/**
	   * The nickname of the contact.
	   *
	   * The nickname is the name that the contact chose for himself. This is
	   * different from {@link AliasDetails.alias} as aliases can be chosen by
	   * the user and not by the contacts themselves.
	   *
	   * Consequently, setting the nickname only makes sense in the context of an
	   * address book when updating the information a contact has specified about
	   * themselves.
	   *
	   * The nickname must not be ``null``: the empty string represents an unset
	   * nickname.
	   *
	   * @since 0.3.5
	   */
#line 385 "../folks/name-details.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("nickname", "nickname", "nickname", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 385 "../folks/name-details.vala"
	iface->change_structured_name = folks_name_details_real_change_structured_name;
#line 385 "../folks/name-details.vala"
	iface->change_structured_name_finish = folks_name_details_real_change_structured_name_finish;
#line 385 "../folks/name-details.vala"
	iface->change_full_name = folks_name_details_real_change_full_name;
#line 385 "../folks/name-details.vala"
	iface->change_full_name_finish = folks_name_details_real_change_full_name_finish;
#line 385 "../folks/name-details.vala"
	iface->change_nickname = folks_name_details_real_change_nickname;
#line 385 "../folks/name-details.vala"
	iface->change_nickname_finish = folks_name_details_real_change_nickname_finish;
#line 2061 "name-details.c"
}

/**
 * Interface for classes which represent contacts with names, such as
 * {@link Persona} and {@link Individual}.
 *
 * @since 0.3.5
 */
static GType
folks_name_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksNameDetailsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_name_details_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType folks_name_details_type_id;
	folks_name_details_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksNameDetails", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (folks_name_details_type_id, G_TYPE_OBJECT);
	return folks_name_details_type_id;
}

GType
folks_name_details_get_type (void)
{
	static volatile gsize folks_name_details_type_id__once = 0;
	if (g_once_init_enter (&folks_name_details_type_id__once)) {
		GType folks_name_details_type_id;
		folks_name_details_type_id = folks_name_details_get_type_once ();
		g_once_init_leave (&folks_name_details_type_id__once, folks_name_details_type_id);
	}
	return folks_name_details_type_id__once;
}

