/* query.c generated by valac 0.56.18, the Vala compiler
 * generated from query.vala, do not modify */

/*
 * Copyright (C) 2011, 2015 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 */

#include "folks/folks.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_QUERY_0_PROPERTY,
	FOLKS_QUERY_MATCH_FIELDS_PROPERTY,
	FOLKS_QUERY_NUM_PROPERTIES
};
static GParamSpec* folks_query_properties[FOLKS_QUERY_NUM_PROPERTIES];

struct _FolksQueryPrivate {
	gchar** _match_fields;
	gint _match_fields_length1;
	gint __match_fields_size_;
};

static gint FolksQuery_private_offset;
static gpointer folks_query_parent_class = NULL;

static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static guint folks_query_real_is_match (FolksQuery* self,
                                 FolksIndividual* individual);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
static void folks_query_finalize (GObject * obj);
static GType folks_query_get_type_once (void);
static void _vala_folks_query_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_folks_query_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gchar* FOLKS_QUERY_MATCH_FIELDS_NAMES[4] = {"alias", "full-name", "nickname", "structured-name"};
const gchar* FOLKS_QUERY_MATCH_FIELDS_ADDRESSES[6] = {"email-addresses", "im-addresses", "phone-numbers", "postal-addresses", "web-service-addresses", "urls"};
const gchar* FOLKS_QUERY_MATCH_FIELDS_MISC[3] = {"groups", "roles", "notes"};

static inline gpointer
folks_query_get_instance_private (FolksQuery* self)
{
	return G_STRUCT_MEMBER_P (self, FolksQuery_private_offset);
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
#line 93 "../folks/query.vala"
	if (length >= 0) {
#line 98 "query.c"
		gchar** result;
		gssize i;
#line 93 "../folks/query.vala"
		result = g_new0 (gchar*, length + 1);
#line 93 "../folks/query.vala"
		for (i = 0; i < length; i++) {
#line 105 "query.c"
			gchar* _tmp0_;
#line 93 "../folks/query.vala"
			_tmp0_ = g_strdup (self[i]);
#line 93 "../folks/query.vala"
			result[i] = _tmp0_;
#line 111 "query.c"
		}
#line 93 "../folks/query.vala"
		return result;
#line 115 "query.c"
	}
#line 93 "../folks/query.vala"
	return NULL;
#line 119 "query.c"
}

/**
   * Determines whether a given {@link Individual} matches this query.
   *
   * This returns a match strength, which is on an arbitrary scale which is not
   * part of libfolks’ public API. These strengths should not be stored by user
   * applications, or examined numerically — they should only be used for
   * pairwise strength comparisons.
   *
   * This function is intended to be used in the {@link SearchView}
   * implementation only. Use {@link SearchView.individuals} to retrieve search
   * results.
   *
   * @param individual an {@link Individual} to match against
   * @return a positive integer if the individual matches this query, or zero
   *   if they do not match; higher numbers indicate a better match
   * @since 0.11.0
   */
static guint
folks_query_real_is_match (FolksQuery* self,
                           FolksIndividual* individual)
{
	guint _tmp0_ = 0U;
#line 139 "../folks/query.vala"
	g_critical ("Type `%s' does not implement abstract method `folks_query_is_match'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 139 "../folks/query.vala"
	return _tmp0_;
#line 148 "query.c"
}

guint
folks_query_is_match (FolksQuery* self,
                      FolksIndividual* individual)
{
	FolksQueryClass* _klass_;
#line 139 "../folks/query.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 139 "../folks/query.vala"
	_klass_ = FOLKS_QUERY_GET_CLASS (self);
#line 139 "../folks/query.vala"
	if (_klass_->is_match) {
#line 139 "../folks/query.vala"
		return _klass_->is_match (self, individual);
#line 164 "query.c"
	}
#line 139 "../folks/query.vala"
	return 0U;
#line 168 "query.c"
}

FolksQuery*
folks_query_construct (GType object_type)
{
	FolksQuery * self = NULL;
#line 36 "../folks/query.vala"
	self = (FolksQuery*) g_object_new (object_type, NULL);
#line 36 "../folks/query.vala"
	return self;
#line 179 "query.c"
}

gchar**
folks_query_get_match_fields (FolksQuery* self,
                              gint* result_length1)
{
	FolksQueryClass* _klass_;
#line 118 "../folks/query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "../folks/query.vala"
	_klass_ = FOLKS_QUERY_GET_CLASS (self);
#line 118 "../folks/query.vala"
	if (_klass_->get_match_fields) {
#line 118 "../folks/query.vala"
		return _klass_->get_match_fields (self, result_length1);
#line 195 "query.c"
	}
#line 118 "../folks/query.vala"
	return NULL;
#line 199 "query.c"
}

static gchar**
folks_query_real_get_match_fields (FolksQuery* base,
                                   gint* result_length1)
{
	gchar** result;
	FolksQuery* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 118 "../folks/query.vala"
	self = base;
#line 118 "../folks/query.vala"
	_tmp0_ = self->priv->_match_fields;
#line 118 "../folks/query.vala"
	_tmp0__length1 = self->priv->_match_fields_length1;
#line 118 "../folks/query.vala"
	_tmp1_ = _tmp0_;
#line 118 "../folks/query.vala"
	_tmp1__length1 = _tmp0__length1;
#line 118 "../folks/query.vala"
	if (result_length1) {
#line 118 "../folks/query.vala"
		*result_length1 = _tmp1__length1;
#line 226 "query.c"
	}
#line 118 "../folks/query.vala"
	result = _tmp1_;
#line 118 "../folks/query.vala"
	return result;
#line 232 "query.c"
}

static void
folks_query_set_match_fields (FolksQuery* self,
                              gchar** value,
                              gint value_length1)
{
	FolksQueryClass* _klass_;
#line 119 "../folks/query.vala"
	g_return_if_fail (self != NULL);
#line 119 "../folks/query.vala"
	_klass_ = FOLKS_QUERY_GET_CLASS (self);
#line 119 "../folks/query.vala"
	if (_klass_->set_match_fields) {
#line 119 "../folks/query.vala"
		_klass_->set_match_fields (self, value, value_length1);
#line 249 "query.c"
	}
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
#line 119 "../folks/query.vala"
	if (length >= 0) {
#line 259 "query.c"
		gchar** result;
		gssize i;
#line 119 "../folks/query.vala"
		result = g_new0 (gchar*, length + 1);
#line 119 "../folks/query.vala"
		for (i = 0; i < length; i++) {
#line 266 "query.c"
			gchar* _tmp0_;
#line 119 "../folks/query.vala"
			_tmp0_ = g_strdup (self[i]);
#line 119 "../folks/query.vala"
			result[i] = _tmp0_;
#line 272 "query.c"
		}
#line 119 "../folks/query.vala"
		return result;
#line 276 "query.c"
	}
#line 119 "../folks/query.vala"
	return NULL;
#line 280 "query.c"
}

static void
folks_query_real_set_match_fields (FolksQuery* base,
                                   gchar** value,
                                   gint value_length1)
{
	FolksQuery* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 119 "../folks/query.vala"
	self = base;
#line 119 "../folks/query.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup5 (value, value_length1) : value;
#line 119 "../folks/query.vala"
	_tmp0__length1 = value_length1;
#line 119 "../folks/query.vala"
	self->priv->_match_fields = (_vala_array_free (self->priv->_match_fields, self->priv->_match_fields_length1, (GDestroyNotify) g_free), NULL);
#line 119 "../folks/query.vala"
	self->priv->_match_fields = _tmp0_;
#line 119 "../folks/query.vala"
	self->priv->_match_fields_length1 = _tmp0__length1;
#line 119 "../folks/query.vala"
	self->priv->__match_fields_size_ = self->priv->_match_fields_length1;
#line 119 "../folks/query.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_query_properties[FOLKS_QUERY_MATCH_FIELDS_PROPERTY]);
#line 307 "query.c"
}

static void
folks_query_class_init (FolksQueryClass * klass,
                        gpointer klass_data)
{
#line 36 "../folks/query.vala"
	folks_query_parent_class = g_type_class_peek_parent (klass);
#line 36 "../folks/query.vala"
	g_type_class_adjust_private_offset (klass, &FolksQuery_private_offset);
#line 36 "../folks/query.vala"
	((FolksQueryClass *) klass)->is_match = (guint (*) (FolksQuery*, FolksIndividual*)) folks_query_real_is_match;
#line 36 "../folks/query.vala"
	FOLKS_QUERY_CLASS (klass)->get_match_fields = (gchar** (*) (FolksQuery*, gint*)) folks_query_real_get_match_fields;
#line 36 "../folks/query.vala"
	FOLKS_QUERY_CLASS (klass)->set_match_fields = (void (*) (FolksQuery*, gchar**, gint)) folks_query_real_set_match_fields;
#line 36 "../folks/query.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_query_get_property;
#line 36 "../folks/query.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folks_query_set_property;
#line 36 "../folks/query.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_query_finalize;
#line 330 "query.c"
	/**
	   * The names of the fields to match within
	   *
	   * The names of valid fields are available via
	   * {@link PersonaStore.detail_key}.
	   *
	   * The ordering of the fields determines the order they are checked for
	   * matches, which can have performance implications (these should ideally be
	   * ordered from most- to least-likely to match).
	   *
	   * Also note that more fields (particularly rarely-matched fields) will
	   * negatively impact performance, so only include important fields.
	   *
	   * Default value is {@link Query.MATCH_FIELDS_NAMES}.
	   *
	   * @since 0.11.0
	   * @see PersonaDetail
	   * @see PersonaStore.detail_key
	   * @see Query.MATCH_FIELDS_NAMES
	   * @see Query.MATCH_FIELDS_ADDRESSES
	   * @see Query.MATCH_FIELDS_MISC
	   */
#line 36 "../folks/query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_QUERY_MATCH_FIELDS_PROPERTY, folks_query_properties[FOLKS_QUERY_MATCH_FIELDS_PROPERTY] = g_param_spec_boxed ("match-fields", "match-fields", "match-fields", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 355 "query.c"
}

static void
folks_query_instance_init (FolksQuery * self,
                           gpointer klass)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 36 "../folks/query.vala"
	self->priv = folks_query_get_instance_private (self);
#line 93 "../folks/query.vala"
	_tmp0_ = _vala_array_dup4 (FOLKS_QUERY_MATCH_FIELDS_NAMES, G_N_ELEMENTS (FOLKS_QUERY_MATCH_FIELDS_NAMES));
#line 93 "../folks/query.vala"
	_tmp0__length1 = G_N_ELEMENTS (FOLKS_QUERY_MATCH_FIELDS_NAMES);
#line 93 "../folks/query.vala"
	self->priv->_match_fields = _tmp0_;
#line 93 "../folks/query.vala"
	self->priv->_match_fields_length1 = _tmp0__length1;
#line 93 "../folks/query.vala"
	self->priv->__match_fields_size_ = self->priv->_match_fields_length1;
#line 376 "query.c"
}

static void
folks_query_finalize (GObject * obj)
{
	FolksQuery * self;
#line 36 "../folks/query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_QUERY, FolksQuery);
#line 93 "../folks/query.vala"
	self->priv->_match_fields = (_vala_array_free (self->priv->_match_fields, self->priv->_match_fields_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../folks/query.vala"
	G_OBJECT_CLASS (folks_query_parent_class)->finalize (obj);
#line 389 "query.c"
}

/**
 * A contact query.
 *
 * If any properties of the query change such that matches may change, the
 * {@link GLib.Object.notify} signal will be emitted, potentially without a
 * detail string. Views which are using this query should re-evaluate their
 * matches on receiving this signal.
 *
 * @see SearchView
 * @since 0.11.0
 */
static GType
folks_query_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksQuery), 0, (GInstanceInitFunc) folks_query_instance_init, NULL };
	GType folks_query_type_id;
	folks_query_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksQuery", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	FolksQuery_private_offset = g_type_add_instance_private (folks_query_type_id, sizeof (FolksQueryPrivate));
	return folks_query_type_id;
}

GType
folks_query_get_type (void)
{
	static volatile gsize folks_query_type_id__once = 0;
	if (g_once_init_enter (&folks_query_type_id__once)) {
		GType folks_query_type_id;
		folks_query_type_id = folks_query_get_type_once ();
		g_once_init_leave (&folks_query_type_id__once, folks_query_type_id);
	}
	return folks_query_type_id__once;
}

static void
_vala_folks_query_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	FolksQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_QUERY, FolksQuery);
#line 36 "../folks/query.vala"
	switch (property_id) {
#line 36 "../folks/query.vala"
		case FOLKS_QUERY_MATCH_FIELDS_PROPERTY:
#line 437 "query.c"
		{
			int length;
#line 36 "../folks/query.vala"
			g_value_set_boxed (value, folks_query_get_match_fields (self, &length));
#line 442 "query.c"
		}
#line 36 "../folks/query.vala"
		break;
#line 446 "query.c"
		default:
#line 36 "../folks/query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../folks/query.vala"
		break;
#line 452 "query.c"
	}
}

static void
_vala_folks_query_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	FolksQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_QUERY, FolksQuery);
#line 36 "../folks/query.vala"
	switch (property_id) {
#line 36 "../folks/query.vala"
		case FOLKS_QUERY_MATCH_FIELDS_PROPERTY:
#line 468 "query.c"
		{
			gpointer boxed;
#line 36 "../folks/query.vala"
			boxed = g_value_get_boxed (value);
#line 36 "../folks/query.vala"
			folks_query_set_match_fields (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 475 "query.c"
		}
#line 36 "../folks/query.vala"
		break;
#line 479 "query.c"
		default:
#line 36 "../folks/query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../folks/query.vala"
		break;
#line 485 "query.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

