/* role-details.c generated by valac 0.56.18, the Vala compiler
 * generated from role-details.vala, do not modify */

/*
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2011 Philip Withnall
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Raul Gutierrez Segales <raul.gutierrez.segales@collabora.co.uk>
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 *       Philip Withnall <philip@tecnocode.co.uk>
 */

#include "folks/folks.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_ROLE_0_PROPERTY,
	FOLKS_ROLE_ORGANISATION_NAME_PROPERTY,
	FOLKS_ROLE_TITLE_PROPERTY,
	FOLKS_ROLE_ROLE_PROPERTY,
	FOLKS_ROLE_UID_PROPERTY,
	FOLKS_ROLE_NUM_PROPERTIES
};
static GParamSpec* folks_role_properties[FOLKS_ROLE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	FOLKS_ROLE_FIELD_DETAILS_0_PROPERTY,
	FOLKS_ROLE_FIELD_DETAILS_ID_PROPERTY,
	FOLKS_ROLE_FIELD_DETAILS_NUM_PROPERTIES
};
static GParamSpec* folks_role_field_details_properties[FOLKS_ROLE_FIELD_DETAILS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _FolksRoleDetailsChangeRolesData FolksRoleDetailsChangeRolesData;

struct _FolksRolePrivate {
	gchar* _organisation_name;
	gchar* _title;
	gchar* _role;
	gchar* _uid;
};

struct _FolksRoleFieldDetailsPrivate {
	gchar* _id;
};

struct _FolksRoleDetailsChangeRolesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksRoleDetails* self;
	GeeSet* roles;
	GError* _tmp0_;
	GError* _inner_error0_;
};

static gint FolksRole_private_offset;
static gpointer folks_role_parent_class = NULL;
static gint FolksRoleFieldDetails_private_offset;
static gpointer folks_role_field_details_parent_class = NULL;

static void folks_role_finalize (GObject * obj);
static GType folks_role_get_type_once (void);
static void _vala_folks_role_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_folks_role_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static gboolean folks_role_field_details_real_equal (FolksAbstractFieldDetails* base,
                                              FolksAbstractFieldDetails* that);
static guint folks_role_field_details_real_hash (FolksAbstractFieldDetails* base);
static GObject * folks_role_field_details_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _folks_role_field_details___lambda5_ (FolksRoleFieldDetails* self,
                                           GObject* s,
                                           GParamSpec* p);
static void __folks_role_field_details___lambda5__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void folks_role_field_details_finalize (GObject * obj);
static GType folks_role_field_details_get_type_once (void);
static void _vala_folks_role_field_details_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_folks_role_field_details_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void folks_role_details_real_change_roles_data_free (gpointer _data);
static void folks_role_details_real_change_roles (FolksRoleDetails* self,
                                           GeeSet* roles,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static gboolean folks_role_details_real_change_roles_co (FolksRoleDetailsChangeRolesData* _data_);
static GType folks_role_details_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
folks_role_get_instance_private (FolksRole* self)
{
	return G_STRUCT_MEMBER_P (self, FolksRole_private_offset);
}

/**
   * Default constructor.
   *
   * @param title title of the position
   * @param organisation_name organisation where the role is hold
   * @param uid a Unique ID associated to this Role
   * @return a new Role
   *
   * @since 0.4.0
   */
FolksRole*
folks_role_construct (GType object_type,
                      const gchar* title,
                      const gchar* organisation_name,
                      const gchar* uid)
{
	FolksRole * self = NULL;
#line 98 "../folks/role-details.vala"
	self = (FolksRole*) g_object_new (object_type, "uid", uid, "title", title, "organisation-name", organisation_name, NULL);
#line 95 "../folks/role-details.vala"
	return self;
#line 161 "role-details.c"
}

FolksRole*
folks_role_new (const gchar* title,
                const gchar* organisation_name,
                const gchar* uid)
{
#line 95 "../folks/role-details.vala"
	return folks_role_construct (FOLKS_TYPE_ROLE, title, organisation_name, uid);
#line 171 "role-details.c"
}

/**
   * Whether none of the components is set.
   *
   * @return ``true`` if all the components are the empty string, ``false``
   * otherwise.
   *
   * @since 0.6.7
   */
gboolean
folks_role_is_empty (FolksRole* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 111 "../folks/role-details.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 113 "../folks/role-details.vala"
	_tmp2_ = folks_role_get_organisation_name (self);
#line 113 "../folks/role-details.vala"
	_tmp3_ = _tmp2_;
#line 113 "../folks/role-details.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 198 "role-details.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 114 "../folks/role-details.vala"
		_tmp4_ = folks_role_get_title (self);
#line 114 "../folks/role-details.vala"
		_tmp5_ = _tmp4_;
#line 114 "../folks/role-details.vala"
		_tmp1_ = g_strcmp0 (_tmp5_, "") == 0;
#line 207 "role-details.c"
	} else {
#line 113 "../folks/role-details.vala"
		_tmp1_ = FALSE;
#line 211 "role-details.c"
	}
#line 113 "../folks/role-details.vala"
	if (_tmp1_) {
#line 215 "role-details.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 115 "../folks/role-details.vala"
		_tmp6_ = folks_role_get_role (self);
#line 115 "../folks/role-details.vala"
		_tmp7_ = _tmp6_;
#line 115 "../folks/role-details.vala"
		_tmp0_ = g_strcmp0 (_tmp7_, "") == 0;
#line 224 "role-details.c"
	} else {
#line 113 "../folks/role-details.vala"
		_tmp0_ = FALSE;
#line 228 "role-details.c"
	}
#line 113 "../folks/role-details.vala"
	result = _tmp0_;
#line 113 "../folks/role-details.vala"
	return result;
#line 234 "role-details.c"
}

/**
   * Compare if two roles are equal. Roles are equal if their titles and
   * organisation names are equal.
   *
   * @param a a role to compare
   * @param b another role to compare
   * @return ``true`` if the roles are equal, ``false`` otherwise
   */
gboolean
folks_role_equal (FolksRole* a,
                  FolksRole* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean result;
#line 126 "../folks/role-details.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 126 "../folks/role-details.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 128 "../folks/role-details.vala"
	_tmp2_ = folks_role_get_title (a);
#line 128 "../folks/role-details.vala"
	_tmp3_ = _tmp2_;
#line 128 "../folks/role-details.vala"
	_tmp4_ = folks_role_get_title (b);
#line 128 "../folks/role-details.vala"
	_tmp5_ = _tmp4_;
#line 128 "../folks/role-details.vala"
	if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 270 "role-details.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 129 "../folks/role-details.vala"
		_tmp6_ = folks_role_get_role (a);
#line 129 "../folks/role-details.vala"
		_tmp7_ = _tmp6_;
#line 129 "../folks/role-details.vala"
		_tmp8_ = folks_role_get_role (b);
#line 129 "../folks/role-details.vala"
		_tmp9_ = _tmp8_;
#line 129 "../folks/role-details.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, _tmp9_) == 0;
#line 285 "role-details.c"
	} else {
#line 128 "../folks/role-details.vala"
		_tmp1_ = FALSE;
#line 289 "role-details.c"
	}
#line 128 "../folks/role-details.vala"
	if (_tmp1_) {
#line 293 "role-details.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 130 "../folks/role-details.vala"
		_tmp10_ = folks_role_get_organisation_name (a);
#line 130 "../folks/role-details.vala"
		_tmp11_ = _tmp10_;
#line 130 "../folks/role-details.vala"
		_tmp12_ = folks_role_get_organisation_name (b);
#line 130 "../folks/role-details.vala"
		_tmp13_ = _tmp12_;
#line 130 "../folks/role-details.vala"
		_tmp0_ = g_strcmp0 (_tmp11_, _tmp13_) == 0;
#line 308 "role-details.c"
	} else {
#line 128 "../folks/role-details.vala"
		_tmp0_ = FALSE;
#line 312 "role-details.c"
	}
#line 128 "../folks/role-details.vala"
	result = _tmp0_;
#line 128 "../folks/role-details.vala"
	return result;
#line 318 "role-details.c"
}

/**
   * Hash function for the class. Suitable for use as a hash table key.
   *
   * @param r a role to hash
   * @return hash value for the role instance
   */
guint
folks_role_hash (FolksRole* r)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	guint result;
#line 139 "../folks/role-details.vala"
	g_return_val_if_fail (r != NULL, 0U);
#line 141 "../folks/role-details.vala"
	_tmp0_ = folks_role_get_organisation_name (r);
#line 141 "../folks/role-details.vala"
	_tmp1_ = _tmp0_;
#line 141 "../folks/role-details.vala"
	_tmp2_ = folks_role_get_title (r);
#line 141 "../folks/role-details.vala"
	_tmp3_ = _tmp2_;
#line 141 "../folks/role-details.vala"
	_tmp4_ = folks_role_get_role (r);
#line 141 "../folks/role-details.vala"
	_tmp5_ = _tmp4_;
#line 141 "../folks/role-details.vala"
	result = (g_str_hash (_tmp1_) ^ g_str_hash (_tmp3_)) ^ g_str_hash (_tmp5_);
#line 141 "../folks/role-details.vala"
	return result;
#line 355 "role-details.c"
}

/**
   * Formatted version of this role.
   *
   * @since 0.4.0
   */
gchar*
folks_role_to_string (FolksRole* self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 149 "../folks/role-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../folks/role-details.vala"
	_tmp0_ = g_strdup (_ ("Title: %s, Organisation: %s, Role: %s"));
#line 151 "../folks/role-details.vala"
	str = _tmp0_;
#line 152 "../folks/role-details.vala"
	_tmp1_ = folks_role_get_title (self);
#line 152 "../folks/role-details.vala"
	_tmp2_ = _tmp1_;
#line 152 "../folks/role-details.vala"
	_tmp3_ = folks_role_get_organisation_name (self);
#line 152 "../folks/role-details.vala"
	_tmp4_ = _tmp3_;
#line 152 "../folks/role-details.vala"
	_tmp5_ = folks_role_get_role (self);
#line 152 "../folks/role-details.vala"
	_tmp6_ = _tmp5_;
#line 152 "../folks/role-details.vala"
	_tmp7_ = g_strdup_printf (str, _tmp2_, _tmp4_, _tmp6_);
#line 152 "../folks/role-details.vala"
	result = _tmp7_;
#line 152 "../folks/role-details.vala"
	_g_free0 (str);
#line 152 "../folks/role-details.vala"
	return result;
#line 402 "role-details.c"
}

const gchar*
folks_role_get_organisation_name (FolksRole* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../folks/role-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../folks/role-details.vala"
	_tmp0_ = self->priv->_organisation_name;
#line 43 "../folks/role-details.vala"
	result = _tmp0_;
#line 43 "../folks/role-details.vala"
	return result;
#line 418 "role-details.c"
}

void
folks_role_set_organisation_name (FolksRole* self,
                                  const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 44 "../folks/role-details.vala"
	g_return_if_fail (self != NULL);
#line 44 "../folks/role-details.vala"
	if (value != NULL) {
#line 44 "../folks/role-details.vala"
		_tmp0_ = value;
#line 433 "role-details.c"
	} else {
#line 44 "../folks/role-details.vala"
		_tmp0_ = "";
#line 437 "role-details.c"
	}
#line 44 "../folks/role-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 44 "../folks/role-details.vala"
	_g_free0 (self->priv->_organisation_name);
#line 44 "../folks/role-details.vala"
	self->priv->_organisation_name = _tmp1_;
#line 44 "../folks/role-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_role_properties[FOLKS_ROLE_ORGANISATION_NAME_PROPERTY]);
#line 447 "role-details.c"
}

const gchar*
folks_role_get_title (FolksRole* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "../folks/role-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../folks/role-details.vala"
	_tmp0_ = self->priv->_title;
#line 55 "../folks/role-details.vala"
	result = _tmp0_;
#line 55 "../folks/role-details.vala"
	return result;
#line 463 "role-details.c"
}

void
folks_role_set_title (FolksRole* self,
                      const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 56 "../folks/role-details.vala"
	g_return_if_fail (self != NULL);
#line 56 "../folks/role-details.vala"
	if (value != NULL) {
#line 56 "../folks/role-details.vala"
		_tmp0_ = value;
#line 478 "role-details.c"
	} else {
#line 56 "../folks/role-details.vala"
		_tmp0_ = "";
#line 482 "role-details.c"
	}
#line 56 "../folks/role-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 56 "../folks/role-details.vala"
	_g_free0 (self->priv->_title);
#line 56 "../folks/role-details.vala"
	self->priv->_title = _tmp1_;
#line 56 "../folks/role-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_role_properties[FOLKS_ROLE_TITLE_PROPERTY]);
#line 492 "role-details.c"
}

const gchar*
folks_role_get_role (FolksRole* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 69 "../folks/role-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../folks/role-details.vala"
	_tmp0_ = self->priv->_role;
#line 69 "../folks/role-details.vala"
	result = _tmp0_;
#line 69 "../folks/role-details.vala"
	return result;
#line 508 "role-details.c"
}

void
folks_role_set_role (FolksRole* self,
                     const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 70 "../folks/role-details.vala"
	g_return_if_fail (self != NULL);
#line 70 "../folks/role-details.vala"
	if (value != NULL) {
#line 70 "../folks/role-details.vala"
		_tmp0_ = value;
#line 523 "role-details.c"
	} else {
#line 70 "../folks/role-details.vala"
		_tmp0_ = "";
#line 527 "role-details.c"
	}
#line 70 "../folks/role-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 70 "../folks/role-details.vala"
	_g_free0 (self->priv->_role);
#line 70 "../folks/role-details.vala"
	self->priv->_role = _tmp1_;
#line 70 "../folks/role-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_role_properties[FOLKS_ROLE_ROLE_PROPERTY]);
#line 537 "role-details.c"
}

const gchar*
folks_role_get_uid (FolksRole* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 81 "../folks/role-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../folks/role-details.vala"
	_tmp0_ = self->priv->_uid;
#line 81 "../folks/role-details.vala"
	result = _tmp0_;
#line 81 "../folks/role-details.vala"
	return result;
#line 553 "role-details.c"
}

void
folks_role_set_uid (FolksRole* self,
                    const gchar* value)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 82 "../folks/role-details.vala"
	g_return_if_fail (self != NULL);
#line 82 "../folks/role-details.vala"
	if (value != NULL) {
#line 82 "../folks/role-details.vala"
		_tmp0_ = value;
#line 568 "role-details.c"
	} else {
#line 82 "../folks/role-details.vala"
		_tmp0_ = "";
#line 572 "role-details.c"
	}
#line 82 "../folks/role-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 82 "../folks/role-details.vala"
	_g_free0 (self->priv->_uid);
#line 82 "../folks/role-details.vala"
	self->priv->_uid = _tmp1_;
#line 82 "../folks/role-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_role_properties[FOLKS_ROLE_UID_PROPERTY]);
#line 582 "role-details.c"
}

static void
folks_role_class_init (FolksRoleClass * klass,
                       gpointer klass_data)
{
#line 35 "../folks/role-details.vala"
	folks_role_parent_class = g_type_class_peek_parent (klass);
#line 35 "../folks/role-details.vala"
	g_type_class_adjust_private_offset (klass, &FolksRole_private_offset);
#line 35 "../folks/role-details.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_role_get_property;
#line 35 "../folks/role-details.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folks_role_set_property;
#line 35 "../folks/role-details.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_role_finalize;
#line 599 "role-details.c"
	/**
	   * The name of the organisation in which the role is held.
	   */
#line 35 "../folks/role-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_ROLE_ORGANISATION_NAME_PROPERTY, folks_role_properties[FOLKS_ROLE_ORGANISATION_NAME_PROPERTY] = g_param_spec_string ("organisation-name", "organisation-name", "organisation-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 605 "role-details.c"
	/**
	   * The title of the position held.
	   *
	   * For example: “Director, Ministry of Silly Walks”
	   */
#line 35 "../folks/role-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_ROLE_TITLE_PROPERTY, folks_role_properties[FOLKS_ROLE_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 613 "role-details.c"
	/**
	   * The role of the position.
	   *
	   * For example: “Programmer”
	   *
	   * @since 0.6.0
	   */
#line 35 "../folks/role-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_ROLE_ROLE_PROPERTY, folks_role_properties[FOLKS_ROLE_ROLE_PROPERTY] = g_param_spec_string ("role", "role", "role", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 623 "role-details.c"
	/**
	   * The UID that distinguishes this role.
	   */
#line 35 "../folks/role-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_ROLE_UID_PROPERTY, folks_role_properties[FOLKS_ROLE_UID_PROPERTY] = g_param_spec_string ("uid", "uid", "uid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
#line 629 "role-details.c"
}

static void
folks_role_instance_init (FolksRole * self,
                          gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 35 "../folks/role-details.vala"
	self->priv = folks_role_get_instance_private (self);
#line 37 "../folks/role-details.vala"
	_tmp0_ = g_strdup ("");
#line 37 "../folks/role-details.vala"
	self->priv->_organisation_name = _tmp0_;
#line 47 "../folks/role-details.vala"
	_tmp1_ = g_strdup ("");
#line 47 "../folks/role-details.vala"
	self->priv->_title = _tmp1_;
#line 59 "../folks/role-details.vala"
	_tmp2_ = g_strdup ("");
#line 59 "../folks/role-details.vala"
	self->priv->_role = _tmp2_;
#line 73 "../folks/role-details.vala"
	_tmp3_ = g_strdup ("");
#line 73 "../folks/role-details.vala"
	self->priv->_uid = _tmp3_;
#line 658 "role-details.c"
}

static void
folks_role_finalize (GObject * obj)
{
	FolksRole * self;
#line 35 "../folks/role-details.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_ROLE, FolksRole);
#line 37 "../folks/role-details.vala"
	_g_free0 (self->priv->_organisation_name);
#line 47 "../folks/role-details.vala"
	_g_free0 (self->priv->_title);
#line 59 "../folks/role-details.vala"
	_g_free0 (self->priv->_role);
#line 73 "../folks/role-details.vala"
	_g_free0 (self->priv->_uid);
#line 35 "../folks/role-details.vala"
	G_OBJECT_CLASS (folks_role_parent_class)->finalize (obj);
#line 677 "role-details.c"
}

/**
 * Role a contact has in an organisation.
 *
 * This represents the role a {@link Persona} or {@link Individual} has in a
 * single given organisation, such as a company.
 *
 * @since 0.4.0
 */
static GType
folks_role_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksRoleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_role_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksRole), 0, (GInstanceInitFunc) folks_role_instance_init, NULL };
	GType folks_role_type_id;
	folks_role_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksRole", &g_define_type_info, 0);
	FolksRole_private_offset = g_type_add_instance_private (folks_role_type_id, sizeof (FolksRolePrivate));
	return folks_role_type_id;
}

GType
folks_role_get_type (void)
{
	static volatile gsize folks_role_type_id__once = 0;
	if (g_once_init_enter (&folks_role_type_id__once)) {
		GType folks_role_type_id;
		folks_role_type_id = folks_role_get_type_once ();
		g_once_init_leave (&folks_role_type_id__once, folks_role_type_id);
	}
	return folks_role_type_id__once;
}

static void
_vala_folks_role_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	FolksRole * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_ROLE, FolksRole);
#line 35 "../folks/role-details.vala"
	switch (property_id) {
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_ORGANISATION_NAME_PROPERTY:
#line 35 "../folks/role-details.vala"
		g_value_set_string (value, folks_role_get_organisation_name (self));
#line 35 "../folks/role-details.vala"
		break;
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_TITLE_PROPERTY:
#line 35 "../folks/role-details.vala"
		g_value_set_string (value, folks_role_get_title (self));
#line 35 "../folks/role-details.vala"
		break;
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_ROLE_PROPERTY:
#line 35 "../folks/role-details.vala"
		g_value_set_string (value, folks_role_get_role (self));
#line 35 "../folks/role-details.vala"
		break;
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_UID_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 741 "role-details.c"
		g_value_set_string (value, folks_role_get_uid (self));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 35 "../folks/role-details.vala"
		break;
#line 746 "role-details.c"
		default:
#line 35 "../folks/role-details.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../folks/role-details.vala"
		break;
#line 752 "role-details.c"
	}
}

static void
_vala_folks_role_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	FolksRole * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_ROLE, FolksRole);
#line 35 "../folks/role-details.vala"
	switch (property_id) {
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_ORGANISATION_NAME_PROPERTY:
#line 35 "../folks/role-details.vala"
		folks_role_set_organisation_name (self, g_value_get_string (value));
#line 35 "../folks/role-details.vala"
		break;
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_TITLE_PROPERTY:
#line 35 "../folks/role-details.vala"
		folks_role_set_title (self, g_value_get_string (value));
#line 35 "../folks/role-details.vala"
		break;
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_ROLE_PROPERTY:
#line 35 "../folks/role-details.vala"
		folks_role_set_role (self, g_value_get_string (value));
#line 35 "../folks/role-details.vala"
		break;
#line 35 "../folks/role-details.vala"
		case FOLKS_ROLE_UID_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 787 "role-details.c"
		folks_role_set_uid (self, g_value_get_string (value));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 35 "../folks/role-details.vala"
		break;
#line 792 "role-details.c"
		default:
#line 35 "../folks/role-details.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../folks/role-details.vala"
		break;
#line 798 "role-details.c"
	}
}

static inline gpointer
folks_role_field_details_get_instance_private (FolksRoleFieldDetails* self)
{
	return G_STRUCT_MEMBER_P (self, FolksRoleFieldDetails_private_offset);
}

/**
   * Create a new RoleFieldDetails.
   *
   * @param value the non-empty {@link Role} of the field
   * @param parameters initial parameters. See
   * {@link AbstractFieldDetails.parameters}. A ``null`` value is equivalent to an
   * empty map of parameters.
   *
   * @return a new RoleFieldDetails
   *
   * @since 0.6.0
   */
FolksRoleFieldDetails*
folks_role_field_details_construct (GType object_type,
                                    FolksRole* value,
                                    GeeMultiMap* parameters)
{
	FolksRoleFieldDetails * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 195 "../folks/role-details.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 198 "../folks/role-details.vala"
	if (folks_role_is_empty (value)) {
#line 200 "../folks/role-details.vala"
		g_warning ("role-details.vala:200: Empty role passed to RoleFieldDetails.");
#line 834 "role-details.c"
	}
#line 204 "../folks/role-details.vala"
	_tmp0_ = folks_role_get_uid (value);
#line 204 "../folks/role-details.vala"
	_tmp1_ = _tmp0_;
#line 204 "../folks/role-details.vala"
	self = (FolksRoleFieldDetails*) g_object_new (object_type, "t-type", FOLKS_TYPE_ROLE, "t-dup-func", (GBoxedCopyFunc) g_object_ref, "t-destroy-func", (GDestroyNotify) g_object_unref, "value", value, "parameters", parameters, "id", _tmp1_, NULL);
#line 195 "../folks/role-details.vala"
	return self;
#line 844 "role-details.c"
}

FolksRoleFieldDetails*
folks_role_field_details_new (FolksRole* value,
                              GeeMultiMap* parameters)
{
#line 195 "../folks/role-details.vala"
	return folks_role_field_details_construct (FOLKS_TYPE_ROLE_FIELD_DETAILS, value, parameters);
#line 853 "role-details.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.6.0
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 226 "../folks/role-details.vala"
	return self ? g_object_ref (self) : NULL;
#line 866 "role-details.c"
}

static gboolean
folks_role_field_details_real_equal (FolksAbstractFieldDetails* base,
                                     FolksAbstractFieldDetails* that)
{
	FolksRoleFieldDetails * self;
	FolksRoleFieldDetails* _that_fd = NULL;
	FolksRoleFieldDetails* _tmp0_;
	FolksRoleFieldDetails* _tmp1_;
	FolksRoleFieldDetails* that_fd = NULL;
	FolksRoleFieldDetails* _tmp2_;
	FolksRoleFieldDetails* _tmp3_;
	gconstpointer _tmp4_;
	gconstpointer _tmp5_;
	FolksRoleFieldDetails* _tmp6_;
	gconstpointer _tmp7_;
	gconstpointer _tmp8_;
	gboolean result;
#line 224 "../folks/role-details.vala"
	self = (FolksRoleFieldDetails*) base;
#line 224 "../folks/role-details.vala"
	g_return_val_if_fail (that != NULL, FALSE);
#line 226 "../folks/role-details.vala"
	_tmp0_ = _g_object_ref0 (FOLKS_IS_ROLE_FIELD_DETAILS (that) ? ((FolksRoleFieldDetails*) that) : NULL);
#line 226 "../folks/role-details.vala"
	_that_fd = _tmp0_;
#line 227 "../folks/role-details.vala"
	_tmp1_ = _that_fd;
#line 227 "../folks/role-details.vala"
	if (_tmp1_ == NULL) {
#line 228 "../folks/role-details.vala"
		result = FALSE;
#line 228 "../folks/role-details.vala"
		_g_object_unref0 (_that_fd);
#line 228 "../folks/role-details.vala"
		return result;
#line 904 "role-details.c"
	}
#line 229 "../folks/role-details.vala"
	_tmp2_ = _that_fd;
#line 229 "../folks/role-details.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, FOLKS_TYPE_ROLE_FIELD_DETAILS, FolksRoleFieldDetails));
#line 229 "../folks/role-details.vala"
	that_fd = _tmp3_;
#line 231 "../folks/role-details.vala"
	if (!FOLKS_ABSTRACT_FIELD_DETAILS_CLASS (folks_role_field_details_parent_class)->parameters_equal (G_TYPE_CHECK_INSTANCE_CAST (self, FOLKS_TYPE_ABSTRACT_FIELD_DETAILS, FolksAbstractFieldDetails), that)) {
#line 232 "../folks/role-details.vala"
		result = FALSE;
#line 232 "../folks/role-details.vala"
		_g_object_unref0 (that_fd);
#line 232 "../folks/role-details.vala"
		_g_object_unref0 (_that_fd);
#line 232 "../folks/role-details.vala"
		return result;
#line 922 "role-details.c"
	}
#line 234 "../folks/role-details.vala"
	_tmp4_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) self);
#line 234 "../folks/role-details.vala"
	_tmp5_ = _tmp4_;
#line 234 "../folks/role-details.vala"
	_tmp6_ = that_fd;
#line 234 "../folks/role-details.vala"
	_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp6_);
#line 234 "../folks/role-details.vala"
	_tmp8_ = _tmp7_;
#line 234 "../folks/role-details.vala"
	result = folks_role_equal ((FolksRole*) _tmp5_, (FolksRole*) _tmp8_);
#line 234 "../folks/role-details.vala"
	_g_object_unref0 (that_fd);
#line 234 "../folks/role-details.vala"
	_g_object_unref0 (_that_fd);
#line 234 "../folks/role-details.vala"
	return result;
#line 942 "role-details.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.6.0
   */
static guint
folks_role_field_details_real_hash (FolksAbstractFieldDetails* base)
{
	FolksRoleFieldDetails * self;
	GHashFunc _tmp0_;
	gconstpointer _tmp1_;
	gconstpointer _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	guint _tmp5_;
	guint result;
#line 242 "../folks/role-details.vala"
	self = (FolksRoleFieldDetails*) base;
#line 244 "../folks/role-details.vala"
	_tmp0_ = g_str_hash;
#line 244 "../folks/role-details.vala"
	_tmp1_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) self);
#line 244 "../folks/role-details.vala"
	_tmp2_ = _tmp1_;
#line 244 "../folks/role-details.vala"
	_tmp3_ = folks_role_to_string ((FolksRole*) _tmp2_);
#line 244 "../folks/role-details.vala"
	_tmp4_ = _tmp3_;
#line 244 "../folks/role-details.vala"
	_tmp5_ = _tmp0_ (_tmp4_);
#line 244 "../folks/role-details.vala"
	_g_free0 (_tmp4_);
#line 244 "../folks/role-details.vala"
	result = _tmp5_;
#line 244 "../folks/role-details.vala"
	return result;
#line 981 "role-details.c"
}

static const gchar*
folks_role_field_details_real_get_id (FolksAbstractFieldDetails* base)
{
	const gchar* result;
	FolksRoleFieldDetails* self;
	const gchar* _tmp0_;
#line 172 "../folks/role-details.vala"
	self = (FolksRoleFieldDetails*) base;
#line 172 "../folks/role-details.vala"
	_tmp0_ = self->priv->_id;
#line 172 "../folks/role-details.vala"
	result = _tmp0_;
#line 172 "../folks/role-details.vala"
	return result;
#line 998 "role-details.c"
}

static void
folks_role_field_details_real_set_id (FolksAbstractFieldDetails* base,
                                      const gchar* value)
{
	FolksRoleFieldDetails* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
#line 173 "../folks/role-details.vala"
	self = (FolksRoleFieldDetails*) base;
#line 175 "../folks/role-details.vala"
	if (value != NULL) {
#line 175 "../folks/role-details.vala"
		_tmp0_ = value;
#line 1019 "role-details.c"
	} else {
#line 175 "../folks/role-details.vala"
		_tmp0_ = "";
#line 1023 "role-details.c"
	}
#line 175 "../folks/role-details.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 175 "../folks/role-details.vala"
	_g_free0 (self->priv->_id);
#line 175 "../folks/role-details.vala"
	self->priv->_id = _tmp1_;
#line 178 "../folks/role-details.vala"
	_tmp2_ = self->priv->_id;
#line 178 "../folks/role-details.vala"
	_tmp3_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) self);
#line 178 "../folks/role-details.vala"
	_tmp4_ = _tmp3_;
#line 178 "../folks/role-details.vala"
	_tmp5_ = folks_role_get_uid ((FolksRole*) _tmp4_);
#line 178 "../folks/role-details.vala"
	_tmp6_ = _tmp5_;
#line 178 "../folks/role-details.vala"
	if (g_strcmp0 (_tmp2_, _tmp6_) != 0) {
#line 1043 "role-details.c"
		gconstpointer _tmp7_;
		gconstpointer _tmp8_;
		const gchar* _tmp9_;
#line 179 "../folks/role-details.vala"
		_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) self);
#line 179 "../folks/role-details.vala"
		_tmp8_ = _tmp7_;
#line 179 "../folks/role-details.vala"
		_tmp9_ = self->priv->_id;
#line 179 "../folks/role-details.vala"
		folks_role_set_uid ((FolksRole*) _tmp8_, _tmp9_);
#line 1055 "role-details.c"
	}
#line 173 "../folks/role-details.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_role_field_details_properties[FOLKS_ROLE_FIELD_DETAILS_ID_PROPERTY]);
#line 1059 "role-details.c"
}

static void
_folks_role_field_details___lambda5_ (FolksRoleFieldDetails* self,
                                      GObject* s,
                                      GParamSpec* p)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gconstpointer _tmp2_;
	gconstpointer _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 212 "../folks/role-details.vala"
	g_return_if_fail (s != NULL);
#line 212 "../folks/role-details.vala"
	g_return_if_fail (p != NULL);
#line 214 "../folks/role-details.vala"
	_tmp0_ = folks_abstract_field_details_get_id ((FolksAbstractFieldDetails*) self);
#line 214 "../folks/role-details.vala"
	_tmp1_ = _tmp0_;
#line 214 "../folks/role-details.vala"
	_tmp2_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) self);
#line 214 "../folks/role-details.vala"
	_tmp3_ = _tmp2_;
#line 214 "../folks/role-details.vala"
	_tmp4_ = folks_role_get_uid ((FolksRole*) _tmp3_);
#line 214 "../folks/role-details.vala"
	_tmp5_ = _tmp4_;
#line 214 "../folks/role-details.vala"
	if (g_strcmp0 (_tmp1_, _tmp5_) != 0) {
#line 1091 "role-details.c"
		gconstpointer _tmp6_;
		gconstpointer _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 215 "../folks/role-details.vala"
		_tmp6_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) self);
#line 215 "../folks/role-details.vala"
		_tmp7_ = _tmp6_;
#line 215 "../folks/role-details.vala"
		_tmp8_ = folks_role_get_uid ((FolksRole*) _tmp7_);
#line 215 "../folks/role-details.vala"
		_tmp9_ = _tmp8_;
#line 215 "../folks/role-details.vala"
		folks_abstract_field_details_set_id ((FolksAbstractFieldDetails*) self, _tmp9_);
#line 1106 "role-details.c"
	}
}

static void
__folks_role_field_details___lambda5__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 212 "../folks/role-details.vala"
	_folks_role_field_details___lambda5_ ((FolksRoleFieldDetails*) self, _sender, pspec);
#line 1117 "role-details.c"
}

static GObject *
folks_role_field_details_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksRoleFieldDetails * self;
	gconstpointer _tmp0_;
	gconstpointer _tmp1_;
#line 209 "../folks/role-details.vala"
	parent_class = G_OBJECT_CLASS (folks_role_field_details_parent_class);
#line 209 "../folks/role-details.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 209 "../folks/role-details.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_ROLE_FIELD_DETAILS, FolksRoleFieldDetails);
#line 212 "../folks/role-details.vala"
	_tmp0_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) self);
#line 212 "../folks/role-details.vala"
	_tmp1_ = _tmp0_;
#line 212 "../folks/role-details.vala"
	g_signal_connect_object ((GObject*) ((FolksRole*) _tmp1_), "notify::uid", (GCallback) __folks_role_field_details___lambda5__g_object_notify, self, 0);
#line 209 "../folks/role-details.vala"
	return obj;
#line 1144 "role-details.c"
}

static void
folks_role_field_details_class_init (FolksRoleFieldDetailsClass * klass,
                                     gpointer klass_data)
{
#line 164 "../folks/role-details.vala"
	folks_role_field_details_parent_class = g_type_class_peek_parent (klass);
#line 164 "../folks/role-details.vala"
	g_type_class_adjust_private_offset (klass, &FolksRoleFieldDetails_private_offset);
#line 164 "../folks/role-details.vala"
	((FolksAbstractFieldDetailsClass *) klass)->equal = (gboolean (*) (FolksAbstractFieldDetails*, FolksAbstractFieldDetails*)) folks_role_field_details_real_equal;
#line 164 "../folks/role-details.vala"
	((FolksAbstractFieldDetailsClass *) klass)->hash = (guint (*) (FolksAbstractFieldDetails*)) folks_role_field_details_real_hash;
#line 164 "../folks/role-details.vala"
	FOLKS_ABSTRACT_FIELD_DETAILS_CLASS (klass)->get_id = (const gchar* (*) (FolksAbstractFieldDetails*)) folks_role_field_details_real_get_id;
#line 164 "../folks/role-details.vala"
	FOLKS_ABSTRACT_FIELD_DETAILS_CLASS (klass)->set_id = (void (*) (FolksAbstractFieldDetails*, const gchar*)) folks_role_field_details_real_set_id;
#line 164 "../folks/role-details.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_role_field_details_get_property;
#line 164 "../folks/role-details.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folks_role_field_details_set_property;
#line 164 "../folks/role-details.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_role_field_details_constructor;
#line 164 "../folks/role-details.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_role_field_details_finalize;
#line 1171 "role-details.c"
	/**
	   * {@inheritDoc}
	   */
#line 164 "../folks/role-details.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_ROLE_FIELD_DETAILS_ID_PROPERTY, folks_role_field_details_properties[FOLKS_ROLE_FIELD_DETAILS_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1177 "role-details.c"
}

static void
folks_role_field_details_instance_init (FolksRoleFieldDetails * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
#line 164 "../folks/role-details.vala"
	self->priv = folks_role_field_details_get_instance_private (self);
#line 166 "../folks/role-details.vala"
	_tmp0_ = g_strdup ("");
#line 166 "../folks/role-details.vala"
	self->priv->_id = _tmp0_;
#line 1191 "role-details.c"
}

static void
folks_role_field_details_finalize (GObject * obj)
{
	FolksRoleFieldDetails * self;
#line 164 "../folks/role-details.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_ROLE_FIELD_DETAILS, FolksRoleFieldDetails);
#line 166 "../folks/role-details.vala"
	_g_free0 (self->priv->_id);
#line 164 "../folks/role-details.vala"
	G_OBJECT_CLASS (folks_role_field_details_parent_class)->finalize (obj);
#line 1204 "role-details.c"
}

/**
 * Object representing details of a contact in an organisation which can have
 * some parameters associated with it.
 *
 * See {@link Folks.AbstractFieldDetails}.
 *
 * @since 0.6.0
 */
static GType
folks_role_field_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksRoleFieldDetailsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_role_field_details_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksRoleFieldDetails), 0, (GInstanceInitFunc) folks_role_field_details_instance_init, NULL };
	GType folks_role_field_details_type_id;
	folks_role_field_details_type_id = g_type_register_static (FOLKS_TYPE_ABSTRACT_FIELD_DETAILS, "FolksRoleFieldDetails", &g_define_type_info, 0);
	FolksRoleFieldDetails_private_offset = g_type_add_instance_private (folks_role_field_details_type_id, sizeof (FolksRoleFieldDetailsPrivate));
	return folks_role_field_details_type_id;
}

GType
folks_role_field_details_get_type (void)
{
	static volatile gsize folks_role_field_details_type_id__once = 0;
	if (g_once_init_enter (&folks_role_field_details_type_id__once)) {
		GType folks_role_field_details_type_id;
		folks_role_field_details_type_id = folks_role_field_details_get_type_once ();
		g_once_init_leave (&folks_role_field_details_type_id__once, folks_role_field_details_type_id);
	}
	return folks_role_field_details_type_id__once;
}

static void
_vala_folks_role_field_details_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	FolksRoleFieldDetails * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_ROLE_FIELD_DETAILS, FolksRoleFieldDetails);
#line 164 "../folks/role-details.vala"
	switch (property_id) {
#line 164 "../folks/role-details.vala"
		case FOLKS_ROLE_FIELD_DETAILS_ID_PROPERTY:
#line 164 "../folks/role-details.vala"
		g_value_set_string (value, folks_abstract_field_details_get_id ((FolksAbstractFieldDetails*) self));
#line 164 "../folks/role-details.vala"
		break;
#line 1253 "role-details.c"
		default:
#line 164 "../folks/role-details.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 164 "../folks/role-details.vala"
		break;
#line 1259 "role-details.c"
	}
}

static void
_vala_folks_role_field_details_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	FolksRoleFieldDetails * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_ROLE_FIELD_DETAILS, FolksRoleFieldDetails);
#line 164 "../folks/role-details.vala"
	switch (property_id) {
#line 164 "../folks/role-details.vala"
		case FOLKS_ROLE_FIELD_DETAILS_ID_PROPERTY:
#line 164 "../folks/role-details.vala"
		folks_abstract_field_details_set_id ((FolksAbstractFieldDetails*) self, g_value_get_string (value));
#line 164 "../folks/role-details.vala"
		break;
#line 1279 "role-details.c"
		default:
#line 164 "../folks/role-details.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 164 "../folks/role-details.vala"
		break;
#line 1285 "role-details.c"
	}
}

static void
folks_role_details_real_change_roles_data_free (gpointer _data)
{
	FolksRoleDetailsChangeRolesData* _data_;
	_data_ = _data;
#line 254 "../folks/role-details.vala"
	_g_object_unref0 (_data_->roles);
#line 254 "../folks/role-details.vala"
	_g_object_unref0 (_data_->self);
#line 254 "../folks/role-details.vala"
	g_slice_free (FolksRoleDetailsChangeRolesData, _data_);
#line 1300 "role-details.c"
}

static void
folks_role_details_real_change_roles (FolksRoleDetails* self,
                                      GeeSet* roles,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	FolksRoleDetailsChangeRolesData* _data_;
	FolksRoleDetails* _tmp0_;
	GeeSet* _tmp1_;
#line 254 "../folks/role-details.vala"
	g_return_if_fail (roles != NULL);
#line 254 "../folks/role-details.vala"
	_data_ = g_slice_new0 (FolksRoleDetailsChangeRolesData);
#line 254 "../folks/role-details.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 254 "../folks/role-details.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_role_details_real_change_roles_data_free);
#line 254 "../folks/role-details.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 254 "../folks/role-details.vala"
	_data_->self = _tmp0_;
#line 254 "../folks/role-details.vala"
	_tmp1_ = _g_object_ref0 (roles);
#line 254 "../folks/role-details.vala"
	_g_object_unref0 (_data_->roles);
#line 254 "../folks/role-details.vala"
	_data_->roles = _tmp1_;
#line 254 "../folks/role-details.vala"
	folks_role_details_real_change_roles_co (_data_);
#line 1332 "role-details.c"
}

static void
folks_role_details_real_change_roles_finish (FolksRoleDetails* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	FolksRoleDetailsChangeRolesData* _data_;
#line 254 "../folks/role-details.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 254 "../folks/role-details.vala"
	if (NULL == _data_) {
#line 254 "../folks/role-details.vala"
		return;
#line 1347 "role-details.c"
	}
}

/**
   * Change the contact's roles.
   *
   * It's preferred to call this rather than setting {@link RoleDetails.roles}
   * directly, as this method gives error notification and will only return once
   * the roles have been written to the relevant backing store (or the
   * operation's failed).
   *
   * @param roles the set of roles
   * @throws PropertyError if setting the roles failed
   * @since 0.6.2
   */
static gboolean
folks_role_details_real_change_roles_co (FolksRoleDetailsChangeRolesData* _data_)
{
#line 275 "../folks/role-details.vala"
	switch (_data_->_state_) {
#line 275 "../folks/role-details.vala"
		case 0:
#line 1370 "role-details.c"
		goto _state_0;
		default:
#line 275 "../folks/role-details.vala"
		g_assert_not_reached ();
#line 1375 "role-details.c"
	}
	_state_0:
#line 279 "../folks/role-details.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Roles are not writeable on this contact."));
#line 279 "../folks/role-details.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 279 "../folks/role-details.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 279 "../folks/role-details.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 279 "../folks/role-details.vala"
		g_object_unref (_data_->_async_result);
#line 279 "../folks/role-details.vala"
		return FALSE;
#line 1390 "role-details.c"
	} else {
#line 279 "../folks/role-details.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 279 "../folks/role-details.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 279 "../folks/role-details.vala"
		g_object_unref (_data_->_async_result);
#line 279 "../folks/role-details.vala"
		return FALSE;
#line 1400 "role-details.c"
	}
#line 275 "../folks/role-details.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 275 "../folks/role-details.vala"
	if (_data_->_state_ != 0) {
#line 275 "../folks/role-details.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 275 "../folks/role-details.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1410 "role-details.c"
		}
	}
#line 275 "../folks/role-details.vala"
	g_object_unref (_data_->_async_result);
#line 275 "../folks/role-details.vala"
	return FALSE;
#line 1417 "role-details.c"
}

void
folks_role_details_change_roles (FolksRoleDetails* self,
                                 GeeSet* roles,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	FolksRoleDetailsIface* _iface_;
#line 254 "../folks/role-details.vala"
	_iface_ = FOLKS_ROLE_DETAILS_GET_INTERFACE (self);
#line 254 "../folks/role-details.vala"
	if (_iface_->change_roles) {
#line 254 "../folks/role-details.vala"
		_iface_->change_roles (self, roles, _callback_, _user_data_);
#line 1433 "role-details.c"
	}
}

void
folks_role_details_change_roles_finish (FolksRoleDetails* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	FolksRoleDetailsIface* _iface_;
#line 254 "../folks/role-details.vala"
	_iface_ = FOLKS_ROLE_DETAILS_GET_INTERFACE (self);
#line 254 "../folks/role-details.vala"
	if (_iface_->change_roles_finish) {
#line 254 "../folks/role-details.vala"
		_iface_->change_roles_finish (self, _res_, error);
#line 1449 "role-details.c"
	}
}

GeeSet*
folks_role_details_get_roles (FolksRoleDetails* self)
{
	FolksRoleDetailsIface* _iface_;
#line 261 "../folks/role-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 261 "../folks/role-details.vala"
	_iface_ = FOLKS_ROLE_DETAILS_GET_INTERFACE (self);
#line 261 "../folks/role-details.vala"
	if (_iface_->get_roles) {
#line 261 "../folks/role-details.vala"
		return _iface_->get_roles (self);
#line 1465 "role-details.c"
	}
#line 261 "../folks/role-details.vala"
	return NULL;
#line 1469 "role-details.c"
}

void
folks_role_details_set_roles (FolksRoleDetails* self,
                              GeeSet* value)
{
	FolksRoleDetailsIface* _iface_;
#line 261 "../folks/role-details.vala"
	g_return_if_fail (self != NULL);
#line 261 "../folks/role-details.vala"
	_iface_ = FOLKS_ROLE_DETAILS_GET_INTERFACE (self);
#line 261 "../folks/role-details.vala"
	if (_iface_->set_roles) {
#line 261 "../folks/role-details.vala"
		_iface_->set_roles (self, value);
#line 1485 "role-details.c"
	}
}

static void
folks_role_details_default_init (FolksRoleDetailsIface * iface,
                                 gpointer iface_data)
{
	/**
	   * The roles of the contact.
	   *
	   * @since 0.6.0
	   */
#line 254 "../folks/role-details.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("roles", "roles", "roles", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 254 "../folks/role-details.vala"
	iface->change_roles = folks_role_details_real_change_roles;
#line 254 "../folks/role-details.vala"
	iface->change_roles_finish = folks_role_details_real_change_roles_finish;
#line 1504 "role-details.c"
}

/**
 * This interfaces represents the list of roles a {@link Persona} and
 * {@link Individual} might have.
 *
 * @since 0.4.0
 */
static GType
folks_role_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksRoleDetailsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_role_details_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType folks_role_details_type_id;
	folks_role_details_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksRoleDetails", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (folks_role_details_type_id, G_TYPE_OBJECT);
	return folks_role_details_type_id;
}

GType
folks_role_details_get_type (void)
{
	static volatile gsize folks_role_details_type_id__once = 0;
	if (g_once_init_enter (&folks_role_details_type_id__once)) {
		GType folks_role_details_type_id;
		folks_role_details_type_id = folks_role_details_get_type_once ();
		g_once_init_leave (&folks_role_details_type_id__once, folks_role_details_type_id);
	}
	return folks_role_details_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

